/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.28 from the
 * contents of CryptX.xs. Do not edit this file, edit CryptX.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "CryptX.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#define NEED_sv_2pvbyte_GLOBAL
#define NEED_sv_2pv_flags_GLOBAL
#define NEED_newRV_noinc_GLOBAL
#include "ppport.h"

#undef LTC_SOURCE
#include "tomcrypt.h"
#include "tommath.h"

typedef adler32_state *Crypt__Checksum__Adler32;
typedef crc32_state   *Crypt__Checksum__CRC32;

typedef struct cipher_struct {          /* used by Crypt::Cipher */
  symmetric_key skey;
  int id;
  struct ltc_cipher_descriptor *desc;
} *Crypt__Cipher;

typedef struct digest_struct {          /* used by Crypt::Digest */
  hash_state state;
  int id;
  struct ltc_hash_descriptor *desc;
} *Crypt__Digest;

typedef struct ccm_struct {             /* used by Crypt::AuthEnc::CCM */
  int id;
} *Crypt__AuthEnc__CCM;

typedef struct eax_struct {             /* used by Crypt::AuthEnc::EAX */
  eax_state state;
  int id;
} *Crypt__AuthEnc__EAX;

typedef struct gcm_struct {             /* used by Crypt::AuthEnc::GCM */
  gcm_state state;
  int id;
} *Crypt__AuthEnc__GCM;

typedef struct ocb_struct {             /* used by Crypt::AuthEnc::OCB */
  ocb3_state state;
  int id;
} *Crypt__AuthEnc__OCB;

typedef struct f9_struct {              /* used by Crypt::Mac::F9 */
  f9_state state;
  int id;
} *Crypt__Mac__F9;

typedef struct hmac_struct {            /* used by Crypt::Mac::HMAC */
  hmac_state state;
  int id;
} *Crypt__Mac__HMAC;

typedef struct omac_struct {            /* used by Crypt::Mac::OMAC */
  omac_state state;
  int id;
} *Crypt__Mac__OMAC;

typedef struct pelican_struct {         /* used by Crypt::Mac::Pelican */
  pelican_state state;
  int id;
} *Crypt__Mac__Pelican;

typedef struct pmac_struct {            /* used by Crypt::Mac::PMAC */
  pmac_state state;
  int id;
} *Crypt__Mac__PMAC;

typedef struct xcbc_struct {            /* used by Crypt::Mac::XCBC */
  xcbc_state state;
  int id;
} *Crypt__Mac__XCBC;

typedef struct cbc_struct {             /* used by Crypt::Mode::CBC */
  int cipher_id, cipher_rounds;
  symmetric_CBC state;
  unsigned char pad[MAXBLOCKSIZE];
  int padlen;
  int padding_mode;
  int direction;
  int id;
} *Crypt__Mode__CBC;

typedef struct ecb_struct {             /* used by Crypt::Mode::ECB */
  int cipher_id, cipher_rounds;
  symmetric_ECB state;
  unsigned char pad[MAXBLOCKSIZE];
  int padlen;
  int padding_mode;
  int direction;
  int id;
} *Crypt__Mode__ECB;

typedef struct cfb_struct {             /* used by Crypt::Mode::CFB */
  int cipher_id, cipher_rounds;
  symmetric_CFB state;
  int direction;
  int id;
} *Crypt__Mode__CFB;

typedef struct ctr_struct {             /* used by Crypt::Mode::CTR */
  int cipher_id, cipher_rounds;
  int ctr_mode_param;
  symmetric_CTR state;
  int direction;
  int id;
} *Crypt__Mode__CTR;

typedef struct f8_struct {              /* used by Crypt::Mode::F8 */
  int cipher_id, cipher_rounds;
  symmetric_F8 state;
  int direction;
  int id;
} *Crypt__Mode__F8;

typedef struct lrw_struct {             /* used by Crypt::Mode::LRW */
  int cipher_id, cipher_rounds;
  symmetric_LRW state;
  int direction;
  int id;
} *Crypt__Mode__LRW;

typedef struct ofb_struct {             /* used by Crypt::Mode::OFB */
  int cipher_id, cipher_rounds;
  symmetric_OFB state;
  int direction;
  int id;
} *Crypt__Mode__OFB;

typedef struct xts_struct {             /* used by Crypt::Mode::XTS */
  int cipher_id, cipher_rounds;
  symmetric_xts state;
  int direction;
  int id;
} *Crypt__Mode__XTS;

typedef struct prng_struct {            /* used by Crypt::PRNG */
  prng_state state;
  struct ltc_prng_descriptor *desc;
  IV last_pid;
  int id;
} *Crypt__PRNG;

typedef struct rsa_struct {             /* used by Crypt::PK::RSA */
  prng_state yarrow_prng_state;
  int yarrow_prng_index;
  rsa_key key;
  int id;
} *Crypt__PK__RSA;

typedef struct dsa_struct {             /* used by Crypt::PK::DSA */
  prng_state yarrow_prng_state;
  int yarrow_prng_index;
  dsa_key key;
  int id;
} *Crypt__PK__DSA;

typedef struct dh_struct {              /* used by Crypt::PK::DH */
  prng_state yarrow_prng_state;
  int yarrow_prng_index;
  dh_key key;
  int id;
} *Crypt__PK__DH;

typedef struct ecc_struct {             /* used by Crypt::PK::ECC */
  prng_state yarrow_prng_state;
  int yarrow_prng_index;
  ecc_key key;
  ltc_ecc_set_type dp;
  int id;
} *Crypt__PK__ECC;

/* Math::BigInt::LTM related */
typedef mp_int * Math__BigInt__LTM;
STATIC SV * sv_from_mpi(mp_int *mpi) {
  SV *obj = newSV(0);
  sv_setref_pv(obj, "Math::BigInt::LTM", (void*)mpi);
  return obj;
}

ltc_ecc_set_type* _ecc_set_dp_from_SV(ltc_ecc_set_type *dp, SV *curve)
{
  HV *h;
  SV *param, **pref;
  SV **sv_cofactor, **sv_prime, **sv_A, **sv_B, **sv_order, **sv_Gx, **sv_Gy;
  int err;
  char *ch_name;
  STRLEN l_name;

  if (SvPOK(curve)) {
    ch_name = SvPV(curve, l_name);
    if ((h = get_hv("Crypt::PK::ECC::curve", 0)) == NULL) croak("FATAL: generate_key_ex: no curve register");
    if ((pref = hv_fetch(h, ch_name, l_name, 0)) == NULL)  croak("FATAL: generate_key_ex: unknown curve/1 '%s'", ch_name);
    if (!SvOK(*pref)) croak("FATAL: generate_key_ex: unknown curve/2 '%s'", ch_name);
    param = *pref;
  }
  else if (SvROK(curve)) {
    param = curve;
    ch_name = "custom";
  }
  else {
    croak("FATAL: curve has to be a string or a hashref");
  }

  if ((h = (HV*)(SvRV(param))) == NULL) croak("FATAL: ecparams: param is not valid hashref");

  if ((sv_prime    = hv_fetchs(h, "prime",    0)) == NULL) croak("FATAL: ecparams: missing param prime");
  if ((sv_A        = hv_fetchs(h, "A",        0)) == NULL) croak("FATAL: ecparams: missing param A");
  if ((sv_B        = hv_fetchs(h, "B",        0)) == NULL) croak("FATAL: ecparams: missing param B");
  if ((sv_order    = hv_fetchs(h, "order",    0)) == NULL) croak("FATAL: ecparams: missing param order");
  if ((sv_Gx       = hv_fetchs(h, "Gx",       0)) == NULL) croak("FATAL: ecparams: missing param Gx");
  if ((sv_Gy       = hv_fetchs(h, "Gy",       0)) == NULL) croak("FATAL: ecparams: missing param Gy");
  if ((sv_cofactor = hv_fetchs(h, "cofactor", 0)) == NULL) croak("FATAL: ecparams: missing param cofactor");

  if (!SvOK(*sv_prime   )) croak("FATAL: ecparams: undefined param prime");
  if (!SvOK(*sv_A       )) croak("FATAL: ecparams: undefined param A");
  if (!SvOK(*sv_B       )) croak("FATAL: ecparams: undefined param B");
  if (!SvOK(*sv_order   )) croak("FATAL: ecparams: undefined param order");
  if (!SvOK(*sv_Gx      )) croak("FATAL: ecparams: undefined param Gx");
  if (!SvOK(*sv_Gy      )) croak("FATAL: ecparams: undefined param Gy");
  if (!SvOK(*sv_cofactor)) croak("FATAL: ecparams: undefined param cofactor");

  err = ecc_dp_set( dp,
                    SvPV_nolen(*sv_prime),
                    SvPV_nolen(*sv_A),
                    SvPV_nolen(*sv_B),
                    SvPV_nolen(*sv_order),
                    SvPV_nolen(*sv_Gx),
                    SvPV_nolen(*sv_Gy),
                    (unsigned long)SvUV(*sv_cofactor),
                    ch_name );
  return err == CRYPT_OK ? dp : NULL;
}

void _ecc_free_key(ecc_key *key, ltc_ecc_set_type *dp)
{
  if(dp) {
    ecc_dp_clear(dp);
  }
  if (key->type != -1) {
    ecc_free(key);
    key->type = -1;
    key->dp = NULL;
  }
}

#line 261 "CryptX.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 405 "CryptX.c"

XS_EUPXS(XS_CryptX__encode_base64url); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_CryptX__encode_base64url)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "in");
    {
	SV *	RETVAL;
	SV *	in = ST(0)
;
#line 312 "CryptX.xs"
    {
        STRLEN in_len;
        unsigned long out_len;
        unsigned char *out_data, *in_data;
        int rv;

        if (!SvPOK(in)) XSRETURN_UNDEF;
        in_data = (unsigned char *) SvPVbyte(in, in_len);
        out_len = 4 * ((in_len + 2) / 3) + 1;
        Newz(0, out_data, out_len, unsigned char);
        if (!out_data) croak("FATAL: Newz failed [%ld]", out_len);
        rv = base64url_encode(in_data, (unsigned long)in_len, out_data, &out_len);
        RETVAL = (rv == CRYPT_OK) ? newSVpvn((char *)out_data, out_len) : newSVpvn(NULL, 0);
        Safefree(out_data);
    }
#line 433 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_CryptX__decode_base64url); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_CryptX__decode_base64url)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "in");
    {
	SV *	RETVAL;
	SV *	in = ST(0)
;
#line 333 "CryptX.xs"
    {
        STRLEN in_len;
        unsigned long out_len;
        unsigned char *out_data, *in_data;
        int rv;

        if (!SvPOK(in)) XSRETURN_UNDEF;
        in_data = (unsigned char *) SvPVbyte(in, in_len);
        out_len = in_len;
        Newz(0, out_data, out_len, unsigned char);
        if (!out_data) croak("FATAL: Newz failed [%ld]", out_len);
        rv = base64url_decode(in_data, (unsigned long)in_len, out_data, &out_len);
        RETVAL = (rv == CRYPT_OK) ? newSVpvn((char *)out_data, out_len) : newSVpvn(NULL, 0);
        Safefree(out_data);
    }
#line 467 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_CryptX__encode_base64); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_CryptX__encode_base64)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "in");
    {
	SV *	RETVAL;
	SV *	in = ST(0)
;
#line 354 "CryptX.xs"
    {
        STRLEN in_len;
        unsigned long out_len;
        unsigned char *out_data, *in_data;
        int rv;

        if (!SvPOK(in)) XSRETURN_UNDEF;
        in_data = (unsigned char *) SvPVbyte(in, in_len);
        out_len = 4 * ((in_len + 2) / 3) + 1;
        Newz(0, out_data, out_len, unsigned char);
        if (!out_data) croak("FATAL: Newz failed [%ld]", out_len);
        rv = base64_encode(in_data, (unsigned long)in_len, out_data, &out_len);
        RETVAL = (rv == CRYPT_OK) ? newSVpvn((char *)out_data, out_len) : newSVpvn(NULL, 0);
        Safefree(out_data);
    }
#line 501 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_CryptX__decode_base64); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_CryptX__decode_base64)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "in");
    {
	SV *	RETVAL;
	SV *	in = ST(0)
;
#line 375 "CryptX.xs"
    {
        STRLEN in_len;
        unsigned long out_len;
        unsigned char *out_data, *in_data;
        int rv;

        if (!SvPOK(in)) XSRETURN_UNDEF;
        in_data = (unsigned char *) SvPVbyte(in, in_len);
        out_len = in_len;
        Newz(0, out_data, out_len, unsigned char);
        if (!out_data) croak("FATAL: Newz failed [%ld]", out_len);
        rv = base64_decode(in_data, (unsigned long)in_len, out_data, &out_len);
        RETVAL = (rv == CRYPT_OK) ? newSVpvn((char *)out_data, out_len) : newSVpvn(NULL, 0);
        Safefree(out_data);
    }
#line 535 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


/* INCLUDE:  Including 'inc/CryptX_Digest.xs.inc' from 'CryptX.xs' */


/* INCLUDE:  Including 'inc/CryptX_Cipher.xs.inc' from 'inc/CryptX_Digest.xs.inc' */


XS_EUPXS(XS_Crypt__Cipher__new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Cipher__new)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "cipher_name, key, rounds=0");
    {
	char *        cipher_name = (SvOK(ST(0))) ? SvPV_nolen(ST(0)) : NULL
;
	SV *	key = ST(1)
;
	int	rounds;
	Crypt__Cipher	RETVAL;

	if (items < 3)
	    rounds = 0;
	else {
	    rounds = (int)SvIV(ST(2))
;
	}
#line 9 "./inc/CryptX_Cipher.xs.inc"
    {
        STRLEN key_len;
        unsigned char *key_data=NULL;
        int rv;
        int id;

        if (!SvPOK (key)) croak("FATAL: key must be string scalar");
        key_data = (unsigned char *)SvPVbyte(key, key_len);

        id = find_cipher(cipher_name);
        if(id==-1) croak("FATAL: find_cipfer failed for '%s'", cipher_name);

        Newz(0, RETVAL, 1, struct cipher_struct);
        if (!RETVAL) croak("FATAL: Newz failed");

        RETVAL->id = id;
        RETVAL->desc = &cipher_descriptor[id];
        rv = RETVAL->desc->setup(key_data, (int)key_len, rounds, &RETVAL->skey);
        if(rv!=CRYPT_OK) croak("FATAL: cipher setup failed: %s", error_to_string(rv));
    }
#line 590 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::Cipher", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Cipher_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Cipher_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__Cipher	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Cipher,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Crypt::Cipher::DESTROY",
			"self")
;
#line 36 "./inc/CryptX_Cipher.xs.inc"
        Safefree(self);
#line 622 "CryptX.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Cipher__max_keysize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Cipher__max_keysize)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	Crypt__Cipher	self;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Cipher")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Cipher,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Cipher::_max_keysize",
			"self", "Crypt::Cipher")
;
#line 42 "./inc/CryptX_Cipher.xs.inc"
        RETVAL = self->desc->max_key_length;
#line 650 "CryptX.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Cipher__min_keysize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Cipher__min_keysize)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	Crypt__Cipher	self;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Cipher")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Cipher,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Cipher::_min_keysize",
			"self", "Crypt::Cipher")
;
#line 50 "./inc/CryptX_Cipher.xs.inc"
        RETVAL = self->desc->min_key_length;
#line 679 "CryptX.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Cipher__blocksize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Cipher__blocksize)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	Crypt__Cipher	self;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Cipher")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Cipher,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Cipher::_blocksize",
			"self", "Crypt::Cipher")
;
#line 58 "./inc/CryptX_Cipher.xs.inc"
        RETVAL = self->desc->block_length;
#line 708 "CryptX.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Cipher__default_rounds); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Cipher__default_rounds)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	Crypt__Cipher	self;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Cipher")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Cipher,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Cipher::_default_rounds",
			"self", "Crypt::Cipher")
;
#line 66 "./inc/CryptX_Cipher.xs.inc"
        RETVAL = self->desc->default_rounds;
#line 737 "CryptX.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Cipher_encrypt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Cipher_encrypt)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, data");
    {
	Crypt__Cipher	self;
	SV *	data = ST(1)
;
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Cipher")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Cipher,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Cipher::encrypt",
			"self", "Crypt::Cipher")
;
#line 75 "./inc/CryptX_Cipher.xs.inc"
    {
        int rv;
        STRLEN len;
        void *plaintext = SvPVbyte(data, len);

        if (len==0)
          RETVAL = newSVpvn("", 0);
        else if (len % self->desc->block_length)
          croak ("FATAL: sizeof(data) should be multiple of blocksize (%d)", self->desc->block_length);
        else {
          /* idea from Crypt::Rijndael */
          RETVAL = NEWSV(0, len);
          SvPOK_only(RETVAL);
          SvCUR_set(RETVAL, len);
          rv = self->desc->ecb_encrypt((unsigned char *)plaintext, (unsigned char *)SvPV_nolen(RETVAL), &self->skey);
          if (rv!=CRYPT_OK) croak("FATAL: encrypt failed: %s", error_to_string(rv));
        }
    }
#line 784 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Cipher_decrypt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Cipher_decrypt)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, data");
    {
	Crypt__Cipher	self;
	SV *	data = ST(1)
;
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Cipher")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Cipher,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Cipher::decrypt",
			"self", "Crypt::Cipher")
;
#line 101 "./inc/CryptX_Cipher.xs.inc"
    {
        int rv;
        STRLEN len;
        void *ciphertext = SvPVbyte(data, len);

        if (len==0)
          RETVAL = newSVpvn("", 0);
        else if (len % self->desc->block_length)
          croak ("FATAL: sizeof(data) should be multiple of blocksize (%d)", self->desc->block_length);
        else {
          /* idea from Crypt::Rijndael */
          RETVAL = NEWSV(0, len);
          SvPOK_only(RETVAL);
          SvCUR_set(RETVAL, len);
          rv = self->desc->ecb_decrypt((unsigned char *)ciphertext, (unsigned char *)SvPV_nolen(RETVAL), &self->skey);
          if (rv!=CRYPT_OK) croak("FATAL: decrypt failed: %s", error_to_string(rv));
        }
    }
#line 832 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Cipher__block_length_by_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Cipher__block_length_by_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cipher_name");
    {
	char *        cipher_name = (SvOK(ST(0))) ? SvPV_nolen(ST(0)) : NULL
;
	int	RETVAL;
	dXSTARG;
#line 126 "./inc/CryptX_Cipher.xs.inc"
    {
        int rv, id;

        id = find_cipher(cipher_name);
        if(id==-1) croak("FATAL: find_cipfer failed for '%s'", cipher_name);

        rv = cipher_descriptor[id].block_length;
        if (!rv) XSRETURN_UNDEF;
        RETVAL = rv;
    }
#line 862 "CryptX.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Cipher__min_key_length_by_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Cipher__min_key_length_by_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cipher_name");
    {
	char *        cipher_name = (SvOK(ST(0))) ? SvPV_nolen(ST(0)) : NULL
;
	int	RETVAL;
	dXSTARG;
#line 143 "./inc/CryptX_Cipher.xs.inc"
    {
        int rv, id;

        id = find_cipher(cipher_name);
        if(id==-1) croak("FATAL: find_cipfer failed for '%s'", cipher_name);

        rv = cipher_descriptor[id].min_key_length;
        if (!rv) XSRETURN_UNDEF;
        RETVAL = rv;
    }
#line 891 "CryptX.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Cipher__max_key_length_by_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Cipher__max_key_length_by_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cipher_name");
    {
	char *        cipher_name = (SvOK(ST(0))) ? SvPV_nolen(ST(0)) : NULL
;
	int	RETVAL;
	dXSTARG;
#line 160 "./inc/CryptX_Cipher.xs.inc"
    {
        int rv, id;

        id = find_cipher(cipher_name);
        if(id==-1) croak("FATAL: find_cipfer failed for '%s'", cipher_name);

        rv = cipher_descriptor[id].max_key_length;
        if (!rv) XSRETURN_UNDEF;
        RETVAL = rv;
    }
#line 920 "CryptX.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Cipher__default_rounds_by_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Cipher__default_rounds_by_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cipher_name");
    {
	char *        cipher_name = (SvOK(ST(0))) ? SvPV_nolen(ST(0)) : NULL
;
	int	RETVAL;
	dXSTARG;
#line 177 "./inc/CryptX_Cipher.xs.inc"
    {
        int rv, id;

        id = find_cipher(cipher_name);
        if(id==-1) croak("FATAL: find_cipfer failed for '%s'", cipher_name);

        rv = cipher_descriptor[id].default_rounds;
        if (!rv) XSRETURN_UNDEF;
        RETVAL = rv;
    }
#line 949 "CryptX.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


/* INCLUDE: Returning to 'inc/CryptX_Digest.xs.inc' from 'inc/CryptX_Cipher.xs.inc' */


XS_EUPXS(XS_Crypt__Digest__new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Digest__new)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "digest_name");
    {
	char *        digest_name = (SvOK(ST(0))) ? SvPV_nolen(ST(0)) : NULL
;
	Crypt__Digest	RETVAL;
#line 7 "./inc/CryptX_Digest.xs.inc"
    {
        int rv;
        int id;

        id = find_hash(digest_name);
        if(id==-1) croak("FATAL: find_hash failed for '%s'", digest_name);

        Newz(0, RETVAL, 1, struct digest_struct);
        if (!RETVAL) croak("FATAL: Newz failed");

        RETVAL->id = id;
        RETVAL->desc = &hash_descriptor[id];
        rv = RETVAL->desc->init(&RETVAL->state);
        if(rv!=CRYPT_OK) croak("FATAL: digest setup failed: %s", error_to_string(rv));
    }
#line 985 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::Digest", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Digest_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Digest_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__Digest	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Digest,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Crypt::Digest::DESTROY",
			"self")
;
#line 29 "./inc/CryptX_Digest.xs.inc"
        Safefree(self);
#line 1017 "CryptX.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Digest_reset); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Digest_reset)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__Digest	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Digest")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Digest,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Digest::reset",
			"self", "Crypt::Digest")
;
#line 35 "./inc/CryptX_Digest.xs.inc"
    {
        int rv;
        rv = self->desc->init(&self->state);
        if (rv != CRYPT_OK) croak("FATAL: digest init failed: %s", error_to_string(rv));
    }
#line 1047 "CryptX.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Digest_clone); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Digest_clone)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__Digest	self;
	Crypt__Digest	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Digest")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Digest,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Digest::clone",
			"self", "Crypt::Digest")
;
#line 45 "./inc/CryptX_Digest.xs.inc"
        Newz(0, RETVAL, 1, struct digest_struct);
        Copy(&self->state, &RETVAL->state, 1, struct digest_struct);
#line 1075 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::Digest", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Digest_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Digest_add)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Crypt__Digest	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Digest")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Digest,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Digest::add",
			"self", "Crypt::Digest")
;
#line 53 "./inc/CryptX_Digest.xs.inc"
    {
        STRLEN inlen;
        int rv, i;
        unsigned char *in;

        for(i=1; i<items; i++) {
          in = (unsigned char *)SvPVbyte(ST(i), inlen);
          if (inlen>0) {
            rv = self->desc->process(&self->state, in, (unsigned long)inlen);
            if (rv != CRYPT_OK) croak("FATAL: digest process failed: %s", error_to_string(rv));
          }
        }
        XPUSHs(ST(0)); /* return self */
    }
#line 1122 "CryptX.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Crypt__Digest_digest); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Digest_digest)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__Digest	self;
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Digest")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Digest,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Digest::digest",
			"self", "Crypt::Digest")
;
#line 72 "./inc/CryptX_Digest.xs.inc"
    {
        unsigned char hash[MAXBLOCKSIZE];
        int rv;

        rv = self->desc->done(&self->state, hash);
        if (rv != CRYPT_OK) croak("FATAL: digest done failed: %s", error_to_string(rv));
        RETVAL = newSVpvn((char *) hash, self->desc->hashsize);
    }
#line 1157 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Digest_hexdigest); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Digest_hexdigest)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__Digest	self;
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Digest")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Digest,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Digest::hexdigest",
			"self", "Crypt::Digest")
;
#line 87 "./inc/CryptX_Digest.xs.inc"
    {
        int rv;
        unsigned long i;
        unsigned char hash[MAXBLOCKSIZE];
        char hash_hex[MAXBLOCKSIZE*2 + 1];

        rv = self->desc->done(&self->state, hash);
        if (rv != CRYPT_OK) croak("FATAL: digest done failed: %s", error_to_string(rv));

        hash_hex[0] = '\0';
        for(i=0; i<self->desc->hashsize; i++)
            sprintf(&hash_hex[2*i], "%02x", hash[i]);
        RETVAL = newSVpvn(hash_hex, strlen(hash_hex));
    }
#line 1199 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Digest_b64digest); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Digest_b64digest)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__Digest	self;
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Digest")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Digest,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Digest::b64digest",
			"self", "Crypt::Digest")
;
#line 108 "./inc/CryptX_Digest.xs.inc"
    {
        int rv;
        unsigned long outlen;
        unsigned char hash[MAXBLOCKSIZE];
        char hash_base64[MAXBLOCKSIZE*2 + 1];

        rv = self->desc->done(&self->state, hash);
        if (rv != CRYPT_OK) croak("FATAL: digest done failed: %s", error_to_string(rv));

        outlen = sizeof(hash_base64);
        rv = base64_encode(hash, self->desc->hashsize, (unsigned char *)hash_base64, &outlen);
        if (rv != CRYPT_OK) croak("FATAL: base64_encode failed: %s", error_to_string(rv));
        RETVAL = newSVpvn(hash_base64, outlen);
    }
#line 1241 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Digest_b64udigest); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Digest_b64udigest)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__Digest	self;
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Digest")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Digest,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Digest::b64udigest",
			"self", "Crypt::Digest")
;
#line 129 "./inc/CryptX_Digest.xs.inc"
    {
        int rv;
        unsigned long outlen;
        unsigned char hash[MAXBLOCKSIZE];
        char hash_base64[MAXBLOCKSIZE*2 + 1];

        rv = self->desc->done(&self->state, hash);
        if (rv != CRYPT_OK) croak("FATAL: digest done failed: %s", error_to_string(rv));

        outlen = sizeof(hash_base64);
        rv = base64url_encode(hash, self->desc->hashsize, (unsigned char *)hash_base64, &outlen);
        if (rv != CRYPT_OK) croak("FATAL: base64url_encode failed: %s", error_to_string(rv));
        RETVAL = newSVpvn(hash_base64, outlen);
    }
#line 1283 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Digest__hashsize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Digest__hashsize)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__Digest	self;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Digest")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Digest,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Digest::_hashsize",
			"self", "Crypt::Digest")
;
#line 150 "./inc/CryptX_Digest.xs.inc"
        RETVAL = self->desc->hashsize;
#line 1313 "CryptX.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Digest__hashsize_by_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Digest__hashsize_by_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "digest_name");
    {
	char *        digest_name = (SvOK(ST(0))) ? SvPV_nolen(ST(0)) : NULL
;
	int	RETVAL;
	dXSTARG;
#line 158 "./inc/CryptX_Digest.xs.inc"
    {
        int rv, id;

        id = find_hash(digest_name);
        if(id==-1) croak("FATAL: find_digest failed for '%s'", digest_name);

        rv = hash_descriptor[id].hashsize;
        if (!rv) croak("FATAL: invalid hashsize for '%s'", digest_name);;
        RETVAL = rv;
    }
#line 1342 "CryptX.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


/* INCLUDE: Returning to 'CryptX.xs' from 'inc/CryptX_Digest.xs.inc' */


/* INCLUDE:  Including 'inc/CryptX_Checksum_Adler32.xs.inc' from 'CryptX.xs' */


/* INCLUDE:  Including 'inc/CryptX_Checksum_CRC32.xs.inc' from 'inc/CryptX_Checksum_Adler32.xs.inc' */


XS_EUPXS(XS_Crypt__Checksum__CRC32_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Checksum__CRC32_new)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "class");
    {
	Crypt__Checksum__CRC32	RETVAL;
	SV *	class = ST(0)
;
#line 6 "./inc/CryptX_Checksum_CRC32.xs.inc"
        Newz(0, RETVAL, 1, crc32_state);
        if (!RETVAL) croak("FATAL: Newz failed");
        crc32_init(RETVAL);
#line 1372 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::Checksum::CRC32", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Checksum__CRC32_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Checksum__CRC32_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__Checksum__CRC32	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Checksum__CRC32,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Crypt::Checksum::CRC32::DESTROY",
			"self")
;
#line 15 "./inc/CryptX_Checksum_CRC32.xs.inc"
        Safefree(self);
#line 1404 "CryptX.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Checksum__CRC32_reset); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Checksum__CRC32_reset)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__Checksum__CRC32	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Checksum::CRC32")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Checksum__CRC32,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Checksum::CRC32::reset",
			"self", "Crypt::Checksum::CRC32")
;
#line 20 "./inc/CryptX_Checksum_CRC32.xs.inc"
        crc32_init(self);
#line 1430 "CryptX.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Checksum__CRC32_clone); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Checksum__CRC32_clone)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__Checksum__CRC32	RETVAL;
	Crypt__Checksum__CRC32	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Checksum::CRC32")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Checksum__CRC32,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Checksum::CRC32::clone",
			"self", "Crypt::Checksum::CRC32")
;
#line 25 "./inc/CryptX_Checksum_CRC32.xs.inc"
        Newz(0, RETVAL, 1, crc32_state);
        if (!RETVAL) croak("FATAL: Newz failed");
        Copy(self, RETVAL, 1, crc32_state);
#line 1459 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::Checksum::CRC32", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Checksum__CRC32_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Checksum__CRC32_add)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Crypt__Checksum__CRC32	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Checksum::CRC32")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Checksum__CRC32,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Checksum::CRC32::add",
			"self", "Crypt::Checksum::CRC32")
;
#line 34 "./inc/CryptX_Checksum_CRC32.xs.inc"
    {
        STRLEN inlen;
        int i;
        unsigned char *in;
        for(i=1; i<items; i++) {
          in = (unsigned char *)SvPVbyte(ST(i), inlen);
          if (inlen>0) crc32_update(self, in, (unsigned long)inlen);
        }
        XPUSHs(ST(0)); /* return self */
    }
#line 1502 "CryptX.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Crypt__Checksum__CRC32_digest); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Checksum__CRC32_digest)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	RETVAL;
	Crypt__Checksum__CRC32	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Checksum::CRC32")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Checksum__CRC32,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Checksum::CRC32::digest",
			"self", "Crypt::Checksum::CRC32")
;
#line 48 "./inc/CryptX_Checksum_CRC32.xs.inc"
    {
        unsigned char hash[4];
        crc32_finish(self, hash, 4);
        RETVAL = newSVpvn((char *) hash, 4);
    }
#line 1534 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Checksum__CRC32_hexdigest); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Checksum__CRC32_hexdigest)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	RETVAL;
	Crypt__Checksum__CRC32	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Checksum::CRC32")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Checksum__CRC32,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Checksum::CRC32::hexdigest",
			"self", "Crypt::Checksum::CRC32")
;
#line 59 "./inc/CryptX_Checksum_CRC32.xs.inc"
    {
        unsigned long i;
        unsigned char hash[4];
        char hash_hex[4*2 + 1];
        crc32_finish(self, hash, 4);
        hash_hex[0] = '\0';
        for(i=0; i<4; i++) sprintf(&hash_hex[2*i], "%02x", hash[i]);
        RETVAL = newSVpvn(hash_hex, strlen(hash_hex));
    }
#line 1571 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


/* INCLUDE: Returning to 'inc/CryptX_Checksum_Adler32.xs.inc' from 'inc/CryptX_Checksum_CRC32.xs.inc' */


XS_EUPXS(XS_Crypt__Checksum__Adler32_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Checksum__Adler32_new)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "class");
    {
	Crypt__Checksum__Adler32	RETVAL;
	SV *	class = ST(0)
;
#line 6 "./inc/CryptX_Checksum_Adler32.xs.inc"
        Newz(0, RETVAL, 1, adler32_state);
        if (!RETVAL) croak("FATAL: Newz failed");
        adler32_init(RETVAL);
#line 1596 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::Checksum::Adler32", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Checksum__Adler32_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Checksum__Adler32_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__Checksum__Adler32	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Checksum__Adler32,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Crypt::Checksum::Adler32::DESTROY",
			"self")
;
#line 15 "./inc/CryptX_Checksum_Adler32.xs.inc"
        Safefree(self);
#line 1628 "CryptX.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Checksum__Adler32_reset); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Checksum__Adler32_reset)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__Checksum__Adler32	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Checksum::Adler32")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Checksum__Adler32,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Checksum::Adler32::reset",
			"self", "Crypt::Checksum::Adler32")
;
#line 20 "./inc/CryptX_Checksum_Adler32.xs.inc"
        adler32_init(self);
#line 1654 "CryptX.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Checksum__Adler32_clone); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Checksum__Adler32_clone)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__Checksum__Adler32	RETVAL;
	Crypt__Checksum__Adler32	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Checksum::Adler32")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Checksum__Adler32,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Checksum::Adler32::clone",
			"self", "Crypt::Checksum::Adler32")
;
#line 25 "./inc/CryptX_Checksum_Adler32.xs.inc"
        Newz(0, RETVAL, 1, adler32_state);
        if (!RETVAL) croak("FATAL: Newz failed");
        Copy(self, RETVAL, 1, adler32_state);
#line 1683 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::Checksum::Adler32", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Checksum__Adler32_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Checksum__Adler32_add)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Crypt__Checksum__Adler32	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Checksum::Adler32")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Checksum__Adler32,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Checksum::Adler32::add",
			"self", "Crypt::Checksum::Adler32")
;
#line 34 "./inc/CryptX_Checksum_Adler32.xs.inc"
    {
        STRLEN inlen;
        int i;
        unsigned char *in;
        for(i=1; i<items; i++) {
          in = (unsigned char *)SvPVbyte(ST(i), inlen);
          if (inlen>0) adler32_update(self, in, (unsigned long)inlen);
        }
        XPUSHs(ST(0)); /* return self */
    }
#line 1726 "CryptX.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Crypt__Checksum__Adler32_digest); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Checksum__Adler32_digest)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	RETVAL;
	Crypt__Checksum__Adler32	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Checksum::Adler32")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Checksum__Adler32,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Checksum::Adler32::digest",
			"self", "Crypt::Checksum::Adler32")
;
#line 48 "./inc/CryptX_Checksum_Adler32.xs.inc"
    {
        unsigned char hash[4];
        adler32_finish(self, hash, 4);
        RETVAL = newSVpvn((char *) hash, 4);
    }
#line 1758 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Checksum__Adler32_hexdigest); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Checksum__Adler32_hexdigest)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	RETVAL;
	Crypt__Checksum__Adler32	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Checksum::Adler32")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Checksum__Adler32,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Checksum::Adler32::hexdigest",
			"self", "Crypt::Checksum::Adler32")
;
#line 59 "./inc/CryptX_Checksum_Adler32.xs.inc"
    {
        unsigned long i;
        unsigned char hash[4];
        char hash_hex[4*2 + 1];
        adler32_finish(self, hash, 4);
        hash_hex[0] = '\0';
        for(i=0; i<4; i++) sprintf(&hash_hex[2*i], "%02x", hash[i]);
        RETVAL = newSVpvn(hash_hex, strlen(hash_hex));
    }
#line 1795 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


/* INCLUDE: Returning to 'CryptX.xs' from 'inc/CryptX_Checksum_Adler32.xs.inc' */


/* INCLUDE:  Including 'inc/CryptX_AuthEnc_EAX.xs.inc' from 'CryptX.xs' */


/* INCLUDE:  Including 'inc/CryptX_AuthEnc_GCM.xs.inc' from 'inc/CryptX_AuthEnc_EAX.xs.inc' */


/* INCLUDE:  Including 'inc/CryptX_AuthEnc_OCB.xs.inc' from 'inc/CryptX_AuthEnc_GCM.xs.inc' */


/* INCLUDE:  Including 'inc/CryptX_AuthEnc_CCM.xs.inc' from 'inc/CryptX_AuthEnc_OCB.xs.inc' */


XS_EUPXS(XS_Crypt__AuthEnc__CCM__memory_encrypt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__AuthEnc__CCM__memory_encrypt)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "cipher_name, key, nonce, header, tag_len, plaintext");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char *        cipher_name = (SvOK(ST(0))) ? SvPV_nolen(ST(0)) : NULL
;
	SV *	key = ST(1)
;
	SV *	nonce = ST(2)
;
	SV *	header = ST(3)
;
	unsigned long	tag_len = (unsigned long)SvUV(ST(4))
;
	SV *	plaintext = ST(5)
;
#line 6 "./inc/CryptX_AuthEnc_CCM.xs.inc"
    {
        STRLEN k_len, n_len, h_len, pt_len;
        unsigned char *k, *n, *h, *pt;
        int rv, id;
        unsigned char tag[MAXBLOCKSIZE];
        SV *ct;

        if (!SvPOK(key))       croak("FATAL: key must be string/buffer scalar");
        if (!SvPOK(nonce))     croak("FATAL: nonce must be string/buffer scalar");
        if (!SvPOK(header))    croak("FATAL: header must be string/buffer scalar");
        if (!SvPOK(plaintext)) croak("FATAL: plaintext must be string/buffer scalar");
        k  = (unsigned char *) SvPVbyte(key, k_len);
        n  = (unsigned char *) SvPVbyte(nonce, n_len);
        h  = (unsigned char *) SvPVbyte(header, h_len);
        pt = (unsigned char *) SvPVbyte(plaintext, pt_len);

        id = find_cipher(cipher_name);
        if(id==-1) croak("FATAL: find_cipfer failed for '%s'", cipher_name);

        ct = NEWSV(0, pt_len);
        SvPOK_only(ct);
        SvCUR_set(ct, pt_len);

        if(tag_len<4 || tag_len>16) tag_len = 16;

        rv = ccm_memory(id, k, (unsigned long)k_len, NULL, n, (unsigned long)n_len, h, (unsigned long)h_len,
                        pt, (unsigned long)pt_len, (unsigned char *)SvPV_nolen(ct), tag, &tag_len, CCM_ENCRYPT);
        if (rv != CRYPT_OK) croak("FATAL: ccm_memory failed: %s", error_to_string(rv));

        XPUSHs(sv_2mortal(ct));
        XPUSHs(sv_2mortal(newSVpvn((char*)tag,tag_len)));

        /* int ccm_memory( int cipher,
                           const unsigned char *key,       unsigned long keylen,
                           symmetric_key *uskey,
                           const unsigned char *nonce,     unsigned long noncelen,
                           const unsigned char *header,    unsigned long headerlen,
                           unsigned char *pt,              unsigned long ptlen,
                           unsigned char *ct,
                           unsigned char *tag,             unsigned long *taglen,
                           int direction); */

    }
#line 1883 "CryptX.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Crypt__AuthEnc__CCM__memory_decrypt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__AuthEnc__CCM__memory_decrypt)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "cipher_name, key, nonce, header, ciphertext, tag");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char *        cipher_name = (SvOK(ST(0))) ? SvPV_nolen(ST(0)) : NULL
;
	SV *	key = ST(1)
;
	SV *	nonce = ST(2)
;
	SV *	header = ST(3)
;
	SV *	ciphertext = ST(4)
;
	SV *	tag = ST(5)
;
#line 53 "./inc/CryptX_AuthEnc_CCM.xs.inc"
    {
        STRLEN k_len, n_len, h_len, ct_len, t_len;
        unsigned char *k, *n, *h, *ct, *t;
        int rv, id;
        unsigned char xtag[MAXBLOCKSIZE];
        unsigned long xtag_len;
        SV *pt;

        if (!SvPOK(key))        croak("FATAL: key must be string/buffer scalar");
        if (!SvPOK(nonce))      croak("FATAL: nonce must be string/buffer scalar");
        if (!SvPOK(header))     croak("FATAL: header must be string/buffer scalar");
        if (!SvPOK(ciphertext)) croak("FATAL: ciphertext must be string/buffer scalar");
        if (!SvPOK(tag))        croak("FATAL: tag must be string/buffer scalar");
        k  = (unsigned char *) SvPVbyte(key, k_len);
        n  = (unsigned char *) SvPVbyte(nonce, n_len);
        h  = (unsigned char *) SvPVbyte(header, h_len);
        ct = (unsigned char *) SvPVbyte(ciphertext, ct_len);
        t  = (unsigned char *) SvPVbyte(tag, t_len);

        id = find_cipher(cipher_name);
        if(id==-1) croak("FATAL: find_cipfer failed for '%s'", cipher_name);

        pt = NEWSV(0, ct_len);
        SvPOK_only(pt);
        SvCUR_set(pt, ct_len);

        xtag_len = (unsigned long)t_len;
        Copy(t, xtag, t_len, unsigned char);

        rv = ccm_memory(id, k, (unsigned long)k_len, NULL, n, (unsigned long)n_len, h, (unsigned long)h_len,
                        (unsigned char *)SvPV_nolen(pt), (unsigned long)ct_len, ct, xtag, &xtag_len, CCM_DECRYPT);
        if (rv != CRYPT_OK) {
          XPUSHs(sv_2mortal(newSVpvn(NULL,0))); /* undef */
        }
        else {
          XPUSHs(sv_2mortal(pt));
        }
    }
#line 1950 "CryptX.c"
	PUTBACK;
	return;
    }
}


/* INCLUDE: Returning to 'inc/CryptX_AuthEnc_OCB.xs.inc' from 'inc/CryptX_AuthEnc_CCM.xs.inc' */


XS_EUPXS(XS_Crypt__AuthEnc__OCB__new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__AuthEnc__OCB__new)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "cipher_name, key, nonce");
    {
	Crypt__AuthEnc__OCB	RETVAL;
	char *        cipher_name = (SvOK(ST(0))) ? SvPV_nolen(ST(0)) : NULL
;
	SV *	key = ST(1)
;
	SV *	nonce = ST(2)
;
#line 6 "./inc/CryptX_AuthEnc_OCB.xs.inc"
    {
        STRLEN k_len=0;
        unsigned char *k=NULL;
        unsigned char *n=NULL;
        STRLEN n_len=0;
        int id;

        if (!SvPOK(key))   croak("FATAL: key must be string/buffer scalar");
        k = (unsigned char *) SvPVbyte(key, k_len);
        if (!SvPOK(nonce)) croak("FATAL: nonce must be string/buffer scalar");
        n = (unsigned char *) SvPVbyte(nonce, n_len);

        id = find_cipher(cipher_name);
        if(id==-1) croak("FATAL: find_cipfer failed for '%s'", cipher_name);

        Newz(0, RETVAL, 1, struct ocb_struct);
        if (!RETVAL) croak("FATAL: Newz failed");

        if (ocb3_init(&RETVAL->state, id, k, (unsigned long)k_len, n, (unsigned long)n_len) != CRYPT_OK) {
          croak("FATAL: ocb setup failed");
        }
    }
#line 1997 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::AuthEnc::OCB", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__AuthEnc__OCB_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__AuthEnc__OCB_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__AuthEnc__OCB	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__AuthEnc__OCB,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Crypt::AuthEnc::OCB::DESTROY",
			"self")
;
#line 34 "./inc/CryptX_AuthEnc_OCB.xs.inc"
        Safefree(self);
#line 2029 "CryptX.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__AuthEnc__OCB_clone); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__AuthEnc__OCB_clone)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__AuthEnc__OCB	RETVAL;
	Crypt__AuthEnc__OCB	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::AuthEnc::OCB")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__AuthEnc__OCB,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::AuthEnc::OCB::clone",
			"self", "Crypt::AuthEnc::OCB")
;
#line 39 "./inc/CryptX_AuthEnc_OCB.xs.inc"
        Newz(0, RETVAL, 1, struct ocb_struct);
        if (!RETVAL) croak("FATAL: Newz failed");
        Copy(&self->state, &RETVAL->state, 1, struct ocb_struct);
#line 2058 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::AuthEnc::OCB", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__AuthEnc__OCB_adata_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__AuthEnc__OCB_adata_add)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, data");
    {
	Crypt__AuthEnc__OCB	self;
	SV *	data = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::AuthEnc::OCB")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__AuthEnc__OCB,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::AuthEnc::OCB::adata_add",
			"self", "Crypt::AuthEnc::OCB")
;
#line 48 "./inc/CryptX_AuthEnc_OCB.xs.inc"
    {
        int rv;
        STRLEN in_data_len;
        unsigned char *in_data;

        in_data = (unsigned char *)SvPVbyte(data, in_data_len);

        if (in_data_len>0) {
          rv = ocb3_add_aad(&self->state, in_data, (unsigned long)in_data_len);
          if (rv != CRYPT_OK) croak("FATAL: ocb3_add_aad failed: %s", error_to_string(rv));
        }
    }
#line 2103 "CryptX.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__AuthEnc__OCB_encrypt_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__AuthEnc__OCB_encrypt_add)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, data");
    {
	SV *	RETVAL;
	Crypt__AuthEnc__OCB	self;
	SV *	data = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::AuthEnc::OCB")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__AuthEnc__OCB,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::AuthEnc::OCB::encrypt_add",
			"self", "Crypt::AuthEnc::OCB")
;
#line 64 "./inc/CryptX_AuthEnc_OCB.xs.inc"
    {
        int rv;
        STRLEN in_data_len;
        unsigned char *in_data, *out_data;

        in_data = (unsigned char *)SvPVbyte(data, in_data_len);
        if (in_data_len==0) {
          RETVAL = newSVpvn("", 0);
        }
        else {
          RETVAL = NEWSV(0, in_data_len);
          SvPOK_only(RETVAL);
          SvCUR_set(RETVAL, in_data_len);
          out_data = (unsigned char *)SvPV_nolen(RETVAL);

          if (in_data_len % (&self->state)->block_len)
            croak ("FATAL: sizeof(data) should be multiple of blocksize (%d)", (&self->state)->block_len);

          rv = ocb3_encrypt(&self->state, in_data, (unsigned long)in_data_len, out_data);
          if (rv != CRYPT_OK) croak("FATAL: ocb3_encrypt failed: %s", error_to_string(rv));
        }
    }
#line 2153 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__AuthEnc__OCB_encrypt_last); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__AuthEnc__OCB_encrypt_last)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, data");
    {
	SV *	RETVAL;
	Crypt__AuthEnc__OCB	self;
	SV *	data = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::AuthEnc::OCB")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__AuthEnc__OCB,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::AuthEnc::OCB::encrypt_last",
			"self", "Crypt::AuthEnc::OCB")
;
#line 92 "./inc/CryptX_AuthEnc_OCB.xs.inc"
    {
        int rv;
        STRLEN in_data_len;
        unsigned char *in_data, *out_data;

        in_data = (unsigned char *)SvPVbyte(data, in_data_len);
        if (in_data_len>0) {
          RETVAL = NEWSV(0, in_data_len);
          SvPOK_only(RETVAL);
          SvCUR_set(RETVAL, in_data_len);
          out_data = (unsigned char *)SvPV_nolen(RETVAL);
        }
        else {
          RETVAL = newSVpvn("", 0);
          out_data = NULL;
        }
        rv = ocb3_encrypt_last(&self->state, in_data, (unsigned long)in_data_len, out_data);
        if (rv != CRYPT_OK) croak("FATAL: ocb3_encrypt_last failed: %s", error_to_string(rv));
    }
#line 2202 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__AuthEnc__OCB_decrypt_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__AuthEnc__OCB_decrypt_add)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, data");
    {
	SV *	RETVAL;
	Crypt__AuthEnc__OCB	self;
	SV *	data = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::AuthEnc::OCB")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__AuthEnc__OCB,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::AuthEnc::OCB::decrypt_add",
			"self", "Crypt::AuthEnc::OCB")
;
#line 117 "./inc/CryptX_AuthEnc_OCB.xs.inc"
    {
        int rv;
        STRLEN in_data_len;
        unsigned char *in_data, *out_data;

        in_data = (unsigned char *)SvPVbyte(data, in_data_len);
        if (in_data_len==0) {
          RETVAL = newSVpvn("", 0);
        }
        else {
          RETVAL = NEWSV(0, in_data_len);
          SvPOK_only(RETVAL);
          SvCUR_set(RETVAL, in_data_len);
          out_data = (unsigned char *)SvPV_nolen(RETVAL);

          if (in_data_len % (&self->state)->block_len)
            croak ("FATAL: sizeof(data) should be multiple of blocksize (%d)", (&self->state)->block_len);

          rv = ocb3_decrypt(&self->state, in_data, (unsigned long)in_data_len, out_data);
          if (rv != CRYPT_OK) croak("FATAL: ocb3_decrypt failed: %s", error_to_string(rv));
        }
    }
#line 2254 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__AuthEnc__OCB_decrypt_last); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__AuthEnc__OCB_decrypt_last)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, data");
    {
	SV *	RETVAL;
	Crypt__AuthEnc__OCB	self;
	SV *	data = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::AuthEnc::OCB")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__AuthEnc__OCB,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::AuthEnc::OCB::decrypt_last",
			"self", "Crypt::AuthEnc::OCB")
;
#line 145 "./inc/CryptX_AuthEnc_OCB.xs.inc"
    {
        int rv;
        STRLEN in_data_len;
        unsigned char *in_data, *out_data;

        in_data = (unsigned char *)SvPVbyte(data, in_data_len);
        if (in_data_len>0) {
          RETVAL = NEWSV(0, in_data_len);
          SvPOK_only(RETVAL);
          SvCUR_set(RETVAL, in_data_len);
          out_data = (unsigned char *)SvPV_nolen(RETVAL);
        }
        else {
          RETVAL = newSVpvn("", 0);
          out_data = NULL;
        }
        rv = ocb3_decrypt_last(&self->state, in_data, (unsigned long)in_data_len, out_data);
        if (rv != CRYPT_OK) croak("FATAL: ocb3_encrypt_last failed: %s", error_to_string(rv));
    }
#line 2303 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__AuthEnc__OCB_encrypt_done); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__AuthEnc__OCB_encrypt_done)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Crypt__AuthEnc__OCB	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::AuthEnc::OCB")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__AuthEnc__OCB,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::AuthEnc::OCB::encrypt_done",
			"self", "Crypt::AuthEnc::OCB")
;
#line 170 "./inc/CryptX_AuthEnc_OCB.xs.inc"
    {
        int rv;
        unsigned char tag[MAXBLOCKSIZE];
        unsigned long tag_len = sizeof(tag);

        rv = ocb3_done(&self->state, tag, &tag_len);
        if (rv != CRYPT_OK) croak("FATAL: ocb3_done_encrypt failed: %s", error_to_string(rv));

        XPUSHs(sv_2mortal(newSVpvn((char*)tag, tag_len)));
    }
#line 2342 "CryptX.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Crypt__AuthEnc__OCB_decrypt_done); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__AuthEnc__OCB_decrypt_done)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Crypt__AuthEnc__OCB	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::AuthEnc::OCB")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__AuthEnc__OCB,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::AuthEnc::OCB::decrypt_done",
			"self", "Crypt::AuthEnc::OCB")
;
#line 184 "./inc/CryptX_AuthEnc_OCB.xs.inc"
    {
        int rv;
        unsigned char tag[MAXBLOCKSIZE];
        unsigned long tag_len = sizeof(tag);
        STRLEN expected_tag_len;
        unsigned char *expected_tag;

        rv = ocb3_done(&self->state, tag, &tag_len);
        if (rv != CRYPT_OK) croak("FATAL: ocb3_done_decrypt failed: %s", error_to_string(rv));
        if (items == 1) {
          XPUSHs(sv_2mortal(newSVpvn((char*)tag, tag_len)));
        }
        else {
          if(!SvPOK(ST(1))) croak("FATAL: expected_tag must be string/buffer scalar");
          expected_tag = (unsigned char *) SvPVbyte(ST(1), expected_tag_len);
          if (expected_tag_len!=tag_len) {
            XPUSHs(sv_2mortal(newSViv(0))); /* false */
          }
          else if (memNE(expected_tag, tag, tag_len)) {
            XPUSHs(sv_2mortal(newSViv(0))); /* false */
          }
          else {
            XPUSHs(sv_2mortal(newSViv(1))); /* true */
          }
        }
    }
#line 2396 "CryptX.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Crypt__AuthEnc__OCB_blocksize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__AuthEnc__OCB_blocksize)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	int	RETVAL;
	dXSTARG;
	Crypt__AuthEnc__OCB	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::AuthEnc::OCB")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__AuthEnc__OCB,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::AuthEnc::OCB::blocksize",
			"self", "Crypt::AuthEnc::OCB")
;
#line 214 "./inc/CryptX_AuthEnc_OCB.xs.inc"
    {
        RETVAL = (&self->state)->block_len;
    }
#line 2427 "CryptX.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


/* INCLUDE: Returning to 'inc/CryptX_AuthEnc_GCM.xs.inc' from 'inc/CryptX_AuthEnc_OCB.xs.inc' */


XS_EUPXS(XS_Crypt__AuthEnc__GCM__new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__AuthEnc__GCM__new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "cipher_name, key");
    {
	Crypt__AuthEnc__GCM	RETVAL;
	char *        cipher_name = (SvOK(ST(0))) ? SvPV_nolen(ST(0)) : NULL
;
	SV *	key = ST(1)
;
#line 6 "./inc/CryptX_AuthEnc_GCM.xs.inc"
    {
        STRLEN k_len=0;
        unsigned char *k=NULL;
        int id;

        if (!SvPOK(key))   croak("FATAL: key must be string/buffer scalar");
        k = (unsigned char *) SvPVbyte(key, k_len);


        id = find_cipher(cipher_name);
        if(id==-1) croak("FATAL: find_cipfer failed for '%s'", cipher_name);

        Newz(0, RETVAL, 1, struct gcm_struct);
        if (!RETVAL) croak("FATAL: Newz failed");

        if (gcm_init(&RETVAL->state, id, k, (unsigned long)k_len) != CRYPT_OK) {
          croak("FATAL: gcm setup failed");
        }
    }
#line 2469 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::AuthEnc::GCM", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__AuthEnc__GCM_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__AuthEnc__GCM_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__AuthEnc__GCM	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__AuthEnc__GCM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Crypt::AuthEnc::GCM::DESTROY",
			"self")
;
#line 31 "./inc/CryptX_AuthEnc_GCM.xs.inc"
        Safefree(self);
#line 2501 "CryptX.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__AuthEnc__GCM_clone); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__AuthEnc__GCM_clone)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__AuthEnc__GCM	RETVAL;
	Crypt__AuthEnc__GCM	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::AuthEnc::GCM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__AuthEnc__GCM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::AuthEnc::GCM::clone",
			"self", "Crypt::AuthEnc::GCM")
;
#line 36 "./inc/CryptX_AuthEnc_GCM.xs.inc"
        Newz(0, RETVAL, 1, struct gcm_struct);
        if (!RETVAL) croak("FATAL: Newz failed");
        Copy(&self->state, &RETVAL->state, 1, struct gcm_struct);
#line 2530 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::AuthEnc::GCM", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__AuthEnc__GCM_reset); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__AuthEnc__GCM_reset)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	int	RETVAL;
	dXSTARG;
	Crypt__AuthEnc__GCM	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::AuthEnc::GCM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__AuthEnc__GCM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::AuthEnc::GCM::reset",
			"self", "Crypt::AuthEnc::GCM")
;
#line 45 "./inc/CryptX_AuthEnc_GCM.xs.inc"
    {
        int rv;
        rv = gcm_reset(&self->state);
        if (rv != CRYPT_OK) croak("FATAL: gcm_reset failed: %s", error_to_string(rv));
        RETVAL = rv;
    }
#line 2569 "CryptX.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__AuthEnc__GCM_encrypt_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__AuthEnc__GCM_encrypt_add)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, data");
    {
	SV *	RETVAL;
	Crypt__AuthEnc__GCM	self;
	SV *	data = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::AuthEnc::GCM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__AuthEnc__GCM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::AuthEnc::GCM::encrypt_add",
			"self", "Crypt::AuthEnc::GCM")
;
#line 57 "./inc/CryptX_AuthEnc_GCM.xs.inc"
    {
        int rv;
        STRLEN in_data_len;
        unsigned char *in_data, *out_data;

        in_data = (unsigned char *)SvPVbyte(data, in_data_len);
        if (in_data_len==0) {
          RETVAL = newSVpvn("", 0);
        }
        else
        {
          RETVAL = NEWSV(0, in_data_len);
          SvPOK_only(RETVAL);
          SvCUR_set(RETVAL, in_data_len);
          out_data = (unsigned char *)SvPV_nolen(RETVAL);
          rv = gcm_process(&self->state, in_data, (unsigned long)in_data_len, out_data, GCM_ENCRYPT);
          if (rv != CRYPT_OK) croak("FATAL: encrypt_add/gcm_process failed: %s", error_to_string(rv));
        }
    }
#line 2617 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__AuthEnc__GCM_iv_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__AuthEnc__GCM_iv_add)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, data");
    {
	int	RETVAL;
	dXSTARG;
	Crypt__AuthEnc__GCM	self;
	SV *	data = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::AuthEnc::GCM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__AuthEnc__GCM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::AuthEnc::GCM::iv_add",
			"self", "Crypt::AuthEnc::GCM")
;
#line 82 "./inc/CryptX_AuthEnc_GCM.xs.inc"
    {
        int rv;
        STRLEN in_data_len;
        unsigned char *in_data;

        in_data = (unsigned char *)SvPVbyte(data, in_data_len);
        rv = gcm_add_iv(&self->state, in_data, (unsigned long)in_data_len);
        if (rv != CRYPT_OK) croak("FATAL: gcm_add_iv failed: %s", error_to_string(rv));
        RETVAL = rv;
    }
#line 2658 "CryptX.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__AuthEnc__GCM_adata_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__AuthEnc__GCM_adata_add)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, data");
    {
	int	RETVAL;
	dXSTARG;
	Crypt__AuthEnc__GCM	self;
	SV *	data = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::AuthEnc::GCM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__AuthEnc__GCM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::AuthEnc::GCM::adata_add",
			"self", "Crypt::AuthEnc::GCM")
;
#line 98 "./inc/CryptX_AuthEnc_GCM.xs.inc"
    {
        int rv;
        STRLEN in_data_len;
        unsigned char *in_data;

        in_data = (unsigned char *)SvPVbyte(data, in_data_len);
        rv = gcm_add_aad(&self->state, in_data, (unsigned long)in_data_len);
        if (rv != CRYPT_OK) croak("FATAL: gcm_add_aad failed: %s", error_to_string(rv));
        RETVAL = rv;
    }
#line 2698 "CryptX.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__AuthEnc__GCM_decrypt_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__AuthEnc__GCM_decrypt_add)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, data");
    {
	SV *	RETVAL;
	Crypt__AuthEnc__GCM	self;
	SV *	data = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::AuthEnc::GCM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__AuthEnc__GCM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::AuthEnc::GCM::decrypt_add",
			"self", "Crypt::AuthEnc::GCM")
;
#line 114 "./inc/CryptX_AuthEnc_GCM.xs.inc"
    {
        int rv;
        STRLEN in_data_len;
        unsigned char *in_data, *out_data;

        in_data = (unsigned char *)SvPVbyte(data, in_data_len);
        if (in_data_len==0) {
          RETVAL = newSVpvn("", 0);
        }
        else {
          RETVAL = NEWSV(0, in_data_len);
          SvPOK_only(RETVAL);
          SvCUR_set(RETVAL, in_data_len);
          out_data = (unsigned char *)SvPV_nolen(RETVAL);
          rv = gcm_process(&self->state, out_data, (unsigned long)in_data_len, in_data, GCM_DECRYPT);
          if (rv != CRYPT_OK) croak("FATAL: encrypt_add/gcm_process failed: %s", error_to_string(rv));
        }
    }
#line 2745 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__AuthEnc__GCM_encrypt_done); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__AuthEnc__GCM_encrypt_done)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Crypt__AuthEnc__GCM	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::AuthEnc::GCM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__AuthEnc__GCM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::AuthEnc::GCM::encrypt_done",
			"self", "Crypt::AuthEnc::GCM")
;
#line 139 "./inc/CryptX_AuthEnc_GCM.xs.inc"
    {
        int rv;
        unsigned char tag[MAXBLOCKSIZE];
        unsigned long tag_len = sizeof(tag);

        rv = gcm_done(&self->state, tag, &tag_len);
        if (rv != CRYPT_OK) croak("FATAL: gcm_done failed: %s", error_to_string(rv));
        XPUSHs(sv_2mortal(newSVpvn((char*)tag, tag_len)));
    }
#line 2783 "CryptX.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Crypt__AuthEnc__GCM_decrypt_done); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__AuthEnc__GCM_decrypt_done)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Crypt__AuthEnc__GCM	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::AuthEnc::GCM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__AuthEnc__GCM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::AuthEnc::GCM::decrypt_done",
			"self", "Crypt::AuthEnc::GCM")
;
#line 152 "./inc/CryptX_AuthEnc_GCM.xs.inc"
    {
        int rv;
        unsigned char tag[MAXBLOCKSIZE];
        unsigned long tag_len = sizeof(tag);
        STRLEN expected_tag_len;
        unsigned char *expected_tag;

        rv = gcm_done(&self->state, tag, &tag_len);
        if (rv != CRYPT_OK) croak("FATAL: gcm_done failed: %s", error_to_string(rv));
        if (items == 1) {
          XPUSHs(sv_2mortal(newSVpvn((char*)tag, tag_len)));
        }
        else {
          if(!SvPOK(ST(1))) croak("FATAL: expected_tag must be string/buffer scalar");
          expected_tag = (unsigned char *) SvPVbyte(ST(1), expected_tag_len);
          if (expected_tag_len!=tag_len) {
            XPUSHs(sv_2mortal(newSViv(0))); /* false */
          }
          else if (memNE(expected_tag, tag, tag_len)) {
            XPUSHs(sv_2mortal(newSViv(0))); /* false */
          }
          else {
            XPUSHs(sv_2mortal(newSViv(1))); /* true */
          }
        }
    }
#line 2837 "CryptX.c"
	PUTBACK;
	return;
    }
}


/* INCLUDE: Returning to 'inc/CryptX_AuthEnc_EAX.xs.inc' from 'inc/CryptX_AuthEnc_GCM.xs.inc' */


XS_EUPXS(XS_Crypt__AuthEnc__EAX__new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__AuthEnc__EAX__new)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "cipher_name, key, nonce, header=&PL_sv_undef");
    {
	Crypt__AuthEnc__EAX	RETVAL;
	char *        cipher_name = (SvOK(ST(0))) ? SvPV_nolen(ST(0)) : NULL
;
	SV *	key = ST(1)
;
	SV *	nonce = ST(2)
;
	SV *	header;

	if (items < 4)
	    header = &PL_sv_undef;
	else {
	    header = ST(3)
;
	}
#line 6 "./inc/CryptX_AuthEnc_EAX.xs.inc"
    {
        STRLEN k_len=0;
        unsigned char *k=NULL;
        unsigned char *n=NULL;
        STRLEN n_len=0;
        unsigned char *h=NULL;
        STRLEN h_len=0;
        int id;

        if (!SvPOK(key))   croak("FATAL: key must be string/buffer scalar");
        k = (unsigned char *) SvPVbyte(key, k_len);
        if (!SvPOK(nonce)) croak("FATAL: nonce must be string/buffer scalar");
        n = (unsigned char *) SvPVbyte(nonce, n_len);
        if(SvOK(header)) { /* header is optional param */
          if(!SvPOK(header)) croak("FATAL: header must be string/buffer scalar");
          h = (unsigned char *) SvPVbyte(header, h_len);
        }

        id = find_cipher(cipher_name);
        if(id==-1) croak("FATAL: find_cipfer failed for '%s'", cipher_name);

        Newz(0, RETVAL, 1, struct eax_struct);
        if (!RETVAL) croak("FATAL: Newz failed");

        if (eax_init(&RETVAL->state, id, k, (unsigned long)k_len, n, (unsigned long)n_len, h, (unsigned long)h_len) != CRYPT_OK) {
          croak("FATAL: eax setup failed");
        }
    }
#line 2898 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::AuthEnc::EAX", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__AuthEnc__EAX_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__AuthEnc__EAX_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__AuthEnc__EAX	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__AuthEnc__EAX,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Crypt::AuthEnc::EAX::DESTROY",
			"self")
;
#line 40 "./inc/CryptX_AuthEnc_EAX.xs.inc"
        Safefree(self);
#line 2930 "CryptX.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__AuthEnc__EAX_clone); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__AuthEnc__EAX_clone)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__AuthEnc__EAX	RETVAL;
	Crypt__AuthEnc__EAX	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::AuthEnc::EAX")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__AuthEnc__EAX,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::AuthEnc::EAX::clone",
			"self", "Crypt::AuthEnc::EAX")
;
#line 45 "./inc/CryptX_AuthEnc_EAX.xs.inc"
        Newz(0, RETVAL, 1, struct eax_struct);
        if (!RETVAL) croak("FATAL: Newz failed");
        Copy(&self->state, &RETVAL->state, 1, struct eax_struct);
#line 2959 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::AuthEnc::EAX", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__AuthEnc__EAX_encrypt_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__AuthEnc__EAX_encrypt_add)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, data");
    {
	SV *	RETVAL;
	Crypt__AuthEnc__EAX	self;
	SV *	data = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::AuthEnc::EAX")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__AuthEnc__EAX,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::AuthEnc::EAX::encrypt_add",
			"self", "Crypt::AuthEnc::EAX")
;
#line 54 "./inc/CryptX_AuthEnc_EAX.xs.inc"
    {
        int rv;
        STRLEN in_data_len;
        unsigned char *in_data, *out_data;

        in_data = (unsigned char *)SvPVbyte(data, in_data_len);
        if (in_data_len==0) {
          RETVAL = newSVpvn("", 0);
        }
        else {
          RETVAL = NEWSV(0, in_data_len);
          SvPOK_only(RETVAL);
          SvCUR_set(RETVAL, in_data_len);
          out_data = (unsigned char *)SvPV_nolen(RETVAL);
          rv = eax_encrypt(&self->state, in_data, out_data, (unsigned long)in_data_len);
          if (rv != CRYPT_OK) croak("FATAL: eax_encrypt failed: %s", error_to_string(rv));
        }
    }
#line 3011 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__AuthEnc__EAX_decrypt_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__AuthEnc__EAX_decrypt_add)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, data");
    {
	SV *	RETVAL;
	Crypt__AuthEnc__EAX	self;
	SV *	data = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::AuthEnc::EAX")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__AuthEnc__EAX,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::AuthEnc::EAX::decrypt_add",
			"self", "Crypt::AuthEnc::EAX")
;
#line 78 "./inc/CryptX_AuthEnc_EAX.xs.inc"
    {
        int rv;
        STRLEN in_data_len;
        unsigned char *in_data, *out_data;

        in_data = (unsigned char *)SvPVbyte(data, in_data_len);
        if (in_data_len==0) {
          RETVAL = newSVpvn("", 0);
        }
        else {
          RETVAL = NEWSV(0, in_data_len);
          SvPOK_only(RETVAL);
          SvCUR_set(RETVAL, in_data_len);
          out_data = (unsigned char *)SvPV_nolen(RETVAL);
          rv = eax_decrypt(&self->state, in_data, out_data, (unsigned long)in_data_len);
          if (rv != CRYPT_OK) croak("FATAL: eax_decrypt failed: %s", error_to_string(rv));
        }
    }
#line 3059 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__AuthEnc__EAX_encrypt_done); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__AuthEnc__EAX_encrypt_done)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Crypt__AuthEnc__EAX	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::AuthEnc::EAX")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__AuthEnc__EAX,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::AuthEnc::EAX::encrypt_done",
			"self", "Crypt::AuthEnc::EAX")
;
#line 102 "./inc/CryptX_AuthEnc_EAX.xs.inc"
    {
        int rv;
        unsigned char tag[MAXBLOCKSIZE];
        unsigned long tag_len = sizeof(tag);

        rv = eax_done(&self->state, tag, &tag_len);
        if (rv != CRYPT_OK) croak("FATAL: eax_done failed: %s", error_to_string(rv));
        XPUSHs(sv_2mortal(newSVpvn((char*)tag, tag_len)));
    }
#line 3097 "CryptX.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Crypt__AuthEnc__EAX_decrypt_done); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__AuthEnc__EAX_decrypt_done)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Crypt__AuthEnc__EAX	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::AuthEnc::EAX")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__AuthEnc__EAX,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::AuthEnc::EAX::decrypt_done",
			"self", "Crypt::AuthEnc::EAX")
;
#line 115 "./inc/CryptX_AuthEnc_EAX.xs.inc"
    {
        int rv;
        unsigned char tag[MAXBLOCKSIZE];
        unsigned long tag_len = sizeof(tag);
        STRLEN expected_tag_len;
        unsigned char *expected_tag;

        rv = eax_done(&self->state, tag, &tag_len);
        if (rv != CRYPT_OK) croak("FATAL: eax_done failed: %s", error_to_string(rv));
        if (items == 1) {
          XPUSHs(sv_2mortal(newSVpvn((char*)tag, tag_len)));
        }
        else {
          if(!SvPOK(ST(1))) croak("FATAL: expected_tag must be string/buffer scalar");
          expected_tag = (unsigned char *) SvPVbyte(ST(1), expected_tag_len);
          if (expected_tag_len!=tag_len) {
            XPUSHs(sv_2mortal(newSViv(0))); /* false */
          }
          else if (memNE(expected_tag, tag, tag_len)) {
            XPUSHs(sv_2mortal(newSViv(0))); /* false */
          }
          else {
            XPUSHs(sv_2mortal(newSViv(1))); /* true */
          }
        }
    }
#line 3151 "CryptX.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Crypt__AuthEnc__EAX_header_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__AuthEnc__EAX_header_add)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, header");
    {
	int	RETVAL;
	dXSTARG;
	Crypt__AuthEnc__EAX	self;
	SV *	header = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::AuthEnc::EAX")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__AuthEnc__EAX,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::AuthEnc::EAX::header_add",
			"self", "Crypt::AuthEnc::EAX")
;
#line 145 "./inc/CryptX_AuthEnc_EAX.xs.inc"
    {
        STRLEN h_len;
        unsigned char *h;
        h = (unsigned char *)SvPVbyte(header, h_len);
        RETVAL = eax_addheader(&self->state, h, (unsigned long)h_len);
    }
#line 3187 "CryptX.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


/* INCLUDE: Returning to 'CryptX.xs' from 'inc/CryptX_AuthEnc_EAX.xs.inc' */


/* INCLUDE:  Including 'inc/CryptX_Mac_F9.xs.inc' from 'CryptX.xs' */


/* INCLUDE:  Including 'inc/CryptX_Mac_HMAC.xs.inc' from 'inc/CryptX_Mac_F9.xs.inc' */


/* INCLUDE:  Including 'inc/CryptX_Mac_OMAC.xs.inc' from 'inc/CryptX_Mac_HMAC.xs.inc' */


/* INCLUDE:  Including 'inc/CryptX_Mac_Pelican.xs.inc' from 'inc/CryptX_Mac_OMAC.xs.inc' */


/* INCLUDE:  Including 'inc/CryptX_Mac_PMAC.xs.inc' from 'inc/CryptX_Mac_Pelican.xs.inc' */


/* INCLUDE:  Including 'inc/CryptX_Mac_XCBC.xs.inc' from 'inc/CryptX_Mac_PMAC.xs.inc' */


XS_EUPXS(XS_Crypt__Mac__XCBC__new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__XCBC__new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "cipher_name, key");
    {
	Crypt__Mac__XCBC	RETVAL;
	char *        cipher_name = (SvOK(ST(0))) ? SvPV_nolen(ST(0)) : NULL
;
	SV *	key = ST(1)
;
#line 8 "./inc/CryptX_Mac_XCBC.xs.inc"
    {
        STRLEN k_len=0;
        unsigned char *k=NULL;
        int rv;
        int id;

        id = find_cipher(cipher_name);
        if(id==-1) croak("FATAL: find_cipfer failed for '%s'", cipher_name);

        if (!SvPOK(key)) croak("FATAL: key must be string/buffer scalar");
        k = (unsigned char *) SvPVbyte(key, k_len);

        Newz(0, RETVAL, 1, struct xcbc_struct);
        if (!RETVAL) croak("FATAL: Newz failed");

        rv = xcbc_init(&RETVAL->state, id, k, (unsigned long)k_len);
        if (rv != CRYPT_OK) croak("FATAL: xcbc_init failed: %s", error_to_string(rv));
    }
#line 3246 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::Mac::XCBC", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mac__XCBC_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__XCBC_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__Mac__XCBC	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mac__XCBC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Crypt::Mac::XCBC::DESTROY",
			"self")
;
#line 32 "./inc/CryptX_Mac_XCBC.xs.inc"
        Safefree(self);
#line 3278 "CryptX.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Mac__XCBC_clone); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__XCBC_clone)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__Mac__XCBC	RETVAL;
	Crypt__Mac__XCBC	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mac::XCBC")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mac__XCBC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mac::XCBC::clone",
			"self", "Crypt::Mac::XCBC")
;
#line 37 "./inc/CryptX_Mac_XCBC.xs.inc"
        Newz(0, RETVAL, 1, struct xcbc_struct);
        if (!RETVAL) croak("FATAL: Newz failed");
        Copy(&self->state, &RETVAL->state, 1, struct xcbc_struct);
#line 3307 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::Mac::XCBC", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mac__XCBC__add_single); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__XCBC__add_single)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, data");
    {
	Crypt__Mac__XCBC	self;
	SV *	data = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mac::XCBC")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mac__XCBC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mac::XCBC::_add_single",
			"self", "Crypt::Mac::XCBC")
;
#line 46 "./inc/CryptX_Mac_XCBC.xs.inc"
    {
        int rv;
        STRLEN in_data_len;
        unsigned char *in_data;

        in_data = (unsigned char *)SvPVbyte(data, in_data_len);
        if (in_data_len>0) {
          rv = xcbc_process(&self->state, in_data, (unsigned long)in_data_len);
          if (rv != CRYPT_OK) croak("FATAL: xcbc_process failed: %s", error_to_string(rv));
        }
    }
#line 3351 "CryptX.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Mac__XCBC_mac); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__XCBC_mac)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	RETVAL;
	Crypt__Mac__XCBC	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mac::XCBC")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mac__XCBC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mac::XCBC::mac",
			"self", "Crypt::Mac::XCBC")
;
#line 61 "./inc/CryptX_Mac_XCBC.xs.inc"
    {
        char mac[MAXBLOCKSIZE];
        unsigned long mac_len;
        int rv;

        mac_len = sizeof(mac);
        rv = xcbc_done(&self->state, (unsigned char*)mac, &mac_len);
        if (rv != CRYPT_OK) croak("FATAL: xcbc_done failed: %s", error_to_string(rv));
        RETVAL = newSVpvn(mac, mac_len);
    }
#line 3387 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mac__XCBC_b64mac); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__XCBC_b64mac)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	RETVAL;
	Crypt__Mac__XCBC	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mac::XCBC")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mac__XCBC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mac::XCBC::b64mac",
			"self", "Crypt::Mac::XCBC")
;
#line 77 "./inc/CryptX_Mac_XCBC.xs.inc"
    {
        unsigned char mac[MAXBLOCKSIZE];
        unsigned long mac_len;
        int rv;
        unsigned long outlen;
        char mac_base64[MAXBLOCKSIZE*2 + 1];

        mac_len = sizeof(mac);
        rv = xcbc_done(&self->state, mac, &mac_len);
        if (rv != CRYPT_OK) croak("FATAL: xcbc_done failed: %s", error_to_string(rv));
        outlen = sizeof(mac_base64);
        rv = base64_encode(mac, mac_len, (unsigned char*)mac_base64, &outlen);
        if (rv != CRYPT_OK) croak("FATAL: base64_encode failed: %s", error_to_string(rv));
        RETVAL = newSVpvn(mac_base64, outlen);
    }
#line 3430 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mac__XCBC_b64umac); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__XCBC_b64umac)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	RETVAL;
	Crypt__Mac__XCBC	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mac::XCBC")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mac__XCBC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mac::XCBC::b64umac",
			"self", "Crypt::Mac::XCBC")
;
#line 98 "./inc/CryptX_Mac_XCBC.xs.inc"
    {
        unsigned char mac[MAXBLOCKSIZE];
        unsigned long mac_len;
        int rv;
        unsigned long outlen;
        char mac_base64[MAXBLOCKSIZE*2 + 1];

        mac_len = sizeof(mac);
        rv = xcbc_done(&self->state, mac, &mac_len);
        if (rv != CRYPT_OK) croak("FATAL: xcbc_done failed: %s", error_to_string(rv));
        outlen = sizeof(mac_base64);
        rv = base64url_encode(mac, mac_len, (unsigned char*)mac_base64, &outlen);
        if (rv != CRYPT_OK) croak("FATAL: base64url_encode failed: %s", error_to_string(rv));
        RETVAL = newSVpvn(mac_base64, outlen);
    }
#line 3473 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mac__XCBC_hexmac); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__XCBC_hexmac)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	RETVAL;
	Crypt__Mac__XCBC	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mac::XCBC")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mac__XCBC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mac::XCBC::hexmac",
			"self", "Crypt::Mac::XCBC")
;
#line 119 "./inc/CryptX_Mac_XCBC.xs.inc"
    {
        unsigned char mac[MAXBLOCKSIZE];
        unsigned long mac_len, i;
        int rv;
        char mac_hex[MAXBLOCKSIZE*2 + 1];

        mac_len = sizeof(mac);
        rv = xcbc_done(&self->state, mac, &mac_len);
        if (rv != CRYPT_OK) croak("FATAL: xcbc_done failed: %s", error_to_string(rv));
        mac_hex[0] = '\0';
        for(i=0; i<mac_len; i++)
            sprintf(&mac_hex[2*i], "%02x", mac[i]);
        RETVAL = newSVpvn(mac_hex, strlen(mac_hex));
    }
#line 3515 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


/* INCLUDE: Returning to 'inc/CryptX_Mac_PMAC.xs.inc' from 'inc/CryptX_Mac_XCBC.xs.inc' */


XS_EUPXS(XS_Crypt__Mac__PMAC__new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__PMAC__new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "cipher_name, key");
    {
	Crypt__Mac__PMAC	RETVAL;
	char *        cipher_name = (SvOK(ST(0))) ? SvPV_nolen(ST(0)) : NULL
;
	SV *	key = ST(1)
;
#line 8 "./inc/CryptX_Mac_PMAC.xs.inc"
    {
        STRLEN k_len=0;
        unsigned char *k=NULL;
        int rv;
        int id;

        id = find_cipher(cipher_name);
        if(id==-1) croak("FATAL: find_cipfer failed for '%s'", cipher_name);

        if (!SvPOK(key)) croak("FATAL: key must be string/buffer scalar");
        k = (unsigned char *) SvPVbyte(key, k_len);

        Newz(0, RETVAL, 1, struct pmac_struct);
        if (!RETVAL) croak("FATAL: Newz failed");

        rv = pmac_init(&RETVAL->state, id, k, (unsigned long)k_len);
        if (rv != CRYPT_OK) croak("FATAL: pmac_init failed: %s", error_to_string(rv));
    }
#line 3557 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::Mac::PMAC", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mac__PMAC_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__PMAC_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__Mac__PMAC	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mac__PMAC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Crypt::Mac::PMAC::DESTROY",
			"self")
;
#line 32 "./inc/CryptX_Mac_PMAC.xs.inc"
        Safefree(self);
#line 3589 "CryptX.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Mac__PMAC_clone); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__PMAC_clone)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__Mac__PMAC	RETVAL;
	Crypt__Mac__PMAC	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mac::PMAC")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mac__PMAC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mac::PMAC::clone",
			"self", "Crypt::Mac::PMAC")
;
#line 37 "./inc/CryptX_Mac_PMAC.xs.inc"
        Newz(0, RETVAL, 1, struct pmac_struct);
        if (!RETVAL) croak("FATAL: Newz failed");
        Copy(&self->state, &RETVAL->state, 1, struct pmac_struct);
#line 3618 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::Mac::PMAC", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mac__PMAC__add_single); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__PMAC__add_single)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, data");
    {
	Crypt__Mac__PMAC	self;
	SV *	data = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mac::PMAC")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mac__PMAC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mac::PMAC::_add_single",
			"self", "Crypt::Mac::PMAC")
;
#line 46 "./inc/CryptX_Mac_PMAC.xs.inc"
    {
        int rv;
        STRLEN in_data_len;
        unsigned char *in_data;

        in_data = (unsigned char *)SvPVbyte(data, in_data_len);
        if (in_data_len>0) {
          rv = pmac_process(&self->state, in_data, (unsigned long)in_data_len);
          if (rv != CRYPT_OK) croak("FATAL: pmac_process failed: %s", error_to_string(rv));
        }
    }
#line 3662 "CryptX.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Mac__PMAC_mac); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__PMAC_mac)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	RETVAL;
	Crypt__Mac__PMAC	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mac::PMAC")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mac__PMAC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mac::PMAC::mac",
			"self", "Crypt::Mac::PMAC")
;
#line 61 "./inc/CryptX_Mac_PMAC.xs.inc"
    {
        char mac[MAXBLOCKSIZE];
        unsigned long mac_len;
        int rv;

        mac_len = sizeof(mac);
        rv = pmac_done(&self->state, (unsigned char*)mac, &mac_len);
        if (rv != CRYPT_OK) croak("FATAL: pmac_done failed: %s", error_to_string(rv));
        RETVAL = newSVpvn(mac, mac_len);
    }
#line 3698 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mac__PMAC_b64mac); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__PMAC_b64mac)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	RETVAL;
	Crypt__Mac__PMAC	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mac::PMAC")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mac__PMAC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mac::PMAC::b64mac",
			"self", "Crypt::Mac::PMAC")
;
#line 77 "./inc/CryptX_Mac_PMAC.xs.inc"
    {
        unsigned char mac[MAXBLOCKSIZE];
        unsigned long mac_len;
        int rv;
        unsigned long outlen;
        char mac_base64[MAXBLOCKSIZE*2 + 1];

        mac_len = sizeof(mac);
        rv = pmac_done(&self->state, mac, &mac_len);
        if (rv != CRYPT_OK) croak("FATAL: pmac_done failed: %s", error_to_string(rv));
        outlen = sizeof(mac_base64);
        rv = base64_encode(mac, mac_len, (unsigned char*)mac_base64, &outlen);
        if (rv != CRYPT_OK) croak("FATAL: base64_encode failed: %s", error_to_string(rv));
        RETVAL = newSVpvn(mac_base64, outlen);
    }
#line 3741 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mac__PMAC_b64umac); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__PMAC_b64umac)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	RETVAL;
	Crypt__Mac__PMAC	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mac::PMAC")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mac__PMAC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mac::PMAC::b64umac",
			"self", "Crypt::Mac::PMAC")
;
#line 98 "./inc/CryptX_Mac_PMAC.xs.inc"
    {
        unsigned char mac[MAXBLOCKSIZE];
        unsigned long mac_len;
        int rv;
        unsigned long outlen;
        char mac_base64[MAXBLOCKSIZE*2 + 1];

        mac_len = sizeof(mac);
        rv = pmac_done(&self->state, mac, &mac_len);
        if (rv != CRYPT_OK) croak("FATAL: pmac_done failed: %s", error_to_string(rv));
        outlen = sizeof(mac_base64);
        rv = base64url_encode(mac, mac_len, (unsigned char*)mac_base64, &outlen);
        if (rv != CRYPT_OK) croak("FATAL: base64url_encode failed: %s", error_to_string(rv));
        RETVAL = newSVpvn(mac_base64, outlen);
    }
#line 3784 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mac__PMAC_hexmac); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__PMAC_hexmac)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	RETVAL;
	Crypt__Mac__PMAC	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mac::PMAC")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mac__PMAC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mac::PMAC::hexmac",
			"self", "Crypt::Mac::PMAC")
;
#line 119 "./inc/CryptX_Mac_PMAC.xs.inc"
    {
        unsigned char mac[MAXBLOCKSIZE];
        unsigned long mac_len, i;
        int rv;
        char mac_hex[MAXBLOCKSIZE*2 + 1];

        mac_len = sizeof(mac);
        rv = pmac_done(&self->state, mac, &mac_len);
        if (rv != CRYPT_OK) croak("FATAL: pmac_done failed: %s", error_to_string(rv));
        mac_hex[0] = '\0';
        for(i=0; i<mac_len; i++)
            sprintf(&mac_hex[2*i], "%02x", mac[i]);
        RETVAL = newSVpvn(mac_hex, strlen(mac_hex));
    }
#line 3826 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


/* INCLUDE: Returning to 'inc/CryptX_Mac_Pelican.xs.inc' from 'inc/CryptX_Mac_PMAC.xs.inc' */


XS_EUPXS(XS_Crypt__Mac__Pelican__new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__Pelican__new)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "key");
    {
	Crypt__Mac__Pelican	RETVAL;
	SV *	key = ST(0)
;
#line 8 "./inc/CryptX_Mac_Pelican.xs.inc"
    {
        STRLEN k_len=0;
        unsigned char *k=NULL;
        int rv;

        if (!SvPOK(key)) croak("FATAL: key must be string/buffer scalar");
        k = (unsigned char *) SvPVbyte(key, k_len);

        Newz(0, RETVAL, 1, struct pelican_struct);
        if (!RETVAL) croak("FATAL: Newz failed");

        rv = pelican_init(&RETVAL->state, k, (unsigned long)k_len);
        if (rv != CRYPT_OK) croak("FATAL: pelican_init failed: %s", error_to_string(rv));
    }
#line 3862 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::Mac::Pelican", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mac__Pelican_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__Pelican_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__Mac__Pelican	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mac__Pelican,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Crypt::Mac::Pelican::DESTROY",
			"self")
;
#line 28 "./inc/CryptX_Mac_Pelican.xs.inc"
        Safefree(self);
#line 3894 "CryptX.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Mac__Pelican_clone); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__Pelican_clone)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__Mac__Pelican	RETVAL;
	Crypt__Mac__Pelican	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mac::Pelican")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mac__Pelican,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mac::Pelican::clone",
			"self", "Crypt::Mac::Pelican")
;
#line 33 "./inc/CryptX_Mac_Pelican.xs.inc"
        Newz(0, RETVAL, 1, struct pelican_struct);
        if (!RETVAL) croak("FATAL: Newz failed");
        Copy(&self->state, &RETVAL->state, 1, struct pelican_struct);
#line 3923 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::Mac::Pelican", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mac__Pelican__add_single); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__Pelican__add_single)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, data");
    {
	Crypt__Mac__Pelican	self;
	SV *	data = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mac::Pelican")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mac__Pelican,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mac::Pelican::_add_single",
			"self", "Crypt::Mac::Pelican")
;
#line 42 "./inc/CryptX_Mac_Pelican.xs.inc"
    {
        int rv;
        STRLEN in_data_len;
        unsigned char *in_data;

        in_data = (unsigned char *)SvPVbyte(data, in_data_len);
        if (in_data_len>0) {
          rv = pelican_process(&self->state, in_data, (unsigned long)in_data_len);
          if (rv != CRYPT_OK) croak("FATAL: pelican_process failed: %s", error_to_string(rv));
        }
    }
#line 3967 "CryptX.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Mac__Pelican_mac); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__Pelican_mac)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	RETVAL;
	Crypt__Mac__Pelican	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mac::Pelican")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mac__Pelican,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mac::Pelican::mac",
			"self", "Crypt::Mac::Pelican")
;
#line 57 "./inc/CryptX_Mac_Pelican.xs.inc"
    {
        char mac[MAXBLOCKSIZE];
        unsigned long mac_len;
        int rv;

        mac_len = 16;
        rv = pelican_done(&self->state, (unsigned char*)mac);
        if (rv != CRYPT_OK) croak("FATAL: pelican_done failed: %s", error_to_string(rv));
        RETVAL = newSVpvn(mac, mac_len);
    }
#line 4003 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mac__Pelican_b64mac); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__Pelican_b64mac)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	RETVAL;
	Crypt__Mac__Pelican	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mac::Pelican")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mac__Pelican,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mac::Pelican::b64mac",
			"self", "Crypt::Mac::Pelican")
;
#line 73 "./inc/CryptX_Mac_Pelican.xs.inc"
    {
        unsigned char mac[MAXBLOCKSIZE];
        unsigned long mac_len;
        int rv;
        unsigned long outlen;
        char mac_base64[MAXBLOCKSIZE*2 + 1];

        mac_len = 16;
        rv = pelican_done(&self->state, mac);
        if (rv != CRYPT_OK) croak("FATAL: pelican_done failed: %s", error_to_string(rv));
        outlen = sizeof(mac_base64);
        rv = base64_encode(mac, mac_len, (unsigned char*)mac_base64, &outlen);
        if (rv != CRYPT_OK) croak("FATAL: base64_encode failed: %s", error_to_string(rv));
        RETVAL = newSVpvn(mac_base64, outlen);
    }
#line 4046 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mac__Pelican_b64umac); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__Pelican_b64umac)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	RETVAL;
	Crypt__Mac__Pelican	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mac::Pelican")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mac__Pelican,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mac::Pelican::b64umac",
			"self", "Crypt::Mac::Pelican")
;
#line 94 "./inc/CryptX_Mac_Pelican.xs.inc"
    {
        unsigned char mac[MAXBLOCKSIZE];
        unsigned long mac_len;
        int rv;
        unsigned long outlen;
        char mac_base64[MAXBLOCKSIZE*2 + 1];

        mac_len = 16;
        rv = pelican_done(&self->state, mac);
        if (rv != CRYPT_OK) croak("FATAL: pelican_done failed: %s", error_to_string(rv));
        outlen = sizeof(mac_base64);
        rv = base64url_encode(mac, mac_len, (unsigned char*)mac_base64, &outlen);
        if (rv != CRYPT_OK) croak("FATAL: base64url_encode failed: %s", error_to_string(rv));
        RETVAL = newSVpvn(mac_base64, outlen);
    }
#line 4089 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mac__Pelican_hexmac); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__Pelican_hexmac)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	RETVAL;
	Crypt__Mac__Pelican	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mac::Pelican")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mac__Pelican,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mac::Pelican::hexmac",
			"self", "Crypt::Mac::Pelican")
;
#line 115 "./inc/CryptX_Mac_Pelican.xs.inc"
    {
        unsigned char mac[MAXBLOCKSIZE];
        unsigned long mac_len, i;
        int rv;
        char mac_hex[MAXBLOCKSIZE*2 + 1];

        mac_len = 16;
        rv = pelican_done(&self->state, mac);
        if (rv != CRYPT_OK) croak("FATAL: pelican_done failed: %s", error_to_string(rv));
        mac_hex[0] = '\0';
        for(i=0; i<mac_len; i++)
            sprintf(&mac_hex[2*i], "%02x", mac[i]);
        RETVAL = newSVpvn(mac_hex, strlen(mac_hex));
    }
#line 4131 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


/* INCLUDE: Returning to 'inc/CryptX_Mac_OMAC.xs.inc' from 'inc/CryptX_Mac_Pelican.xs.inc' */


XS_EUPXS(XS_Crypt__Mac__OMAC__new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__OMAC__new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "cipher_name, key");
    {
	Crypt__Mac__OMAC	RETVAL;
	char *        cipher_name = (SvOK(ST(0))) ? SvPV_nolen(ST(0)) : NULL
;
	SV *	key = ST(1)
;
#line 8 "./inc/CryptX_Mac_OMAC.xs.inc"
    {
        STRLEN k_len=0;
        unsigned char *k=NULL;
        int rv;
        int id;

        id = find_cipher(cipher_name);
        if(id==-1) croak("FATAL: find_cipfer failed for '%s'", cipher_name);

        if (!SvPOK(key)) croak("FATAL: key must be string/buffer scalar");
        k = (unsigned char *) SvPVbyte(key, k_len);

        Newz(0, RETVAL, 1, struct omac_struct);
        if (!RETVAL) croak("FATAL: Newz failed");

        rv = omac_init(&RETVAL->state, id, k, (unsigned long)k_len);
        if (rv != CRYPT_OK) croak("FATAL: omac_init failed: %s", error_to_string(rv));
    }
#line 4173 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::Mac::OMAC", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mac__OMAC_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__OMAC_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__Mac__OMAC	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mac__OMAC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Crypt::Mac::OMAC::DESTROY",
			"self")
;
#line 32 "./inc/CryptX_Mac_OMAC.xs.inc"
        Safefree(self);
#line 4205 "CryptX.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Mac__OMAC_clone); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__OMAC_clone)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__Mac__OMAC	RETVAL;
	Crypt__Mac__OMAC	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mac::OMAC")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mac__OMAC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mac::OMAC::clone",
			"self", "Crypt::Mac::OMAC")
;
#line 37 "./inc/CryptX_Mac_OMAC.xs.inc"
        Newz(0, RETVAL, 1, struct omac_struct);
        if (!RETVAL) croak("FATAL: Newz failed");
        Copy(&self->state, &RETVAL->state, 1, struct omac_struct);
#line 4234 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::Mac::OMAC", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mac__OMAC__add_single); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__OMAC__add_single)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, data");
    {
	Crypt__Mac__OMAC	self;
	SV *	data = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mac::OMAC")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mac__OMAC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mac::OMAC::_add_single",
			"self", "Crypt::Mac::OMAC")
;
#line 46 "./inc/CryptX_Mac_OMAC.xs.inc"
    {
        int rv;
        STRLEN in_data_len;
        unsigned char *in_data;

        in_data = (unsigned char *)SvPVbyte(data, in_data_len);
        if (in_data_len>0) {
          rv = omac_process(&self->state, in_data, (unsigned long)in_data_len);
          if (rv != CRYPT_OK) croak("FATAL: omac_process failed: %s", error_to_string(rv));
        }
    }
#line 4278 "CryptX.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Mac__OMAC_mac); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__OMAC_mac)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	RETVAL;
	Crypt__Mac__OMAC	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mac::OMAC")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mac__OMAC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mac::OMAC::mac",
			"self", "Crypt::Mac::OMAC")
;
#line 61 "./inc/CryptX_Mac_OMAC.xs.inc"
    {
        char mac[MAXBLOCKSIZE];
        unsigned long mac_len;
        int rv;

        mac_len = sizeof(mac);
        rv = omac_done(&self->state, (unsigned char*)mac, &mac_len);
        if (rv != CRYPT_OK) croak("FATAL: omac_done failed: %s", error_to_string(rv));
        RETVAL = newSVpvn(mac, mac_len);
    }
#line 4314 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mac__OMAC_b64mac); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__OMAC_b64mac)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	RETVAL;
	Crypt__Mac__OMAC	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mac::OMAC")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mac__OMAC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mac::OMAC::b64mac",
			"self", "Crypt::Mac::OMAC")
;
#line 77 "./inc/CryptX_Mac_OMAC.xs.inc"
    {
        unsigned char mac[MAXBLOCKSIZE];
        unsigned long mac_len;
        int rv;
        unsigned long outlen;
        char mac_base64[MAXBLOCKSIZE*2 + 1];

        mac_len = sizeof(mac);
        rv = omac_done(&self->state, mac, &mac_len);
        if (rv != CRYPT_OK) croak("FATAL: omac_done failed: %s", error_to_string(rv));
        outlen = sizeof(mac_base64);
        rv = base64_encode(mac, mac_len, (unsigned char*)mac_base64, &outlen);
        if (rv != CRYPT_OK) croak("FATAL: base64_encode failed: %s", error_to_string(rv));
        RETVAL = newSVpvn(mac_base64, outlen);
    }
#line 4357 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mac__OMAC_b64umac); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__OMAC_b64umac)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	RETVAL;
	Crypt__Mac__OMAC	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mac::OMAC")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mac__OMAC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mac::OMAC::b64umac",
			"self", "Crypt::Mac::OMAC")
;
#line 98 "./inc/CryptX_Mac_OMAC.xs.inc"
    {
        unsigned char mac[MAXBLOCKSIZE];
        unsigned long mac_len;
        int rv;
        unsigned long outlen;
        char mac_base64[MAXBLOCKSIZE*2 + 1];

        mac_len = sizeof(mac);
        rv = omac_done(&self->state, mac, &mac_len);
        if (rv != CRYPT_OK) croak("FATAL: omac_done failed: %s", error_to_string(rv));
        outlen = sizeof(mac_base64);
        rv = base64url_encode(mac, mac_len, (unsigned char*)mac_base64, &outlen);
        if (rv != CRYPT_OK) croak("FATAL: base64url_encode failed: %s", error_to_string(rv));
        RETVAL = newSVpvn(mac_base64, outlen);
    }
#line 4400 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mac__OMAC_hexmac); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__OMAC_hexmac)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	RETVAL;
	Crypt__Mac__OMAC	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mac::OMAC")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mac__OMAC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mac::OMAC::hexmac",
			"self", "Crypt::Mac::OMAC")
;
#line 119 "./inc/CryptX_Mac_OMAC.xs.inc"
    {
        unsigned char mac[MAXBLOCKSIZE];
        unsigned long mac_len, i;
        int rv;
        char mac_hex[MAXBLOCKSIZE*2 + 1];

        mac_len = sizeof(mac);
        rv = omac_done(&self->state, mac, &mac_len);
        if (rv != CRYPT_OK) croak("FATAL: omac_done failed: %s", error_to_string(rv));
        mac_hex[0] = '\0';
        for(i=0; i<mac_len; i++)
            sprintf(&mac_hex[2*i], "%02x", mac[i]);
        RETVAL = newSVpvn(mac_hex, strlen(mac_hex));
    }
#line 4442 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


/* INCLUDE: Returning to 'inc/CryptX_Mac_HMAC.xs.inc' from 'inc/CryptX_Mac_OMAC.xs.inc' */


XS_EUPXS(XS_Crypt__Mac__HMAC__new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__HMAC__new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "hash_name, key");
    {
	Crypt__Mac__HMAC	RETVAL;
	char *        hash_name = (SvOK(ST(0))) ? SvPV_nolen(ST(0)) : NULL
;
	SV *	key = ST(1)
;
#line 8 "./inc/CryptX_Mac_HMAC.xs.inc"
    {
        STRLEN k_len=0;
        unsigned char *k=NULL;
        int rv;
        int id;

        id = find_hash(hash_name);
        if(id==-1) croak("FATAL: find_hash failed for '%s'", hash_name);

        if (!SvPOK(key)) croak("FATAL: key must be string/buffer scalar");
        k = (unsigned char *) SvPVbyte(key, k_len);

        Newz(0, RETVAL, 1, struct hmac_struct);
        if (!RETVAL) croak("FATAL: Newz failed");

        rv = hmac_init(&RETVAL->state, id, k, (unsigned long)k_len);
        if (rv != CRYPT_OK) croak("FATAL: hmac_init failed: %s", error_to_string(rv));
    }
#line 4484 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::Mac::HMAC", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mac__HMAC_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__HMAC_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__Mac__HMAC	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mac__HMAC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Crypt::Mac::HMAC::DESTROY",
			"self")
;
#line 32 "./inc/CryptX_Mac_HMAC.xs.inc"
        Safefree(self);
#line 4516 "CryptX.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Mac__HMAC_clone); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__HMAC_clone)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__Mac__HMAC	RETVAL;
	Crypt__Mac__HMAC	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mac::HMAC")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mac__HMAC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mac::HMAC::clone",
			"self", "Crypt::Mac::HMAC")
;
#line 37 "./inc/CryptX_Mac_HMAC.xs.inc"
        Newz(0, RETVAL, 1, struct hmac_struct);
        if (!RETVAL) croak("FATAL: Newz failed");
        Copy(&self->state, &RETVAL->state, 1, struct hmac_struct);
#line 4545 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::Mac::HMAC", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mac__HMAC__add_single); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__HMAC__add_single)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, data");
    {
	Crypt__Mac__HMAC	self;
	SV *	data = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mac::HMAC")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mac__HMAC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mac::HMAC::_add_single",
			"self", "Crypt::Mac::HMAC")
;
#line 46 "./inc/CryptX_Mac_HMAC.xs.inc"
    {
        int rv;
        STRLEN in_data_len;
        unsigned char *in_data;

        in_data = (unsigned char *)SvPVbyte(data, in_data_len);
        if (in_data_len>0) {
          rv = hmac_process(&self->state, in_data, (unsigned long)in_data_len);
          if (rv != CRYPT_OK) croak("FATAL: hmac_process failed: %s", error_to_string(rv));
        }
    }
#line 4589 "CryptX.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Mac__HMAC_mac); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__HMAC_mac)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	RETVAL;
	Crypt__Mac__HMAC	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mac::HMAC")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mac__HMAC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mac::HMAC::mac",
			"self", "Crypt::Mac::HMAC")
;
#line 61 "./inc/CryptX_Mac_HMAC.xs.inc"
    {
        char mac[MAXBLOCKSIZE];
        unsigned long mac_len;
        int rv;

        mac_len = sizeof(mac);
        rv = hmac_done(&self->state, (unsigned char*)mac, &mac_len);
        if (rv != CRYPT_OK) croak("FATAL: hmac_done failed: %s", error_to_string(rv));
        RETVAL = newSVpvn(mac, mac_len);
    }
#line 4625 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mac__HMAC_b64mac); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__HMAC_b64mac)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	RETVAL;
	Crypt__Mac__HMAC	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mac::HMAC")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mac__HMAC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mac::HMAC::b64mac",
			"self", "Crypt::Mac::HMAC")
;
#line 77 "./inc/CryptX_Mac_HMAC.xs.inc"
    {
        unsigned char mac[MAXBLOCKSIZE];
        unsigned long mac_len;
        int rv;
        unsigned long outlen;
        char mac_base64[MAXBLOCKSIZE*2 + 1];

        mac_len = sizeof(mac);
        rv = hmac_done(&self->state, mac, &mac_len);
        if (rv != CRYPT_OK) croak("FATAL: hmac_done failed: %s", error_to_string(rv));
        outlen = sizeof(mac_base64);
        rv = base64_encode(mac, mac_len, (unsigned char*)mac_base64, &outlen);
        if (rv != CRYPT_OK) croak("FATAL: base64_encode failed: %s", error_to_string(rv));
        RETVAL = newSVpvn(mac_base64, outlen);
    }
#line 4668 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mac__HMAC_b64umac); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__HMAC_b64umac)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	RETVAL;
	Crypt__Mac__HMAC	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mac::HMAC")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mac__HMAC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mac::HMAC::b64umac",
			"self", "Crypt::Mac::HMAC")
;
#line 98 "./inc/CryptX_Mac_HMAC.xs.inc"
    {
        unsigned char mac[MAXBLOCKSIZE];
        unsigned long mac_len;
        int rv;
        unsigned long outlen;
        char mac_base64[MAXBLOCKSIZE*2 + 1];

        mac_len = sizeof(mac);
        rv = hmac_done(&self->state, mac, &mac_len);
        if (rv != CRYPT_OK) croak("FATAL: hmac_done failed: %s", error_to_string(rv));
        outlen = sizeof(mac_base64);
        rv = base64url_encode(mac, mac_len, (unsigned char*)mac_base64, &outlen);
        if (rv != CRYPT_OK) croak("FATAL: base64url_encode failed: %s", error_to_string(rv));
        RETVAL = newSVpvn(mac_base64, outlen);
    }
#line 4711 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mac__HMAC_hexmac); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__HMAC_hexmac)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	RETVAL;
	Crypt__Mac__HMAC	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mac::HMAC")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mac__HMAC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mac::HMAC::hexmac",
			"self", "Crypt::Mac::HMAC")
;
#line 119 "./inc/CryptX_Mac_HMAC.xs.inc"
    {
        unsigned char mac[MAXBLOCKSIZE];
        unsigned long mac_len, i;
        int rv;
        char mac_hex[MAXBLOCKSIZE*2 + 1];

        mac_len = sizeof(mac);
        rv = hmac_done(&self->state, mac, &mac_len);
        if (rv != CRYPT_OK) croak("FATAL: hmac_done failed: %s", error_to_string(rv));
        mac_hex[0] = '\0';
        for(i=0; i<mac_len; i++)
            sprintf(&mac_hex[2*i], "%02x", mac[i]);
        RETVAL = newSVpvn(mac_hex, strlen(mac_hex));
    }
#line 4753 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


/* INCLUDE: Returning to 'inc/CryptX_Mac_F9.xs.inc' from 'inc/CryptX_Mac_HMAC.xs.inc' */


XS_EUPXS(XS_Crypt__Mac__F9__new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__F9__new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "cipher_name, key");
    {
	Crypt__Mac__F9	RETVAL;
	char *        cipher_name = (SvOK(ST(0))) ? SvPV_nolen(ST(0)) : NULL
;
	SV *	key = ST(1)
;
#line 8 "./inc/CryptX_Mac_F9.xs.inc"
    {
        STRLEN k_len=0;
        unsigned char *k=NULL;
        int rv;
        int id;

        id = find_cipher(cipher_name);
        if(id==-1) croak("FATAL: find_cipfer failed for '%s'", cipher_name);

        if (!SvPOK(key)) croak("FATAL: key must be string/buffer scalar");
        k = (unsigned char *) SvPVbyte(key, k_len);

        Newz(0, RETVAL, 1, struct f9_struct);
        if (!RETVAL) croak("FATAL: Newz failed");

        rv = f9_init(&RETVAL->state, id, k, (unsigned long)k_len);
        if (rv != CRYPT_OK) croak("FATAL: f9_init failed: %s", error_to_string(rv));
    }
#line 4795 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::Mac::F9", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mac__F9_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__F9_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__Mac__F9	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mac__F9,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Crypt::Mac::F9::DESTROY",
			"self")
;
#line 32 "./inc/CryptX_Mac_F9.xs.inc"
        Safefree(self);
#line 4827 "CryptX.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Mac__F9_clone); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__F9_clone)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__Mac__F9	RETVAL;
	Crypt__Mac__F9	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mac::F9")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mac__F9,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mac::F9::clone",
			"self", "Crypt::Mac::F9")
;
#line 37 "./inc/CryptX_Mac_F9.xs.inc"
        Newz(0, RETVAL, 1, struct f9_struct);
        if (!RETVAL) croak("FATAL: Newz failed");
        Copy(&self->state, &RETVAL->state, 1, struct f9_struct);
#line 4856 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::Mac::F9", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mac__F9__add_single); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__F9__add_single)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, data");
    {
	Crypt__Mac__F9	self;
	SV *	data = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mac::F9")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mac__F9,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mac::F9::_add_single",
			"self", "Crypt::Mac::F9")
;
#line 46 "./inc/CryptX_Mac_F9.xs.inc"
    {
        int rv;
        STRLEN in_data_len;
        unsigned char *in_data;

        in_data = (unsigned char *)SvPVbyte(data, in_data_len);
        if (in_data_len>0) {
          rv = f9_process(&self->state, in_data, (unsigned long)in_data_len);
          if (rv != CRYPT_OK) croak("FATAL: f9_process failed: %s", error_to_string(rv));
        }
    }
#line 4900 "CryptX.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Mac__F9_mac); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__F9_mac)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	RETVAL;
	Crypt__Mac__F9	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mac::F9")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mac__F9,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mac::F9::mac",
			"self", "Crypt::Mac::F9")
;
#line 61 "./inc/CryptX_Mac_F9.xs.inc"
    {
        char mac[MAXBLOCKSIZE];
        unsigned long mac_len;
        int rv;

        mac_len = sizeof(mac);
        rv = f9_done(&self->state, (unsigned char*)mac, &mac_len);
        if (rv != CRYPT_OK) croak("FATAL: f9_done failed: %s", error_to_string(rv));
        RETVAL = newSVpvn(mac, mac_len);
    }
#line 4936 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mac__F9_b64mac); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__F9_b64mac)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	RETVAL;
	Crypt__Mac__F9	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mac::F9")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mac__F9,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mac::F9::b64mac",
			"self", "Crypt::Mac::F9")
;
#line 77 "./inc/CryptX_Mac_F9.xs.inc"
    {
        unsigned char mac[MAXBLOCKSIZE];
        unsigned long mac_len;
        int rv;
        unsigned long outlen;
        char mac_base64[MAXBLOCKSIZE*2 + 1];

        mac_len = sizeof(mac);
        rv = f9_done(&self->state, mac, &mac_len);
        if (rv != CRYPT_OK) croak("FATAL: f9_done failed: %s", error_to_string(rv));
        outlen = sizeof(mac_base64);
        rv = base64_encode(mac, mac_len, (unsigned char*)mac_base64, &outlen);
        if (rv != CRYPT_OK) croak("FATAL: base64_encode failed: %s", error_to_string(rv));
        RETVAL = newSVpvn(mac_base64, outlen);
    }
#line 4979 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mac__F9_b64umac); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__F9_b64umac)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	RETVAL;
	Crypt__Mac__F9	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mac::F9")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mac__F9,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mac::F9::b64umac",
			"self", "Crypt::Mac::F9")
;
#line 98 "./inc/CryptX_Mac_F9.xs.inc"
    {
        unsigned char mac[MAXBLOCKSIZE];
        unsigned long mac_len;
        int rv;
        unsigned long outlen;
        char mac_base64[MAXBLOCKSIZE*2 + 1];

        mac_len = sizeof(mac);
        rv = f9_done(&self->state, mac, &mac_len);
        if (rv != CRYPT_OK) croak("FATAL: f9_done failed: %s", error_to_string(rv));
        outlen = sizeof(mac_base64);
        rv = base64url_encode(mac, mac_len, (unsigned char*)mac_base64, &outlen);
        if (rv != CRYPT_OK) croak("FATAL: base64url_encode failed: %s", error_to_string(rv));
        RETVAL = newSVpvn(mac_base64, outlen);
    }
#line 5022 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mac__F9_hexmac); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mac__F9_hexmac)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	RETVAL;
	Crypt__Mac__F9	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mac::F9")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mac__F9,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mac::F9::hexmac",
			"self", "Crypt::Mac::F9")
;
#line 119 "./inc/CryptX_Mac_F9.xs.inc"
    {
        unsigned char mac[MAXBLOCKSIZE];
        unsigned long mac_len, i;
        int rv;
        char mac_hex[MAXBLOCKSIZE*2 + 1];

        mac_len = sizeof(mac);
        rv = f9_done(&self->state, mac, &mac_len);
        if (rv != CRYPT_OK) croak("FATAL: f9_done failed: %s", error_to_string(rv));
        mac_hex[0] = '\0';
        for(i=0; i<mac_len; i++)
            sprintf(&mac_hex[2*i], "%02x", mac[i]);
        RETVAL = newSVpvn(mac_hex, strlen(mac_hex));
    }
#line 5064 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


/* INCLUDE: Returning to 'CryptX.xs' from 'inc/CryptX_Mac_F9.xs.inc' */


/* INCLUDE:  Including 'inc/CryptX_Mode_CBC.xs.inc' from 'CryptX.xs' */


/* INCLUDE:  Including 'inc/CryptX_Mode_ECB.xs.inc' from 'inc/CryptX_Mode_CBC.xs.inc' */


/* INCLUDE:  Including 'inc/CryptX_Mode_CFB.xs.inc' from 'inc/CryptX_Mode_ECB.xs.inc' */


/* INCLUDE:  Including 'inc/CryptX_Mode_OFB.xs.inc' from 'inc/CryptX_Mode_CFB.xs.inc' */


/* INCLUDE:  Including 'inc/CryptX_Mode_CTR.xs.inc' from 'inc/CryptX_Mode_OFB.xs.inc' */


XS_EUPXS(XS_Crypt__Mode__CTR__new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mode__CTR__new)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 4)
       croak_xs_usage(cv,  "cipher_name, ctr_mode=0, ctr_width=0, rounds=0");
    {
	Crypt__Mode__CTR	RETVAL;
	char *        cipher_name = (SvOK(ST(0))) ? SvPV_nolen(ST(0)) : NULL
;
	int	ctr_mode;
	int	ctr_width;
	int	rounds;

	if (items < 2)
	    ctr_mode = 0;
	else {
	    ctr_mode = (int)SvIV(ST(1))
;
	}

	if (items < 3)
	    ctr_width = 0;
	else {
	    ctr_width = (int)SvIV(ST(2))
;
	}

	if (items < 4)
	    rounds = 0;
	else {
	    rounds = (int)SvIV(ST(3))
;
	}
#line 8 "./inc/CryptX_Mode_CTR.xs.inc"
    {
        Newz(0, RETVAL, 1, struct ctr_struct);
        if (!RETVAL) croak("FATAL: Newz failed");
        RETVAL->direction = 0;
        RETVAL->cipher_rounds = rounds;
        RETVAL->cipher_id = find_cipher(cipher_name);
        if(RETVAL->cipher_id==-1) croak("FATAL: find_cipfer failed for '%s'", cipher_name);
        if (ctr_mode == 0) RETVAL->ctr_mode_param = CTR_COUNTER_LITTLE_ENDIAN;
        if (ctr_mode == 1) RETVAL->ctr_mode_param = CTR_COUNTER_BIG_ENDIAN;
        if (ctr_mode == 2) RETVAL->ctr_mode_param = CTR_COUNTER_LITTLE_ENDIAN|LTC_CTR_RFC3686;
        if (ctr_mode == 3) RETVAL->ctr_mode_param = CTR_COUNTER_BIG_ENDIAN|LTC_CTR_RFC3686;
        if (ctr_width > 0 && ctr_width <= cipher_descriptor[RETVAL->cipher_id].block_length) RETVAL->ctr_mode_param |= ctr_width;
    }
#line 5138 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::Mode::CTR", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mode__CTR_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mode__CTR_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__Mode__CTR	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mode__CTR,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Crypt::Mode::CTR::DESTROY",
			"self")
;
#line 27 "./inc/CryptX_Mode_CTR.xs.inc"
        Safefree(self);
#line 5170 "CryptX.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Mode__CTR__get_dir); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mode__CTR__get_dir)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	int	RETVAL;
	dXSTARG;
	Crypt__Mode__CTR	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mode::CTR")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mode__CTR,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mode::CTR::_get_dir",
			"self", "Crypt::Mode::CTR")
;
#line 32 "./inc/CryptX_Mode_CTR.xs.inc"
        RETVAL = self->direction;
#line 5198 "CryptX.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mode__CTR__start); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mode__CTR__start)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "self, dir, key, iv");
    {
	Crypt__Mode__CTR	self;
	int	dir = (int)SvIV(ST(1))
;
	SV *	key = ST(2)
;
	SV *	iv = ST(3)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mode::CTR")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mode__CTR,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mode::CTR::_start",
			"self", "Crypt::Mode::CTR")
;
#line 39 "./inc/CryptX_Mode_CTR.xs.inc"
    {
        STRLEN k_len=0;
        unsigned char *k=NULL;
        STRLEN i_len=0;
        unsigned char *i=NULL;
        int rv;

        if (!SvPOK(key))   croak("FATAL: key must be string/buffer scalar");
        k = (unsigned char *) SvPVbyte(key, k_len);

        if (!SvPOK(iv))    croak("FATAL: iv must be string/buffer scalar");
        i = (unsigned char *) SvPVbyte(iv, i_len);
        if (i_len != (STRLEN)cipher_descriptor[self->cipher_id].block_length) {
          croak ("FATAL: sizeof(iv) should be equal to blocksize (%d)", cipher_descriptor[self->cipher_id].block_length);
        }

        rv = ctr_start(self->cipher_id, i, k, (int)k_len, self->cipher_rounds, self->ctr_mode_param, &self->state);
        if (rv != CRYPT_OK) {
          croak("FATAL: ctr_start failed: %s", error_to_string(rv));
        }

        self->direction = dir;
    }
#line 5253 "CryptX.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Mode__CTR__crypt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mode__CTR__crypt)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, data");
    {
	SV *	RETVAL;
	Crypt__Mode__CTR	self;
	SV *	data = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mode::CTR")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mode__CTR,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mode::CTR::_crypt",
			"self", "Crypt::Mode::CTR")
;
#line 66 "./inc/CryptX_Mode_CTR.xs.inc"
    {
        int rv;
        STRLEN in_data_len;
        unsigned char *in_data, *out_data;

        in_data = (unsigned char *)SvPVbyte(data, in_data_len);
        if (in_data_len==0) {
          RETVAL = newSVpvn("", 0);
        }
        else {
          RETVAL = NEWSV(0, in_data_len);
          SvPOK_only(RETVAL);
          SvCUR_set(RETVAL, in_data_len);
          out_data = (unsigned char *)SvPV_nolen(RETVAL);

          if (self->direction == 1) {
            rv = ctr_encrypt(in_data, out_data, (unsigned long)in_data_len, &self->state);
            if (rv != CRYPT_OK) croak("FATAL: ctr_encrypt failed: %s", error_to_string(rv));
          }
          else if (self->direction == -1) {
            rv = ctr_decrypt(in_data, out_data, (unsigned long)in_data_len, &self->state);
            if (rv != CRYPT_OK) croak("FATAL: ctr_decrypt failed: %s", error_to_string(rv));
          }
          else {
            croak("FATAL: ctr_crypt failed: call start_encrypt or start_decrypt first");
          }
        }
    }
#line 5309 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mode__CTR__finish); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mode__CTR__finish)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	RETVAL;
	Crypt__Mode__CTR	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mode::CTR")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mode__CTR,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mode::CTR::_finish",
			"self", "Crypt::Mode::CTR")
;
#line 100 "./inc/CryptX_Mode_CTR.xs.inc"
          self->direction = 0;
          RETVAL = newSVpvn("", 0);
#line 5339 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


/* INCLUDE: Returning to 'inc/CryptX_Mode_OFB.xs.inc' from 'inc/CryptX_Mode_CTR.xs.inc' */


XS_EUPXS(XS_Crypt__Mode__OFB__new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mode__OFB__new)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "cipher_name, rounds=0");
    {
	Crypt__Mode__OFB	RETVAL;
	char *        cipher_name = (SvOK(ST(0))) ? SvPV_nolen(ST(0)) : NULL
;
	int	rounds;

	if (items < 2)
	    rounds = 0;
	else {
	    rounds = (int)SvIV(ST(1))
;
	}
#line 8 "./inc/CryptX_Mode_OFB.xs.inc"
    {
        Newz(0, RETVAL, 1, struct ofb_struct);
        if (!RETVAL) croak("FATAL: Newz failed");
        RETVAL->direction = 0;
        RETVAL->cipher_rounds = rounds;
        RETVAL->cipher_id = find_cipher(cipher_name);
        if(RETVAL->cipher_id==-1) croak("FATAL: find_cipfer failed for '%s'", cipher_name);
    }
#line 5377 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::Mode::OFB", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mode__OFB_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mode__OFB_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__Mode__OFB	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mode__OFB,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Crypt::Mode::OFB::DESTROY",
			"self")
;
#line 22 "./inc/CryptX_Mode_OFB.xs.inc"
        Safefree(self);
#line 5409 "CryptX.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Mode__OFB__get_dir); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mode__OFB__get_dir)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	int	RETVAL;
	dXSTARG;
	Crypt__Mode__OFB	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mode::OFB")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mode__OFB,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mode::OFB::_get_dir",
			"self", "Crypt::Mode::OFB")
;
#line 27 "./inc/CryptX_Mode_OFB.xs.inc"
        RETVAL = self->direction;
#line 5437 "CryptX.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mode__OFB__start); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mode__OFB__start)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "self, dir, key, iv");
    {
	Crypt__Mode__OFB	self;
	int	dir = (int)SvIV(ST(1))
;
	SV *	key = ST(2)
;
	SV *	iv = ST(3)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mode::OFB")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mode__OFB,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mode::OFB::_start",
			"self", "Crypt::Mode::OFB")
;
#line 34 "./inc/CryptX_Mode_OFB.xs.inc"
    {
        STRLEN k_len=0;
        unsigned char *k=NULL;
        STRLEN i_len=0;
        unsigned char *i=NULL;
        int rv;

        if (!SvPOK(key))   croak("FATAL: key must be string/buffer scalar");
        k = (unsigned char *) SvPVbyte(key, k_len);

        if (!SvPOK(iv))    croak("FATAL: iv must be string/buffer scalar");
        i = (unsigned char *) SvPVbyte(iv, i_len);
        if (i_len != (STRLEN)cipher_descriptor[self->cipher_id].block_length) {
          croak ("FATAL: sizeof(iv) should be equal to blocksize (%d)", cipher_descriptor[self->cipher_id].block_length);
        }

        rv = ofb_start(self->cipher_id, i, k, (int)k_len, self->cipher_rounds, &self->state);
        if (rv != CRYPT_OK) {
          croak("FATAL: ofb_start failed: %s", error_to_string(rv));
        }

        self->direction = dir;
    }
#line 5492 "CryptX.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Mode__OFB__crypt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mode__OFB__crypt)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, data");
    {
	SV *	RETVAL;
	Crypt__Mode__OFB	self;
	SV *	data = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mode::OFB")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mode__OFB,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mode::OFB::_crypt",
			"self", "Crypt::Mode::OFB")
;
#line 61 "./inc/CryptX_Mode_OFB.xs.inc"
    {
        int rv;
        STRLEN in_data_len;
        unsigned char *in_data, *out_data;

        in_data = (unsigned char *)SvPVbyte(data, in_data_len);
        if (in_data_len==0) {
          RETVAL = newSVpvn("", 0);
        }
        else {
          RETVAL = NEWSV(0, in_data_len);
          SvPOK_only(RETVAL);
          SvCUR_set(RETVAL, in_data_len);
          out_data = (unsigned char *)SvPV_nolen(RETVAL);

          if (self->direction == 1) {
            rv = ofb_encrypt(in_data, out_data, (unsigned long)in_data_len, &self->state);
            if (rv != CRYPT_OK) croak("FATAL: ofb_encrypt failed: %s", error_to_string(rv));
          }
          else if (self->direction == -1) {
            rv = ofb_decrypt(in_data, out_data, (unsigned long)in_data_len, &self->state);
            if (rv != CRYPT_OK) croak("FATAL: ofb_decrypt failed: %s", error_to_string(rv));
          }
          else {
            croak("FATAL: ofb_crypt failed: call start_encrypt or start_decrypt first");
          }
        }
    }
#line 5548 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mode__OFB__finish); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mode__OFB__finish)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	RETVAL;
	Crypt__Mode__OFB	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mode::OFB")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mode__OFB,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mode::OFB::_finish",
			"self", "Crypt::Mode::OFB")
;
#line 95 "./inc/CryptX_Mode_OFB.xs.inc"
          self->direction = 0;
          RETVAL = newSVpvn("", 0);
#line 5578 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


/* INCLUDE: Returning to 'inc/CryptX_Mode_CFB.xs.inc' from 'inc/CryptX_Mode_OFB.xs.inc' */


XS_EUPXS(XS_Crypt__Mode__CFB__new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mode__CFB__new)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "cipher_name, rounds=0");
    {
	Crypt__Mode__CFB	RETVAL;
	char *        cipher_name = (SvOK(ST(0))) ? SvPV_nolen(ST(0)) : NULL
;
	int	rounds;

	if (items < 2)
	    rounds = 0;
	else {
	    rounds = (int)SvIV(ST(1))
;
	}
#line 8 "./inc/CryptX_Mode_CFB.xs.inc"
    {
        Newz(0, RETVAL, 1, struct cfb_struct);
        if (!RETVAL) croak("FATAL: Newz failed");
        RETVAL->direction = 0;
        RETVAL->cipher_rounds = rounds;
        RETVAL->cipher_id = find_cipher(cipher_name);
        if(RETVAL->cipher_id==-1) croak("FATAL: find_cipfer failed for '%s'", cipher_name);
    }
#line 5616 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::Mode::CFB", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mode__CFB_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mode__CFB_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__Mode__CFB	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mode__CFB,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Crypt::Mode::CFB::DESTROY",
			"self")
;
#line 22 "./inc/CryptX_Mode_CFB.xs.inc"
        Safefree(self);
#line 5648 "CryptX.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Mode__CFB__get_dir); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mode__CFB__get_dir)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	int	RETVAL;
	dXSTARG;
	Crypt__Mode__CFB	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mode::CFB")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mode__CFB,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mode::CFB::_get_dir",
			"self", "Crypt::Mode::CFB")
;
#line 27 "./inc/CryptX_Mode_CFB.xs.inc"
        RETVAL = self->direction;
#line 5676 "CryptX.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mode__CFB__start); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mode__CFB__start)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "self, dir, key, iv");
    {
	Crypt__Mode__CFB	self;
	int	dir = (int)SvIV(ST(1))
;
	SV *	key = ST(2)
;
	SV *	iv = ST(3)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mode::CFB")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mode__CFB,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mode::CFB::_start",
			"self", "Crypt::Mode::CFB")
;
#line 34 "./inc/CryptX_Mode_CFB.xs.inc"
    {
        STRLEN k_len=0;
        unsigned char *k=NULL;
        STRLEN i_len=0;
        unsigned char *i=NULL;
        int rv;

        if (!SvPOK(key))   croak("FATAL: key must be string/buffer scalar");
        k = (unsigned char *) SvPVbyte(key, k_len);

        if (!SvPOK(iv))    croak("FATAL: iv must be string/buffer scalar");
        i = (unsigned char *) SvPVbyte(iv, i_len);
        if (i_len != (STRLEN)cipher_descriptor[self->cipher_id].block_length) {
          croak ("FATAL: sizeof(iv) should be equal to blocksize (%d)", cipher_descriptor[self->cipher_id].block_length);
        }

        rv = cfb_start(self->cipher_id, i, k, (int)k_len, self->cipher_rounds, &self->state);
        if (rv != CRYPT_OK) {
          croak("FATAL: cfb_start failed: %s", error_to_string(rv));
        }

        self->direction = dir;
    }
#line 5731 "CryptX.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Mode__CFB__crypt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mode__CFB__crypt)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, data");
    {
	SV *	RETVAL;
	Crypt__Mode__CFB	self;
	SV *	data = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mode::CFB")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mode__CFB,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mode::CFB::_crypt",
			"self", "Crypt::Mode::CFB")
;
#line 61 "./inc/CryptX_Mode_CFB.xs.inc"
    {
        int rv;
        STRLEN in_data_len;
        unsigned char *in_data, *out_data;

        in_data = (unsigned char *)SvPVbyte(data, in_data_len);
        if (in_data_len==0) {
          RETVAL = newSVpvn("", 0);
        }
        else {
          RETVAL = NEWSV(0, in_data_len);
          SvPOK_only(RETVAL);
          SvCUR_set(RETVAL, in_data_len);
          out_data = (unsigned char *)SvPV_nolen(RETVAL);

          if (self->direction == 1) {
            rv = cfb_encrypt(in_data, out_data, (unsigned long)in_data_len, &self->state);
            if (rv != CRYPT_OK) croak("FATAL: cfb_encrypt failed: %s", error_to_string(rv));
          }
          else if (self->direction == -1) {
            rv = cfb_decrypt(in_data, out_data, (unsigned long)in_data_len, &self->state);
            if (rv != CRYPT_OK) croak("FATAL: cfb_decrypt failed: %s", error_to_string(rv));
          }
          else {
            croak("FATAL: cfb_crypt failed: call start_encrypt or start_decrypt first");
          }
        }
    }
#line 5787 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mode__CFB__finish); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mode__CFB__finish)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	RETVAL;
	Crypt__Mode__CFB	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mode::CFB")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mode__CFB,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mode::CFB::_finish",
			"self", "Crypt::Mode::CFB")
;
#line 95 "./inc/CryptX_Mode_CFB.xs.inc"
          self->direction = 0;
          RETVAL = newSVpvn("", 0);
#line 5817 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


/* INCLUDE: Returning to 'inc/CryptX_Mode_ECB.xs.inc' from 'inc/CryptX_Mode_CFB.xs.inc' */


XS_EUPXS(XS_Crypt__Mode__ECB__new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mode__ECB__new)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "cipher_name, padding=1, rounds=0");
    {
	Crypt__Mode__ECB	RETVAL;
	char *        cipher_name = (SvOK(ST(0))) ? SvPV_nolen(ST(0)) : NULL
;
	int	padding;
	int	rounds;

	if (items < 2)
	    padding = 1;
	else {
	    padding = (int)SvIV(ST(1))
;
	}

	if (items < 3)
	    rounds = 0;
	else {
	    rounds = (int)SvIV(ST(2))
;
	}
#line 8 "./inc/CryptX_Mode_ECB.xs.inc"
    {
        Newz(0, RETVAL, 1, struct ecb_struct);
        if (!RETVAL) croak("FATAL: Newz failed");
        RETVAL->padding_mode = padding;
        RETVAL->padlen = 0;
        RETVAL->direction = 0;
        RETVAL->cipher_rounds = rounds;
        RETVAL->cipher_id = find_cipher(cipher_name);
        if(RETVAL->cipher_id==-1) croak("FATAL: find_cipfer failed for '%s'", cipher_name);
    }
#line 5865 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::Mode::ECB", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mode__ECB_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mode__ECB_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__Mode__ECB	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mode__ECB,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Crypt::Mode::ECB::DESTROY",
			"self")
;
#line 24 "./inc/CryptX_Mode_ECB.xs.inc"
        Safefree(self);
#line 5897 "CryptX.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Mode__ECB__get_dir); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mode__ECB__get_dir)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	int	RETVAL;
	dXSTARG;
	Crypt__Mode__ECB	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mode::ECB")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mode__ECB,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mode::ECB::_get_dir",
			"self", "Crypt::Mode::ECB")
;
#line 29 "./inc/CryptX_Mode_ECB.xs.inc"
        RETVAL = self->direction;
#line 5925 "CryptX.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mode__ECB__start); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mode__ECB__start)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, dir, key");
    {
	Crypt__Mode__ECB	self;
	int	dir = (int)SvIV(ST(1))
;
	SV *	key = ST(2)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mode::ECB")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mode__ECB,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mode::ECB::_start",
			"self", "Crypt::Mode::ECB")
;
#line 36 "./inc/CryptX_Mode_ECB.xs.inc"
    {
        int rv;
        STRLEN k_len=0;
        unsigned char *k=NULL;

        if (!SvPOK(key))   croak("FATAL: key must be string/buffer scalar");
        k = (unsigned char *) SvPVbyte(key, k_len);

        rv = ecb_start(self->cipher_id, k, (unsigned long)k_len, self->cipher_rounds, &self->state);
        if (rv != CRYPT_OK) {
          croak("FATAL: ecb_start failed: %s", error_to_string(rv));
        }

        self->direction = dir;
        self->padlen = 0;
    }
#line 5971 "CryptX.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Mode__ECB__encrypt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mode__ECB__encrypt)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, data");
    {
	SV *	RETVAL;
	Crypt__Mode__ECB	self;
	SV *	data = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mode::ECB")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mode__ECB,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mode::ECB::_encrypt",
			"self", "Crypt::Mode::ECB")
;
#line 56 "./inc/CryptX_Mode_ECB.xs.inc"
    {
        int rv, has_tmp_block, blen;
        unsigned long i;

        STRLEN in_data_len, in_data_start;
        unsigned char *in_data, *out_data, tmp_block[MAXBLOCKSIZE];

        if (self->direction != 1) croak("FATAL: encrypt error, call start_encrypt first (%d)", self->direction);

        blen = (&self->state)->blocklen;
        in_data_start = 0;
        has_tmp_block = 0;
        in_data = (unsigned char *)SvPVbyte(data, in_data_len);
        if (in_data_len==0) {
          RETVAL = newSVpvn("", 0);
        }
        else {
          if(self->padlen > 0) {
            i = (blen - self->padlen);
            if (in_data_len >= i) { /* enough data to fill pad */
              Copy(in_data, self->pad+self->padlen, i, unsigned char);
              in_data_len -= i;
              in_data_start = i;
              rv = ecb_encrypt(self->pad, tmp_block, blen, &self->state);
              if (rv != CRYPT_OK) croak("FATAL: ecb_encrypt failed: %s", error_to_string(rv));
              self->padlen = 0;
              has_tmp_block = 1;
            }
            else { /* not enough data to fill pad */
              Copy(in_data, self->pad+self->padlen, in_data_len, unsigned char);
              self->padlen += (int)in_data_len;
              in_data_len = 0;
            }
          } /* padlen > 0 */

          i = (unsigned long)(in_data_len % blen);
          if (in_data_len>0 && i>0) { /* save tail of data into pad */
            Copy(in_data+in_data_start+in_data_len-i, self->pad, i, unsigned char);
            self->padlen = i;
            in_data_len -= i;
          }

          if (in_data_len>0) {
            i = (unsigned long)(has_tmp_block ? in_data_len + blen : in_data_len);
            RETVAL = NEWSV(0, i);
            SvPOK_only(RETVAL);
            SvCUR_set(RETVAL, i);
            out_data = (unsigned char *)SvPV_nolen(RETVAL);

            if (has_tmp_block) {
              Copy(tmp_block, out_data, blen, unsigned char);
              out_data += blen;
            }
            rv = ecb_encrypt(in_data+in_data_start, out_data, (unsigned long)in_data_len, &self->state);
            if (rv != CRYPT_OK) croak("FATAL: ecb_encrypt failed: %s", error_to_string(rv));
          } /* in_data_len>0 */
          else if (has_tmp_block) {
            RETVAL = newSVpvn((char*)tmp_block, blen);
          }
          else {
            RETVAL = newSVpvn("", 0);
          }
        }
    }
#line 6063 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mode__ECB__finish_enc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mode__ECB__finish_enc)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	RETVAL;
	Crypt__Mode__ECB	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mode::ECB")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mode__ECB,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mode::ECB::_finish_enc",
			"self", "Crypt::Mode::ECB")
;
#line 126 "./inc/CryptX_Mode_ECB.xs.inc"
    {
        unsigned char tmp_block[MAXBLOCKSIZE];
        int rv, blen, i, j;

        blen = (&self->state)->blocklen;
        if (self->padlen<0 || self->padlen>=blen) croak("FATAL: invalid padlen");

        if(self->padding_mode == 1) { /* pkcs5|7 padding */
          i = blen - self->padlen;
          if (i == 0) i = blen;
          for(j=self->padlen; j<blen; j++) self->pad[j] = (unsigned char)i;
          rv = ecb_encrypt(self->pad, tmp_block, blen, &self->state);
          if (rv != CRYPT_OK) croak("FATAL: ecb_encrypt failed: %s", error_to_string(rv));
        }
        else if(self->padding_mode == 2) { /* oneandzeroes padding */
          self->pad[self->padlen] = 0x80;
          for(j=self->padlen+1; j<blen; j++) self->pad[j] = 0;
          rv = ecb_encrypt(self->pad, tmp_block, blen, &self->state);
          if (rv != CRYPT_OK) croak("FATAL: ecb_encrypt failed: %s", error_to_string(rv));
        }
        else {
          if (self->padlen>0) croak("FATAL: ecb_encrypt, input data length not multiple of %d", blen);
          blen = 0;
        }

        self->direction = 0;
        RETVAL = newSVpvn((char*)tmp_block, blen);
    }
#line 6119 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mode__ECB__decrypt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mode__ECB__decrypt)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, data");
    {
	SV *	RETVAL;
	Crypt__Mode__ECB	self;
	SV *	data = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mode::ECB")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mode__ECB,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mode::ECB::_decrypt",
			"self", "Crypt::Mode::ECB")
;
#line 160 "./inc/CryptX_Mode_ECB.xs.inc"
    {
        int rv, has_tmp_block, blen;
        unsigned long i;
        STRLEN in_data_len, in_data_start;
        unsigned char *in_data, *out_data, tmp_block[MAXBLOCKSIZE];

        if (self->direction != -1) croak("FATAL: decrypt error, call start_decryt first (%d)", self->direction);

        blen = (&self->state)->blocklen;
        in_data_start = 0;
        has_tmp_block = 0;
        in_data = (unsigned char *)SvPVbyte(data, in_data_len);
        if (in_data_len==0) {
          RETVAL = newSVpvn("", 0);
        }
        else {

          if(self->padlen == blen) {
            rv = ecb_decrypt(self->pad, tmp_block, blen, &self->state);
            if (rv != CRYPT_OK) croak("FATAL: ecb_decrypt failed: %s", error_to_string(rv));
            self->padlen = 0;
            has_tmp_block = 1;
          } /* padlen == blen */
          else if(self->padlen > 0) {
            i = (blen - self->padlen); /* remaining bytes in padding buffer */
            if (in_data_len >= i) { /* enough data to fill pad */
              Copy(in_data, self->pad+self->padlen, i, unsigned char);
              self->padlen += i;
              in_data_len -= i;
              in_data_start = i;
              if (in_data_len>0 || self->padding_mode == 0) {
                rv = ecb_decrypt(self->pad, tmp_block, blen, &self->state);
                if (rv != CRYPT_OK) croak("FATAL: ecb_decrypt failed: %s", error_to_string(rv));
                self->padlen = 0;
                has_tmp_block = 1;
              }
            }
            else { /* not enough data to fill pad */
              Copy(in_data, self->pad+self->padlen, in_data_len, unsigned char);
              self->padlen += (int)in_data_len;
              in_data_len = 0;
            }
          } /* padlen > 0 */

          /* here: a/ padlen==1..16 && in_data_len==0; b/ padlen==0 && in_data_len>0 */
          if (in_data_len>0) {
            i = (unsigned long)(in_data_len % blen);
            if (i>0) { /* save tail of data into pad */
              Copy(in_data+in_data_start+in_data_len-i, self->pad, i, unsigned char);
              self->padlen = i;
              in_data_len -= i;
            }
          }

          if (in_data_len>0) {
            if(self->padlen == 0 && self->padding_mode !=0) {
              /* in case of padding keep full pad if no more data */
              Copy(in_data+in_data_start+in_data_len-blen, self->pad, blen, unsigned char);
              self->padlen = blen;
              in_data_len -= blen;
            }
            i = (unsigned long)(has_tmp_block ? in_data_len + blen : in_data_len);
            if (i == 0) {
              RETVAL = newSVpvn("", 0);
            }
            else {
              RETVAL = NEWSV(0, i);
              SvPOK_only(RETVAL);
              SvCUR_set(RETVAL, i);
              out_data = (unsigned char *)SvPV_nolen(RETVAL);
              if (has_tmp_block) {
                Copy(tmp_block, out_data, blen, unsigned char);
                out_data += blen;
              }
              rv = ecb_decrypt(in_data+in_data_start, out_data, (unsigned long)in_data_len, &self->state);
              if (rv != CRYPT_OK) croak("FATAL: ecb_decrypt failed: %s", error_to_string(rv));
            }
          } /* in_data_len>0 */
          else if (has_tmp_block) {
            RETVAL = newSVpvn((char*)tmp_block, blen);
          }
          else {
            RETVAL = newSVpvn("", 0);
          }
        }

    }
#line 6236 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mode__ECB__finish_dec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mode__ECB__finish_dec)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	RETVAL;
	Crypt__Mode__ECB	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mode::ECB")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mode__ECB,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mode::ECB::_finish_dec",
			"self", "Crypt::Mode::ECB")
;
#line 253 "./inc/CryptX_Mode_ECB.xs.inc"
    {
        unsigned char tmp_block[MAXBLOCKSIZE];
        unsigned char i;
        int rv, rv_len, blen;

        rv_len = 0;
        if (self->padlen > 0) {
          blen = (&self->state)->blocklen;
          if (self->padlen != blen) croak("FATAL: cipher text length has to be multiple of %d (%d)", blen, self->padlen);
          rv = ecb_decrypt(self->pad, tmp_block, blen, &self->state);
          if (rv != CRYPT_OK) croak("FATAL: ecb_decrypt failed: %s", error_to_string(rv));
          if(self->padding_mode == 0) {         /* no padding */
            rv_len = blen;
          }
          else if(self->padding_mode == 1) {    /* pkcs5|7 padding */
            i = tmp_block[blen-1];
            rv_len = blen - (i>blen ? blen : i);
          }
          else if(self->padding_mode == 2) {    /* oneandzeroes padding */
            rv_len = blen;
            while ((unsigned char)tmp_block[rv_len-1] == 0x00) rv_len--;
            if ((unsigned char)tmp_block[rv_len-1] == 0x80) rv_len--;
            if (rv_len<0) rv_len = 0;
          }
        }

        self->direction = 0;
        RETVAL = newSVpvn((char*)tmp_block, rv_len);
    }
#line 6293 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


/* INCLUDE: Returning to 'inc/CryptX_Mode_CBC.xs.inc' from 'inc/CryptX_Mode_ECB.xs.inc' */


XS_EUPXS(XS_Crypt__Mode__CBC__new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mode__CBC__new)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "cipher_name, padding=1, rounds=0");
    {
	Crypt__Mode__CBC	RETVAL;
	char *        cipher_name = (SvOK(ST(0))) ? SvPV_nolen(ST(0)) : NULL
;
	int	padding;
	int	rounds;

	if (items < 2)
	    padding = 1;
	else {
	    padding = (int)SvIV(ST(1))
;
	}

	if (items < 3)
	    rounds = 0;
	else {
	    rounds = (int)SvIV(ST(2))
;
	}
#line 8 "./inc/CryptX_Mode_CBC.xs.inc"
    {
        Newz(0, RETVAL, 1, struct cbc_struct);
        if (!RETVAL) croak("FATAL: Newz failed");
        RETVAL->padding_mode = padding;
        RETVAL->padlen = 0;
        RETVAL->direction = 0;
        RETVAL->cipher_rounds = rounds;
        RETVAL->cipher_id = find_cipher(cipher_name);
        if(RETVAL->cipher_id==-1) croak("FATAL: find_cipfer failed for '%s'", cipher_name);
    }
#line 6341 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::Mode::CBC", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mode__CBC_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mode__CBC_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__Mode__CBC	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mode__CBC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Crypt::Mode::CBC::DESTROY",
			"self")
;
#line 24 "./inc/CryptX_Mode_CBC.xs.inc"
        Safefree(self);
#line 6373 "CryptX.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Mode__CBC__get_dir); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mode__CBC__get_dir)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	int	RETVAL;
	dXSTARG;
	Crypt__Mode__CBC	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mode::CBC")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mode__CBC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mode::CBC::_get_dir",
			"self", "Crypt::Mode::CBC")
;
#line 29 "./inc/CryptX_Mode_CBC.xs.inc"
        RETVAL = self->direction;
#line 6401 "CryptX.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mode__CBC__start); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mode__CBC__start)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "self, dir, key, iv");
    {
	Crypt__Mode__CBC	self;
	int	dir = (int)SvIV(ST(1))
;
	SV *	key = ST(2)
;
	SV *	iv = ST(3)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mode::CBC")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mode__CBC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mode::CBC::_start",
			"self", "Crypt::Mode::CBC")
;
#line 36 "./inc/CryptX_Mode_CBC.xs.inc"
    {
        int rv;
        STRLEN k_len=0;
        unsigned char *k=NULL;
        STRLEN i_len=0;
        unsigned char *i=NULL;

        if (!SvPOK(key))   croak("FATAL: key must be string/buffer scalar");
        k = (unsigned char *) SvPVbyte(key, k_len);

        if (!SvPOK(iv))    croak("FATAL: iv must be string/buffer scalar");
        i = (unsigned char *) SvPVbyte(iv, i_len);
        if (i_len != (STRLEN)cipher_descriptor[self->cipher_id].block_length) {
          croak ("FATAL: sizeof(iv) should be equal to blocksize (%d)", cipher_descriptor[self->cipher_id].block_length);
        }
        rv = cbc_start(self->cipher_id, i, k, (unsigned long)k_len, self->cipher_rounds, &self->state);
        if (rv != CRYPT_OK) {
          croak("FATAL: cbc_start failed: %s", error_to_string(rv));
        }

        self->direction = dir;
        self->padlen = 0;
    }
#line 6456 "CryptX.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Mode__CBC__encrypt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mode__CBC__encrypt)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, data");
    {
	SV *	RETVAL;
	Crypt__Mode__CBC	self;
	SV *	data = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mode::CBC")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mode__CBC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mode::CBC::_encrypt",
			"self", "Crypt::Mode::CBC")
;
#line 63 "./inc/CryptX_Mode_CBC.xs.inc"
    {
        int rv, has_tmp_block, blen;
        unsigned long i;

        STRLEN in_data_len, in_data_start;
        unsigned char *in_data, *out_data, tmp_block[MAXBLOCKSIZE];

        if (self->direction != 1) croak("FATAL: encrypt error, call start_encrypt first (%d)", self->direction);

        blen = (&self->state)->blocklen;
        in_data_start = 0;
        has_tmp_block = 0;
        in_data = (unsigned char *)SvPVbyte(data, in_data_len);
        if (in_data_len==0) {
          RETVAL = newSVpvn("", 0);
        }
        else {
          if(self->padlen > 0) {
            i = (blen - self->padlen);
            if (in_data_len >= i) { /* enough data to fill pad */
              Copy(in_data, self->pad+self->padlen, i, unsigned char);
              in_data_len -= i;
              in_data_start = i;
              rv = cbc_encrypt(self->pad, tmp_block, blen, &self->state);
              if (rv != CRYPT_OK) croak("FATAL: cbc_encrypt failed: %s", error_to_string(rv));
              self->padlen = 0;
              has_tmp_block = 1;
            }
            else { /* not enough data to fill pad */
              Copy(in_data, self->pad+self->padlen, in_data_len, unsigned char);
              self->padlen += (int)in_data_len;
              in_data_len = 0;
            }
          } /* padlen > 0 */

          i = (unsigned long)(in_data_len % blen);
          if (in_data_len>0 && i>0) { /* save tail of data into pad */
            Copy(in_data+in_data_start+in_data_len-i, self->pad, i, unsigned char);
            self->padlen = i;
            in_data_len -= i;
          }

          if (in_data_len>0) {
            i = (unsigned long)(has_tmp_block ? in_data_len + blen : in_data_len);
            RETVAL = NEWSV(0, i);
            SvPOK_only(RETVAL);
            SvCUR_set(RETVAL, i);
            out_data = (unsigned char *)SvPV_nolen(RETVAL);

            if (has_tmp_block) {
              Copy(tmp_block, out_data, blen, unsigned char);
              out_data += blen;
            }
            rv = cbc_encrypt(in_data+in_data_start, out_data, (unsigned long)in_data_len, &self->state);
            if (rv != CRYPT_OK) croak("FATAL: cbc_encrypt failed: %s", error_to_string(rv));
          } /* in_data_len>0 */
          else if (has_tmp_block) {
            RETVAL = newSVpvn((char*)tmp_block, blen);
          }
          else {
            RETVAL = newSVpvn("", 0);
          }
        }
    }
#line 6548 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mode__CBC__finish_enc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mode__CBC__finish_enc)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	RETVAL;
	Crypt__Mode__CBC	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mode::CBC")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mode__CBC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mode::CBC::_finish_enc",
			"self", "Crypt::Mode::CBC")
;
#line 133 "./inc/CryptX_Mode_CBC.xs.inc"
    {
        unsigned char tmp_block[MAXBLOCKSIZE];
        int rv, blen, i, j;

        blen = (&self->state)->blocklen;
        if (self->padlen<0 || self->padlen>=blen) croak("FATAL: invalid padlen");

        if(self->padding_mode == 1) { /* pkcs5|7 padding */
          i = blen - self->padlen;
          if (i == 0) i = blen;
          for(j=self->padlen; j<blen; j++) self->pad[j] = (unsigned char)i;
          rv = cbc_encrypt(self->pad, tmp_block, blen, &self->state);
          if (rv != CRYPT_OK) croak("FATAL: cbc_encrypt failed: %s", error_to_string(rv));
        }
        else if(self->padding_mode == 2) { /* oneandzeroes padding */
          self->pad[self->padlen] = 0x80;
          for(j=self->padlen+1; j<blen; j++) self->pad[j] = 0;
          rv = cbc_encrypt(self->pad, tmp_block, blen, &self->state);
          if (rv != CRYPT_OK) croak("FATAL: cbc_encrypt failed: %s", error_to_string(rv));
        }
        else {
          if (self->padlen>0) croak("FATAL: cbc_encrypt, input data length not multiple of %d", blen);
          blen = 0;
        }

        self->direction = 0;
        RETVAL = newSVpvn((char*)tmp_block, blen);
    }
#line 6604 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mode__CBC__decrypt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mode__CBC__decrypt)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, data");
    {
	SV *	RETVAL;
	Crypt__Mode__CBC	self;
	SV *	data = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mode::CBC")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mode__CBC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mode::CBC::_decrypt",
			"self", "Crypt::Mode::CBC")
;
#line 167 "./inc/CryptX_Mode_CBC.xs.inc"
    {
        int rv, has_tmp_block, blen;
        unsigned long i;
        STRLEN in_data_len, in_data_start;
        unsigned char *in_data, *out_data, tmp_block[MAXBLOCKSIZE];

        if (self->direction != -1) croak("FATAL: decrypt error, call start_decryt first (%d)", self->direction);

        blen = (&self->state)->blocklen;
        in_data_start = 0;
        has_tmp_block = 0;
        in_data = (unsigned char *)SvPVbyte(data, in_data_len);
        if (in_data_len==0) {
          RETVAL = newSVpvn("", 0);
        }
        else {

          if(self->padlen == blen) {
            rv = cbc_decrypt(self->pad, tmp_block, blen, &self->state);
            if (rv != CRYPT_OK) croak("FATAL: cbc_decrypt failed: %s", error_to_string(rv));
            self->padlen = 0;
            has_tmp_block = 1;
          } /* padlen == blen */
          else if(self->padlen > 0) {
            i = (blen - self->padlen); /* remaining bytes in padding buffer */
            if (in_data_len >= i) { /* enough data to fill pad */
              Copy(in_data, self->pad+self->padlen, i, unsigned char);
              self->padlen += i;
              in_data_len -= i;
              in_data_start = i;
              if (in_data_len>0 || self->padding_mode == 0) {
                rv = cbc_decrypt(self->pad, tmp_block, blen, &self->state);
                if (rv != CRYPT_OK) croak("FATAL: cbc_decrypt failed: %s", error_to_string(rv));
                self->padlen = 0;
                has_tmp_block = 1;
              }
            }
            else { /* not enough data to fill pad */
              Copy(in_data, self->pad+self->padlen, in_data_len, unsigned char);
              self->padlen += (int)in_data_len;
              in_data_len = 0;
            }
          } /* padlen > 0 */

          /* here: a/ padlen==1..16 && in_data_len==0; b/ padlen==0 && in_data_len>0 */
          if (in_data_len>0) {
            i = (unsigned long)(in_data_len % blen);
            if (i>0) { /* save tail of data into pad */
              Copy(in_data+in_data_start+in_data_len-i, self->pad, i, unsigned char);
              self->padlen = i;
              in_data_len -= i;
            }
          }

          if (in_data_len>0) {
            if(self->padlen == 0 && self->padding_mode !=0) {
              /* in case of padding keep full pad if no more data */
              Copy(in_data+in_data_start+in_data_len-blen, self->pad, blen, unsigned char);
              self->padlen = blen;
              in_data_len -= blen;
            }
            i = (unsigned long)(has_tmp_block ? in_data_len + blen : in_data_len);
            if (i == 0) {
              RETVAL = newSVpvn("", 0);
            }
            else {
              RETVAL = NEWSV(0, i);
              SvPOK_only(RETVAL);
              SvCUR_set(RETVAL, i);
              out_data = (unsigned char *)SvPV_nolen(RETVAL);
              if (has_tmp_block) {
                Copy(tmp_block, out_data, blen, unsigned char);
                out_data += blen;
              }
              rv = cbc_decrypt(in_data+in_data_start, out_data, (unsigned long)in_data_len, &self->state);
              if (rv != CRYPT_OK) croak("FATAL: cbc_decrypt failed: %s", error_to_string(rv));
            }
          } /* in_data_len>0 */
          else if (has_tmp_block) {
            RETVAL = newSVpvn((char*)tmp_block, blen);
          }
          else {
            RETVAL = newSVpvn("", 0);
          }
        }

    }
#line 6721 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Mode__CBC__finish_dec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Mode__CBC__finish_dec)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	RETVAL;
	Crypt__Mode__CBC	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::Mode::CBC")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Mode__CBC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::Mode::CBC::_finish_dec",
			"self", "Crypt::Mode::CBC")
;
#line 260 "./inc/CryptX_Mode_CBC.xs.inc"
    {
        unsigned char tmp_block[MAXBLOCKSIZE];
        unsigned char i;
        int rv, rv_len, blen;

        rv_len = 0;
        if (self->padlen > 0) {
          blen = (&self->state)->blocklen;
          if (self->padlen != blen) croak("FATAL: cipher text length has to be multiple of %d (%d)", blen, self->padlen);
          rv = cbc_decrypt(self->pad, tmp_block, blen, &self->state);
          if (rv != CRYPT_OK) croak("FATAL: cbc_decrypt failed: %s", error_to_string(rv));
          if(self->padding_mode == 0) {         /* no padding */
            rv_len = blen;
          }
          else if(self->padding_mode == 1) {    /* pkcs5|7 padding */
            i = tmp_block[blen-1];
            rv_len = blen - (i>blen ? blen : i);
          }
          else if(self->padding_mode == 2) {    /* oneandzeroes padding */
            rv_len = blen;
            while ((unsigned char)tmp_block[rv_len-1] == 0x00) rv_len--;
            if ((unsigned char)tmp_block[rv_len-1] == 0x80) rv_len--;
            if (rv_len<0) rv_len = 0;
          }
        }

        self->direction = 0;
        RETVAL = newSVpvn((char*)tmp_block, rv_len);
    }
#line 6778 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


/* INCLUDE: Returning to 'CryptX.xs' from 'inc/CryptX_Mode_CBC.xs.inc' */


/* INCLUDE:  Including 'inc/CryptX_PRNG.xs.inc' from 'CryptX.xs' */


XS_EUPXS(XS_Crypt__PRNG__new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PRNG__new)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "curpid, prng_name, entropy=&PL_sv_undef");
    {
	Crypt__PRNG	RETVAL;
	IV	curpid = (IV)SvIV(ST(0))
;
	char *        prng_name = (SvOK(ST(1))) ? SvPV_nolen(ST(1)) : NULL
;
	SV *	entropy;

	if (items < 3)
	    entropy = &PL_sv_undef;
	else {
	    entropy = ST(2)
;
	}
#line 6 "./inc/CryptX_PRNG.xs.inc"
    {
        int rv, id;
        unsigned char *ent=NULL;
        STRLEN ent_len=0;
        unsigned char entropy_buf[32];

        Newz(0, RETVAL, 1, struct prng_struct);
        if (!RETVAL) croak("FATAL: Newz failed");

        id = find_prng(prng_name);
        if(id==-1) croak("FATAL: find_prng failed for '%s'", prng_name);
        RETVAL->id = id;
        RETVAL->last_pid = curpid;
        RETVAL->desc = &prng_descriptor[id];

        rv = RETVAL->desc->start(&RETVAL->state);
        if (rv != CRYPT_OK) croak("FATAL: PRNG_start failed: %s", error_to_string(rv));

        if(SvOK(entropy)) {
          ent = (unsigned char *) SvPVbyte(entropy, ent_len);
          rv = RETVAL->desc->add_entropy(ent, (unsigned long)ent_len, &RETVAL->state);
          if (rv != CRYPT_OK) croak("FATAL: PRNG_add_entropy failed: %s", error_to_string(rv));
        }
        else {
          if (rng_get_bytes(entropy_buf, 32, NULL) != 32) croak("FATAL: rng_get_bytes failed: %s", error_to_string(rv));
          rv = RETVAL->desc->add_entropy(entropy_buf, 32, &RETVAL->state);
          if (rv != CRYPT_OK) croak("FATAL: PRNG_add_entropy failed: %s", error_to_string(rv));
        }
        rv = RETVAL->desc->ready(&RETVAL->state);
        if (rv != CRYPT_OK) croak("FATAL: PRNG_ready failed: %s", error_to_string(rv));
    }
#line 6844 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::PRNG", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PRNG_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PRNG_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__PRNG	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PRNG,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Crypt::PRNG::DESTROY",
			"self")
;
#line 43 "./inc/CryptX_PRNG.xs.inc"
    {
        Safefree(self);
    }
#line 6878 "CryptX.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__PRNG_add_entropy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PRNG_add_entropy)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "self, entropy=&PL_sv_undef");
    {
	Crypt__PRNG	self;
	SV *	entropy;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PRNG")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PRNG,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PRNG::add_entropy",
			"self", "Crypt::PRNG")
;

	if (items < 2)
	    entropy = &PL_sv_undef;
	else {
	    entropy = ST(1)
;
	}
#line 50 "./inc/CryptX_PRNG.xs.inc"
    {
        STRLEN in_len=0;
        unsigned char *in_buffer=NULL;
        unsigned char entropy_buf[32];
        int rv;
        if(SvOK(entropy)) {
          in_buffer = (unsigned char *) SvPVbyte(entropy, in_len);
          rv = self->desc->add_entropy(in_buffer, (unsigned long)in_len, &self->state);
          if (rv != CRYPT_OK) croak("FATAL: PRNG_add_entropy failed: %s", error_to_string(rv));
        }
        else {
          if (rng_get_bytes(entropy_buf, 32, NULL) != 32) croak("FATAL: rng_get_bytes failed");
          rv = self->desc->add_entropy(entropy_buf, 32, &self->state);
          if (rv != CRYPT_OK) croak("FATAL: PRNG_add_entropy failed: %s", error_to_string(rv));
        }
        rv = self->desc->ready(&self->state);
        if (rv != CRYPT_OK) croak("FATAL: PRNG_ready failed: %s", error_to_string(rv));
    }
#line 6929 "CryptX.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__PRNG__bytes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PRNG__bytes)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, curpid, output_len");
    {
	SV *	RETVAL;
	Crypt__PRNG	self;
	IV	curpid = (IV)SvIV(ST(1))
;
	STRLEN	output_len = (STRLEN)SvUV(ST(2))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PRNG")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PRNG,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PRNG::_bytes",
			"self", "Crypt::PRNG")
;
#line 72 "./inc/CryptX_PRNG.xs.inc"
    {
        int rv_len;
        unsigned char *rdata;
        unsigned char entropy_buf[32];

        if (self->last_pid != curpid) {
          rng_get_bytes(entropy_buf, 32, NULL);
          self->desc->add_entropy(entropy_buf, 32, &self->state);
          self->desc->ready(&self->state);
          self->last_pid = curpid;
        }

        RETVAL = NEWSV(0, output_len);
        SvPOK_only(RETVAL);
        SvCUR_set(RETVAL, output_len);
        rdata = (unsigned char *)SvPV_nolen(RETVAL);
        rv_len = (self->desc->read)(rdata, (unsigned long)output_len, &self->state);
        if ((UV)rv_len != output_len) croak("FATAL: PRNG_read failed");
    }
#line 6978 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PRNG__int32); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PRNG__int32)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, curpid");
    {
	UV	RETVAL;
	dXSTARG;
	Crypt__PRNG	self;
	IV	curpid = (IV)SvIV(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PRNG")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PRNG,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PRNG::_int32",
			"self", "Crypt::PRNG")
;
#line 97 "./inc/CryptX_PRNG.xs.inc"
    {
        int i;
        unsigned char rdata[4];
        unsigned char entropy_buf[32];

        if (self->last_pid != curpid) {
          rng_get_bytes(entropy_buf, 32, NULL);
          self->desc->add_entropy(entropy_buf, 32, &self->state);
          self->desc->ready(&self->state);
          self->last_pid = curpid;
        }

        i = (self->desc->read)(rdata, 4, &self->state);
        if (i != 4) croak("FATAL: PRNG_read failed");
        RETVAL = ((UV)(rdata[0])<<24) + ((UV)(rdata[1])<<16) + ((UV)(rdata[2])<<8) + ((UV)(rdata[3]));
    }
#line 7025 "CryptX.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PRNG__double); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PRNG__double)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "self, curpid, ...");
    {
	NV	RETVAL;
	dXSTARG;
	Crypt__PRNG	self;
	IV	curpid = (IV)SvIV(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PRNG")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PRNG,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PRNG::_double",
			"self", "Crypt::PRNG")
;
#line 119 "./inc/CryptX_PRNG.xs.inc"
    {
        int i;
        unsigned long a, b;     /* 32bit is enough */
        unsigned char rdata[7]; /* for double we need 53 bits */
        unsigned char entropy_buf[32];
        NV limit;

        if (self->last_pid != curpid) {
          rng_get_bytes(entropy_buf, 32, NULL);
          self->desc->add_entropy(entropy_buf, 32, &self->state);
          self->desc->ready(&self->state);
          self->last_pid = curpid;
        }

        i = (self->desc->read)(rdata, 7, &self->state);
        if (i != 7) croak("FATAL: PRNG_read failed");
        a = (((unsigned long)(rdata[0])<<16) + ((unsigned long)(rdata[1])<<8) + ((unsigned long)(rdata[2]))) & 0x1FFFFF;                      /* 21 bits */
        b = ((unsigned long)(rdata[3])<<24) + ((unsigned long)(rdata[4])<<16) + ((unsigned long)(rdata[5])<<8) + ((unsigned long)(rdata[6])); /* 32 bits */
        RETVAL = ( (NV)a * 4294967296.0 + (NV)b ) / 9007199254740992.0;                           /* (a * 2^32 + b) / 2^53 */
        if (items>2 && SvOK(ST(2))) {
          limit = SvNV(ST(2));
          if (limit > 0 || limit < 0) RETVAL = RETVAL * limit;
        }
    }
#line 7079 "CryptX.c"
	XSprePUSH; PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


/* INCLUDE: Returning to 'CryptX.xs' from 'inc/CryptX_PRNG.xs.inc' */


/* INCLUDE:  Including 'inc/CryptX_PK_RSA.xs.inc' from 'CryptX.xs' */


/* INCLUDE:  Including 'inc/CryptX_PK_DSA.xs.inc' from 'inc/CryptX_PK_RSA.xs.inc' */


/* INCLUDE:  Including 'inc/CryptX_PK_DH.xs.inc' from 'inc/CryptX_PK_DSA.xs.inc' */


/* INCLUDE:  Including 'inc/CryptX_PK_ECC.xs.inc' from 'inc/CryptX_PK_DH.xs.inc' */


XS_EUPXS(XS_Crypt__PK__ECC__new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__ECC__new)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	Crypt__PK__ECC	RETVAL;
#line 6 "./inc/CryptX_PK_ECC.xs.inc"
    {
        int rv;
        Newz(0, RETVAL, 1, struct ecc_struct);
        if (!RETVAL) croak("FATAL: Newz failed");
        RETVAL->yarrow_prng_index = find_prng("yarrow");
        RETVAL->key.type = -1;
        ecc_dp_init(&RETVAL->dp);
        if(RETVAL->yarrow_prng_index==-1) croak("FATAL: find_prng('yarrow') failed");
        rv = rng_make_prng(256, RETVAL->yarrow_prng_index, &RETVAL->yarrow_prng_state, NULL);
        if (rv != CRYPT_OK) croak("FATAL: rng_make_prng failed: %s", error_to_string(rv));
    }
#line 7121 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::PK::ECC", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PK__ECC_generate_key); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__ECC_generate_key)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, curve");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Crypt__PK__ECC	self;
	SV *	curve = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::ECC")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__ECC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::ECC::generate_key",
			"self", "Crypt::PK::ECC")
;
#line 23 "./inc/CryptX_PK_ECC.xs.inc"
    {
        int rv;
        /* add a small random entropy before generating key - not necessary as we have initialized prng with 256bit entropy in _new() */
        rv = rng_make_prng(64, self->yarrow_prng_index, &self->yarrow_prng_state, NULL);
        if (rv != CRYPT_OK) croak("FATAL: rng_make_prng failed: %s", error_to_string(rv));
        /* setup dp structure */
        _ecc_set_dp_from_SV(&self->dp, curve); /* croaks on error */
        /* gen the key */
        rv = ecc_make_key_ex(&self->yarrow_prng_state, self->yarrow_prng_index, &self->key, &self->dp);
        if (rv != CRYPT_OK) croak("FATAL: ecc_make_key_ex failed: %s", error_to_string(rv));
        XPUSHs(ST(0)); /* return self */
    }
#line 7168 "CryptX.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Crypt__PK__ECC__import); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__ECC__import)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, key_data");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Crypt__PK__ECC	self;
	SV *	key_data = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::ECC")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__ECC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::ECC::_import",
			"self", "Crypt::PK::ECC")
;
#line 39 "./inc/CryptX_PK_ECC.xs.inc"
    {
        int rv;
        unsigned char *data=NULL;
        STRLEN data_len=0;

        data = (unsigned char *)SvPVbyte(key_data, data_len);
        _ecc_free_key(&self->key, &self->dp);
        rv = ecc_import_full(data, (unsigned long)data_len, &self->key, &self->dp);
        if (rv != CRYPT_OK) croak("FATAL: ecc_import_full failed: %s", error_to_string(rv));
        XPUSHs(ST(0)); /* return self */
    }
#line 7209 "CryptX.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Crypt__PK__ECC__import_pkcs8); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__ECC__import_pkcs8)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, key_data");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Crypt__PK__ECC	self;
	SV *	key_data = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::ECC")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__ECC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::ECC::_import_pkcs8",
			"self", "Crypt::PK::ECC")
;
#line 54 "./inc/CryptX_PK_ECC.xs.inc"
    {
        int rv;
        unsigned char *data=NULL;
        STRLEN data_len=0;

        data = (unsigned char *)SvPVbyte(key_data, data_len);
        _ecc_free_key(&self->key, &self->dp);
        rv = ecc_import_pkcs8(data, (unsigned long)data_len, &self->key, &self->dp);
        if (rv != CRYPT_OK) croak("FATAL: ecc_import_pkcs8 failed: %s", error_to_string(rv));
        XPUSHs(ST(0)); /* return self */
    }
#line 7250 "CryptX.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Crypt__PK__ECC_import_key_raw); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__ECC_import_key_raw)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, key_data, curve");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Crypt__PK__ECC	self;
	SV *	key_data = ST(1)
;
	SV *	curve = ST(2)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::ECC")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__ECC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::ECC::import_key_raw",
			"self", "Crypt::PK::ECC")
;
#line 69 "./inc/CryptX_PK_ECC.xs.inc"
    {
        int rv;
        unsigned char *data=NULL;
        STRLEN data_len=0;

        data = (unsigned char *)SvPVbyte(key_data, data_len);
        _ecc_free_key(&self->key, &self->dp);

        _ecc_set_dp_from_SV(&self->dp, curve); /* croaks on error */

        rv = ecc_import_raw(data, (unsigned long)data_len, &self->key, &self->dp);
        if (rv != CRYPT_OK) croak("FATAL: ecc_import_raw failed: %s", error_to_string(rv));
        XPUSHs(ST(0)); /* return self */
    }
#line 7296 "CryptX.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Crypt__PK__ECC_is_private); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__ECC_is_private)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	int	RETVAL;
	dXSTARG;
	Crypt__PK__ECC	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::ECC")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__ECC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::ECC::is_private",
			"self", "Crypt::PK::ECC")
;
#line 87 "./inc/CryptX_PK_ECC.xs.inc"
        if (self->key.type == -1) XSRETURN_UNDEF;
        RETVAL = (self->key.type == PK_PRIVATE) ? 1 : 0;
#line 7326 "CryptX.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PK__ECC_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__ECC_size)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	int	RETVAL;
	dXSTARG;
	Crypt__PK__ECC	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::ECC")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__ECC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::ECC::size",
			"self", "Crypt::PK::ECC")
;
#line 95 "./inc/CryptX_PK_ECC.xs.inc"
        if (self->key.type == -1) XSRETURN_UNDEF;
        RETVAL = ecc_get_size(&self->key);
#line 7356 "CryptX.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PK__ECC_key2hash); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__ECC_key2hash)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
#line 103 "./inc/CryptX_PK_ECC.xs.inc"
        HV *rv_hash;
        long siz;
        char buf[20001];
        SV **not_used;
#line 7375 "CryptX.c"
	SV *	RETVAL;
	Crypt__PK__ECC	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::ECC")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__ECC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::ECC::key2hash",
			"self", "Crypt::PK::ECC")
;
#line 108 "./inc/CryptX_PK_ECC.xs.inc"
        if (self->key.type == -1) XSRETURN_UNDEF;
        rv_hash = newHV();
        /* =====> k */
        siz = (self->key.k) ? mp_unsigned_bin_size(self->key.k) : 0;
        if (siz>10000) {
          croak("FATAL: key2hash failed - 'k' too big number");
        }
        if (siz>0) {
          mp_tohex(self->key.k, buf);
          not_used = hv_store(rv_hash, "k", 1, newSVpv(buf, strlen(buf)), 0);
        }
        else{
          not_used = hv_store(rv_hash, "k", 1, newSVpv("", 0), 0);
        }
        /* =====> pub_x */
        siz = (self->key.pubkey.x) ? mp_unsigned_bin_size(self->key.pubkey.x) : 0;
        if (siz>10000) {
          croak("FATAL: key2hash failed - 'pub_x' too big number");
        }
        if (siz>0) {
          mp_tohex(self->key.pubkey.x, buf);
          not_used = hv_store(rv_hash, "pub_x", 5, newSVpv(buf, strlen(buf)), 0);
        }
        else{
          not_used = hv_store(rv_hash, "pub_x", 5, newSVpv("", 0), 0);
        }
        /* =====> pub_y */
        siz = (self->key.pubkey.y) ? mp_unsigned_bin_size(self->key.pubkey.y) : 0;
        if (siz>10000) {
          croak("FATAL: key2hash failed - 'pub_y' too big number");
        }
        if (siz>0) {
          mp_tohex(self->key.pubkey.y, buf);
          not_used = hv_store(rv_hash, "pub_y", 5, newSVpv(buf, strlen(buf)), 0);
        }
        else{
          not_used = hv_store(rv_hash, "pub_y", 5, newSVpv("", 0), 0);
        }
        /* =====> curve_... */
        if (self->key.dp) {
          not_used = hv_store(rv_hash, "curve_name",  10, newSVpv(self->key.dp->name,  strlen(self->key.dp->name)), 0);
          not_used = hv_store(rv_hash, "curve_prime", 11, newSVpv(self->key.dp->prime, strlen(self->key.dp->prime)), 0);
          not_used = hv_store(rv_hash, "curve_A",      7, newSVpv(self->key.dp->A,     strlen(self->key.dp->A)), 0);
          not_used = hv_store(rv_hash, "curve_B",      7, newSVpv(self->key.dp->B,     strlen(self->key.dp->B)), 0);
          not_used = hv_store(rv_hash, "curve_order", 11, newSVpv(self->key.dp->order, strlen(self->key.dp->order)), 0);
          not_used = hv_store(rv_hash, "curve_Gx",     8, newSVpv(self->key.dp->Gx,    strlen(self->key.dp->Gx)), 0);
          not_used = hv_store(rv_hash, "curve_Gy",     8, newSVpv(self->key.dp->Gy,    strlen(self->key.dp->Gy)), 0);
          not_used = hv_store(rv_hash, "curve_cofactor", 14, newSViv(self->key.dp->cofactor), 0);
          {
            mp_int p_num;
            mp_init(&p_num);
            mp_read_radix(&p_num, self->key.dp->prime, 16);
            not_used = hv_store(rv_hash, "curve_bytes", 11, newSViv(mp_unsigned_bin_size(&p_num)), 0);
            not_used = hv_store(rv_hash, "curve_bits",  10, newSViv(mp_count_bits(&p_num)), 0);
            mp_clear(&p_num);
          }
        }
        /* =====> size */
        not_used = hv_store(rv_hash, "size", 4, newSViv(ecc_get_size(&self->key)), 0);
        /* =====> type */
        not_used = hv_store(rv_hash, "type", 4, newSViv(self->key.type), 0);
        if (not_used) not_used = NULL; /* just silence the warning: variable 'not_used' set but not used */
        RETVAL = newRV_noinc((SV*)rv_hash);
#line 7452 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PK__ECC_export_key_der); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__ECC_export_key_der)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, type");
    {
	SV *	RETVAL;
	Crypt__PK__ECC	self;
	char *        type = (SvOK(ST(1))) ? SvPV_nolen(ST(1)) : NULL
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::ECC")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__ECC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::ECC::export_key_der",
			"self", "Crypt::PK::ECC")
;
#line 177 "./inc/CryptX_PK_ECC.xs.inc"
    {
        int rv;
        unsigned char out[4096];
        unsigned long int out_len = 4096;

        RETVAL = newSVpvn(NULL, 0); /* undef */
        if (strnEQ(type, "private", 7)) {
          rv = ecc_export_full(out, &out_len, PK_PRIVATE, &self->key);
          if (rv != CRYPT_OK) croak("FATAL: ecc_export(PK_PRIVATE) failed: %s", error_to_string(rv));
          RETVAL = newSVpvn((char*)out, out_len);
        }
        else if (strnEQ(type, "public", 6)) {
          rv = ecc_export_full(out, &out_len, PK_PUBLIC, &self->key);
          if (rv != CRYPT_OK) croak("FATAL: ecc_export(PK_PUBLIC) failed: %s", error_to_string(rv));
          RETVAL = newSVpvn((char*)out, out_len);
        }
        else {
          croak("FATAL: export_key_der invalid type '%s'", type);
        }
    }
#line 7502 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PK__ECC_export_key_raw); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__ECC_export_key_raw)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, type");
    {
	SV *	RETVAL;
	Crypt__PK__ECC	self;
	char *        type = (SvOK(ST(1))) ? SvPV_nolen(ST(1)) : NULL
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::ECC")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__ECC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::ECC::export_key_raw",
			"self", "Crypt::PK::ECC")
;
#line 203 "./inc/CryptX_PK_ECC.xs.inc"
    {
        int rv;
        unsigned char out[4096];
        unsigned long int out_len = sizeof(out);

        RETVAL = newSVpvn(NULL, 0); /* undef */
        if (strnEQ(type, "private", 7)) {
          rv = ecc_export_raw(out, &out_len, PK_PRIVATE, &self->key);
          if (rv != CRYPT_OK) croak("FATAL: ecc_export_raw(private) failed: %s", error_to_string(rv));
          RETVAL = newSVpvn((char*)out, out_len);
        }
        else if (strnEQ(type, "public_compressed", 17)) {
          rv = ecc_export_raw(out, &out_len, PK_PUBLIC_COMPRESSED, &self->key);
          if (rv != CRYPT_OK) croak("FATAL: ecc_export_raw(public_compressed) failed: %s", error_to_string(rv));
          RETVAL = newSVpvn((char*)out, out_len);
        }
        else if (strnEQ(type, "public", 6)) {
          rv = ecc_export_raw(out, &out_len, PK_PUBLIC, &self->key);
          if (rv != CRYPT_OK) croak("FATAL: ecc_export_raw(public) failed: %s", error_to_string(rv));
          RETVAL = newSVpvn((char*)out, out_len);
        }
        else {
          croak("FATAL: export_key_raw invalid type '%s'", type);
        }
    }
#line 7557 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PK__ECC__encrypt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__ECC__encrypt)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, data, hash_name");
    {
	SV *	RETVAL;
	Crypt__PK__ECC	self;
	SV *	data = ST(1)
;
	char *        hash_name = (SvOK(ST(2))) ? SvPV_nolen(ST(2)) : NULL
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::ECC")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__ECC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::ECC::_encrypt",
			"self", "Crypt::PK::ECC")
;
#line 234 "./inc/CryptX_PK_ECC.xs.inc"
    {
        int rv, hash_id;
        unsigned char *data_ptr=NULL;
        STRLEN data_len=0;
        unsigned char buffer[1024];
        unsigned long buffer_len = 1024;

        data_ptr = (unsigned char *)SvPVbyte(data, data_len);

        hash_id = find_hash(hash_name);
        if(hash_id==-1) croak("FATAL: find_hash failed for '%s'", hash_name);
        rv = ecc_encrypt_key(data_ptr, (unsigned long)data_len, buffer, &buffer_len,
                             &self->yarrow_prng_state, self->yarrow_prng_index,
                             hash_id, &self->key);
        if (rv != CRYPT_OK) croak("FATAL: ecc_encrypt_key failed: %s", error_to_string(rv));
        RETVAL = newSVpvn((char*)buffer, buffer_len);
    }
#line 7606 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PK__ECC__decrypt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__ECC__decrypt)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, data");
    {
	SV *	RETVAL;
	Crypt__PK__ECC	self;
	SV *	data = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::ECC")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__ECC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::ECC::_decrypt",
			"self", "Crypt::PK::ECC")
;
#line 257 "./inc/CryptX_PK_ECC.xs.inc"
    {
        int rv;
        unsigned char *data_ptr=NULL;
        STRLEN data_len=0;
        unsigned char buffer[1024];
        unsigned long buffer_len = 1024;

        data_ptr = (unsigned char *)SvPVbyte(data, data_len);

        rv = ecc_decrypt_key(data_ptr, (unsigned long)data_len, buffer, &buffer_len, &self->key);
        if (rv != CRYPT_OK) croak("FATAL: ecc_decrypt_key_ex failed: %s", error_to_string(rv));
        RETVAL = newSVpvn((char*)buffer, buffer_len);
    }
#line 7649 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PK__ECC__sign); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__ECC__sign)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "self, data");
    {
	SV *	RETVAL;
	Crypt__PK__ECC	self;
	SV *	data = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::ECC")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__ECC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"self", "Crypt::PK::ECC")
;
#line 278 "./inc/CryptX_PK_ECC.xs.inc"
    {
        int rv;
        unsigned char *data_ptr=NULL;
        STRLEN data_len=0;
        unsigned char buffer[1024];
        unsigned long buffer_len = 1024;

        data_ptr = (unsigned char *)SvPVbyte(data, data_len);

        if (ix == 1) {
          rv = ecc_sign_hash_rfc7518(data_ptr, (unsigned long)data_len, buffer, &buffer_len,
                             &self->yarrow_prng_state, self->yarrow_prng_index,
                             &self->key);
        }
        else {
          rv = ecc_sign_hash(data_ptr, (unsigned long)data_len, buffer, &buffer_len,
                             &self->yarrow_prng_state, self->yarrow_prng_index,
                             &self->key);
        }
        if (rv != CRYPT_OK) croak("FATAL: ecc_sign_hash_ex failed: %s", error_to_string(rv));
        RETVAL = newSVpvn((char*)buffer, buffer_len);
    }
#line 7702 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PK__ECC__verify); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__ECC__verify)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 3)
       croak_xs_usage(cv,  "self, sig, data");
    {
	int	RETVAL;
	dXSTARG;
	Crypt__PK__ECC	self;
	SV *	sig = ST(1)
;
	SV *	data = ST(2)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::ECC")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__ECC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"self", "Crypt::PK::ECC")
;
#line 308 "./inc/CryptX_PK_ECC.xs.inc"
    {
        int rv, stat;
        unsigned char *data_ptr=NULL;
        STRLEN data_len=0;
        unsigned char *sig_ptr=NULL;
        STRLEN sig_len=0;

        data_ptr = (unsigned char *)SvPVbyte(data, data_len);
        sig_ptr = (unsigned char *)SvPVbyte(sig, sig_len);

        RETVAL = 1;
        if (ix == 1) {
          rv = ecc_verify_hash_rfc7518(sig_ptr, (unsigned long)sig_len, data_ptr, (unsigned long)data_len, &stat, &self->key);
        }
        else {
          rv = ecc_verify_hash(sig_ptr, (unsigned long)sig_len, data_ptr, (unsigned long)data_len, &stat, &self->key);
        }
        if (rv != CRYPT_OK || stat != 1) RETVAL = 0;
    }
#line 7755 "CryptX.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PK__ECC_shared_secret); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__ECC_shared_secret)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, pubkey");
    {
	SV *	RETVAL;
	Crypt__PK__ECC	self;
	Crypt__PK__ECC	pubkey;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::ECC")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__ECC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::ECC::shared_secret",
			"self", "Crypt::PK::ECC")
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Crypt::PK::ECC")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    pubkey = INT2PTR(Crypt__PK__ECC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::ECC::shared_secret",
			"pubkey", "Crypt::PK::ECC")
;
#line 333 "./inc/CryptX_PK_ECC.xs.inc"
    {
        int rv;
        unsigned char buffer[1024];
        unsigned long buffer_len = 1024;

        rv = ecc_shared_secret(&self->key, &pubkey->key, buffer, &buffer_len);
        if (rv != CRYPT_OK) croak("FATAL: ecc_shared_secret failed: %s", error_to_string(rv));
        RETVAL = newSVpvn((char*)buffer, buffer_len);
    }
#line 7802 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PK__ECC_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__ECC_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__PK__ECC	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__ECC,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Crypt::PK::ECC::DESTROY",
			"self")
;
#line 348 "./inc/CryptX_PK_ECC.xs.inc"
        _ecc_free_key(&self->key, &self->dp);
        Safefree(self);
#line 7831 "CryptX.c"
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'inc/CryptX_PK_DH.xs.inc' from 'inc/CryptX_PK_ECC.xs.inc' */


XS_EUPXS(XS_Crypt__PK__DH__new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__DH__new)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	Crypt__PK__DH	RETVAL;
#line 6 "./inc/CryptX_PK_DH.xs.inc"
    {
        int rv;
        Newz(0, RETVAL, 1, struct dh_struct);
        if (!RETVAL) croak("FATAL: Newz failed");
        RETVAL->key.type = -1;
        RETVAL->yarrow_prng_index = find_prng("yarrow");
        if(RETVAL->yarrow_prng_index==-1) croak("FATAL: find_prng('yarrow') failed");
        rv = rng_make_prng(256, RETVAL->yarrow_prng_index, &RETVAL->yarrow_prng_state, NULL);
        if (rv != CRYPT_OK) croak("FATAL: rng_make_prng failed: %s", error_to_string(rv));
    }
#line 7859 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::PK::DH", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PK__DH__generate_key); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__DH__generate_key)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "self, key_size=256");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Crypt__PK__DH	self;
	int	key_size;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::DH")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__DH,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::DH::_generate_key",
			"self", "Crypt::PK::DH")
;

	if (items < 2)
	    key_size = 256;
	else {
	    key_size = (int)SvIV(ST(1))
;
	}
#line 22 "./inc/CryptX_PK_DH.xs.inc"
    {
        int rv;
        /* add a small random entropy before generating key - not necessary as we have initialized prng with 256bit entropy in _new() */
        rv = rng_make_prng(64, self->yarrow_prng_index, &self->yarrow_prng_state, NULL);
        if (rv != CRYPT_OK) croak("FATAL: rng_make_prng failed: %s", error_to_string(rv));
        /* gen the key */
        rv = dh_make_key(&self->yarrow_prng_state, self->yarrow_prng_index, key_size, &self->key);
        if (rv != CRYPT_OK) croak("FATAL: dh_make_key failed: %s", error_to_string(rv));
        XPUSHs(ST(0)); /* return self */
    }
#line 7910 "CryptX.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Crypt__PK__DH__generate_key_ex); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__DH__generate_key_ex)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, g, p");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Crypt__PK__DH	self;
	SV *	g = ST(1)
;
	SV *	p = ST(2)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::DH")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__DH,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::DH::_generate_key_ex",
			"self", "Crypt::PK::DH")
;
#line 36 "./inc/CryptX_PK_DH.xs.inc"
    {
        int rv;
        STRLEN p_len = 0;
        STRLEN g_len = 0;
        unsigned char *p_ptr=NULL;
        unsigned char *g_ptr=NULL;

        p_ptr = (unsigned char *)SvPVbyte(p, p_len);
        g_ptr = (unsigned char *)SvPVbyte(g, g_len);

        /* add a small random entropy before generating key - not necessary as we have initialized prng with 256bit entropy in _new() */
        rv = rng_make_prng(64, self->yarrow_prng_index, &self->yarrow_prng_state, NULL);
        if (rv != CRYPT_OK) croak("FATAL: rng_make_prng failed: %s", error_to_string(rv));
        /* gen the key */
        rv = dh_make_key_ex(&self->yarrow_prng_state, self->yarrow_prng_index, (const char *) g_ptr, (const char *) p_ptr, &self->key);
        if (rv != CRYPT_OK) croak("FATAL: dh_make_key_ex failed: %s", error_to_string(rv));
        XPUSHs(ST(0)); /* return self */
    }
#line 7960 "CryptX.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Crypt__PK__DH__import); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__DH__import)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, key_data");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Crypt__PK__DH	self;
	SV *	key_data = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::DH")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__DH,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::DH::_import",
			"self", "Crypt::PK::DH")
;
#line 58 "./inc/CryptX_PK_DH.xs.inc"
    {
        int rv;
        unsigned char *data=NULL;
        STRLEN data_len=0;

        data = (unsigned char *)SvPVbyte(key_data, data_len);
        if (self->key.type != -1) { dh_free(&self->key); self->key.type = -1; }
        rv = dh_import(data, (unsigned long)data_len, &self->key);
        if (rv != CRYPT_OK) croak("FATAL: dh_import failed: %s", error_to_string(rv));
        XPUSHs(ST(0)); /* return self */
    }
#line 8001 "CryptX.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Crypt__PK__DH__import_raw); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__DH__import_raw)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "self, raw_key, type, g, p");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Crypt__PK__DH	self;
	SV *	raw_key = ST(1)
;
	int	type = (int)SvIV(ST(2))
;
	char *        g = (SvOK(ST(3))) ? SvPV_nolen(ST(3)) : NULL
;
	char *        p = (SvOK(ST(4))) ? SvPV_nolen(ST(4)) : NULL
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::DH")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__DH,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::DH::_import_raw",
			"self", "Crypt::PK::DH")
;
#line 73 "./inc/CryptX_PK_DH.xs.inc"
    {
        int rv;
        unsigned char *data=NULL;
        STRLEN data_len=0;

        data = (unsigned char *)SvPVbyte(raw_key, data_len);
        if (self->key.type != -1) { dh_free(&self->key); self->key.type = -1; }
        /* public */
        if (type == 0) {
          rv = dh_import_raw(data, (unsigned long)data_len, PK_PUBLIC, g, p, &self->key);
          if (rv != CRYPT_OK) croak("FATAL: dh_import_raw failed: %s", error_to_string(rv));
        }
        /* private */
        else if (type == 1) {
          rv = dh_import_raw(data, (unsigned long)data_len, PK_PRIVATE, g, p, &self->key);
          if (rv != CRYPT_OK) croak("FATAL: dh_import_raw failed: %s", error_to_string(rv));
        }
        else {
          croak("FATAL: import_raw invalid type '%d'", type);
        }

        XPUSHs(ST(0)); /* return self */
    }
#line 8060 "CryptX.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Crypt__PK__DH_is_private); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__DH_is_private)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	int	RETVAL;
	dXSTARG;
	Crypt__PK__DH	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::DH")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__DH,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::DH::is_private",
			"self", "Crypt::PK::DH")
;
#line 100 "./inc/CryptX_PK_DH.xs.inc"
        if (self->key.type == -1) XSRETURN_UNDEF;
        RETVAL = (self->key.type == PK_PRIVATE) ? 1 : 0;
#line 8090 "CryptX.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PK__DH_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__DH_size)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	int	RETVAL;
	dXSTARG;
	Crypt__PK__DH	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::DH")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__DH,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::DH::size",
			"self", "Crypt::PK::DH")
;
#line 108 "./inc/CryptX_PK_DH.xs.inc"
        if (self->key.type == -1) XSRETURN_UNDEF;
        RETVAL = dh_get_size(&self->key);
#line 8120 "CryptX.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PK__DH_key2hash); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__DH_key2hash)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
#line 116 "./inc/CryptX_PK_DH.xs.inc"
        HV *rv_hash;
        long siz;
        char buf[20001];
        SV **not_used;
#line 8139 "CryptX.c"
	SV *	RETVAL;
	Crypt__PK__DH	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::DH")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__DH,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::DH::key2hash",
			"self", "Crypt::PK::DH")
;
#line 121 "./inc/CryptX_PK_DH.xs.inc"
        if (self->key.type == -1) XSRETURN_UNDEF;
        rv_hash = newHV();
        /* =====> x */
        siz = (self->key.x) ? mp_unsigned_bin_size(self->key.x) : 0;
        if (siz>10000) {
          croak("FATAL: key2hash failed - 'x' too big number");
        }
        if (siz>0) {
          mp_tohex(self->key.x, buf);
          not_used = hv_store(rv_hash, "x", 1, newSVpv(buf, strlen(buf)), 0);
        }
        else{
          not_used = hv_store(rv_hash, "x", 1, newSVpv("", 0), 0);
        }
        /* =====> y */
        siz = (self->key.y) ? mp_unsigned_bin_size(self->key.y) : 0;
        if (siz>10000) {
          croak("FATAL: key2hash failed - 'y' too big number");
        }
        if (siz>0) {
          mp_tohex(self->key.y, buf);
          not_used = hv_store(rv_hash, "y", 1, newSVpv(buf, strlen(buf)), 0);
        }
        else{
          not_used = hv_store(rv_hash, "y", 1, newSVpv("", 0), 0);
        }
        /* =====> p */
        siz = (self->key.prime) ? mp_unsigned_bin_size(self->key.prime) : 0;
        if (siz>10000) {
          croak("FATAL: key2hash failed - 'p' too big number");
        }
        if (siz>0) {
          mp_tohex(self->key.prime, buf);
          not_used = hv_store(rv_hash, "p", 1, newSVpv(buf, strlen(buf)), 0);
        }
        else {
          not_used = hv_store(rv_hash, "p", 1, newSVpv("", 0), 0);
        }

        /* =====> g */
        siz = (self->key.base) ? mp_unsigned_bin_size(self->key.base) : 0;
        if (siz>10000) {
          croak("FATAL: key2hash failed - 'g' too big number");
        }
        if (siz>0) {
          mp_tohex(self->key.base, buf);
          not_used = hv_store(rv_hash, "g", 1, newSVpv(buf, strlen(buf)), 0);
        }
        else {
          not_used = hv_store(rv_hash, "g", 1, newSVpv("", 0), 0);
        }
        /* =====> size */
        not_used = hv_store(rv_hash, "size", 4, newSViv(dh_get_size(&self->key)), 0);
        /* =====> type */
        not_used = hv_store(rv_hash, "type", 4, newSViv(self->key.type), 0);
        if (not_used) not_used = NULL; /* just silence the warning: variable 'not_used' set but not used */
        RETVAL = newRV_noinc((SV*)rv_hash);
#line 8210 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PK__DH_params2hash); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__DH_params2hash)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
#line 184 "./inc/CryptX_PK_DH.xs.inc"
        HV *rv_hash;
        long siz;
        char buf[20001];
        SV **not_used;
#line 8230 "CryptX.c"
	SV *	RETVAL;
	Crypt__PK__DH	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::DH")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__DH,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::DH::params2hash",
			"self", "Crypt::PK::DH")
;
#line 189 "./inc/CryptX_PK_DH.xs.inc"
        if (self->key.type == -1) XSRETURN_UNDEF;
        rv_hash = newHV();
        /* =====> p */
        siz = (self->key.prime) ? mp_unsigned_bin_size(self->key.prime) : 0;
        if (siz>10000) {
          croak("FATAL: key2hash failed - 'p' too big number");
        }
        if (siz>0) {
          mp_tohex(self->key.prime, buf);
          not_used = hv_store(rv_hash, "p", 1, newSVpv(buf, strlen(buf)), 0);
        }
        else {
          not_used = hv_store(rv_hash, "p", 1, newSVpv("", 0), 0);
        }

        /* =====> g */
        siz = (self->key.base) ? mp_unsigned_bin_size(self->key.base) : 0;
        if (siz>10000) {
          croak("FATAL: key2hash failed - 'g' too big number");
        }
        if (siz>0) {
          mp_tohex(self->key.base, buf);
          not_used = hv_store(rv_hash, "g", 1, newSVpv(buf, strlen(buf)), 0);
        }
        else {
          not_used = hv_store(rv_hash, "g", 1, newSVpv("", 0), 0);
        }
        if (not_used) not_used = NULL; /* just silence the warning: variable 'not_used' set but not used */
        RETVAL = newRV_noinc((SV*)rv_hash);
#line 8273 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PK__DH_export_key); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__DH_export_key)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, type");
    {
	SV *	RETVAL;
	Crypt__PK__DH	self;
	char *        type = (SvOK(ST(1))) ? SvPV_nolen(ST(1)) : NULL
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::DH")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__DH,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::DH::export_key",
			"self", "Crypt::PK::DH")
;
#line 224 "./inc/CryptX_PK_DH.xs.inc"
    {
        int rv;
        unsigned long int out_len = 4096;
        unsigned char out[4096];

        RETVAL = newSVpvn(NULL, 0); /* undef */
        if (strnEQ(type, "private", 7)) {
          rv = dh_export(out, &out_len, PK_PRIVATE, &self->key);
          if (rv != CRYPT_OK) croak("FATAL: dh_export(PK_PRIVATE) failed: %s", error_to_string(rv));
          RETVAL = newSVpvn((char*)out, out_len);
        }
        else if (strnEQ(type, "public", 6)) {
          rv = dh_export(out, &out_len, PK_PUBLIC, &self->key);
          if (rv != CRYPT_OK) croak("FATAL: dh_export(PK_PUBLIC) failed: %s", error_to_string(rv));
          RETVAL = newSVpvn((char*)out, out_len);
        }
        else {
          croak("FATAL: export_key_der invalid type '%s'", type);
        }
    }
#line 8323 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PK__DH__encrypt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__DH__encrypt)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, data, hash_name");
    {
	SV *	RETVAL;
	Crypt__PK__DH	self;
	SV *	data = ST(1)
;
	char *        hash_name = (SvOK(ST(2))) ? SvPV_nolen(ST(2)) : NULL
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::DH")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__DH,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::DH::_encrypt",
			"self", "Crypt::PK::DH")
;
#line 250 "./inc/CryptX_PK_DH.xs.inc"
    {
        int rv, hash_id;
        unsigned char *data_ptr=NULL;
        STRLEN data_len=0;
        unsigned long buffer_len = 1024;
        unsigned char buffer[1024];

        data_ptr = (unsigned char *)SvPVbyte(data, data_len);

        hash_id = find_hash(hash_name);
        if(hash_id==-1) croak("FATAL: find_hash failed for '%s'", hash_name);
        rv = dh_encrypt_key(data_ptr, (unsigned long)data_len, buffer, &buffer_len,
                             &self->yarrow_prng_state, self->yarrow_prng_index,
                             hash_id, &self->key);
        if (rv != CRYPT_OK) croak("FATAL: dh_encrypt_key failed: %s", error_to_string(rv));
        RETVAL = newSVpvn((char*)buffer, buffer_len);
    }
#line 8372 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PK__DH__decrypt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__DH__decrypt)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, data");
    {
	SV *	RETVAL;
	Crypt__PK__DH	self;
	SV *	data = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::DH")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__DH,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::DH::_decrypt",
			"self", "Crypt::PK::DH")
;
#line 273 "./inc/CryptX_PK_DH.xs.inc"
    {
        int rv;
        unsigned char *data_ptr=NULL;
        STRLEN data_len=0;
        unsigned long buffer_len = 1024;
        unsigned char buffer[1024];

        data_ptr = (unsigned char *)SvPVbyte(data, data_len);

        rv = dh_decrypt_key(data_ptr, (unsigned long)data_len, buffer, &buffer_len, &self->key);
        if (rv != CRYPT_OK) croak("FATAL: dh_decrypt_key failed: %s", error_to_string(rv));
        RETVAL = newSVpvn((char*)buffer, buffer_len);
    }
#line 8415 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PK__DH__sign); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__DH__sign)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, data");
    {
	SV *	RETVAL;
	Crypt__PK__DH	self;
	SV *	data = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::DH")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__DH,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::DH::_sign",
			"self", "Crypt::PK::DH")
;
#line 292 "./inc/CryptX_PK_DH.xs.inc"
    {
        int rv;
        unsigned char *data_ptr=NULL;
        STRLEN data_len=0;
        unsigned long buffer_len = 1024;
        unsigned char buffer[1024];

        data_ptr = (unsigned char *)SvPVbyte(data, data_len);

        rv = dh_sign_hash(data_ptr, (unsigned long)data_len, buffer, &buffer_len,
                           &self->yarrow_prng_state, self->yarrow_prng_index,
                           &self->key);
        if (rv != CRYPT_OK) croak("FATAL: dh_sign_hash failed: %s", error_to_string(rv));
        RETVAL = newSVpvn((char*)buffer, buffer_len);
    }
#line 8460 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PK__DH__verify); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__DH__verify)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, sig, data");
    {
	int	RETVAL;
	dXSTARG;
	Crypt__PK__DH	self;
	SV *	sig = ST(1)
;
	SV *	data = ST(2)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::DH")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__DH,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::DH::_verify",
			"self", "Crypt::PK::DH")
;
#line 313 "./inc/CryptX_PK_DH.xs.inc"
    {
        int rv, stat;
        unsigned char *data_ptr=NULL;
        STRLEN data_len=0;
        unsigned char *sig_ptr=NULL;
        STRLEN sig_len=0;

        data_ptr = (unsigned char *)SvPVbyte(data, data_len);
        sig_ptr = (unsigned char *)SvPVbyte(sig, sig_len);

        RETVAL = 1;
        rv = dh_verify_hash(sig_ptr, (unsigned long)sig_len, data_ptr, (unsigned long)data_len, &stat, &self->key);
        if (rv != CRYPT_OK || stat != 1) RETVAL = 0;
    }
#line 8507 "CryptX.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PK__DH_shared_secret); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__DH_shared_secret)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, pubkey");
    {
	SV *	RETVAL;
	Crypt__PK__DH	self;
	Crypt__PK__DH	pubkey;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::DH")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__DH,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::DH::shared_secret",
			"self", "Crypt::PK::DH")
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Crypt::PK::DH")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    pubkey = INT2PTR(Crypt__PK__DH,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::DH::shared_secret",
			"pubkey", "Crypt::PK::DH")
;
#line 333 "./inc/CryptX_PK_DH.xs.inc"
    {
        int rv;
        unsigned long buffer_len = 1024;
        unsigned char buffer[1024];

        rv = dh_shared_secret(&self->key, &pubkey->key, buffer, &buffer_len);
        if (rv != CRYPT_OK) croak("FATAL: dh_shared_secret failed: %s", error_to_string(rv));
        RETVAL = newSVpvn((char*)buffer, buffer_len);
    }
#line 8554 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PK__DH_export_key_raw); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__DH_export_key_raw)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, type");
    {
	SV *	RETVAL;
	Crypt__PK__DH	self;
	char *        type = (SvOK(ST(1))) ? SvPV_nolen(ST(1)) : NULL
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::DH")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__DH,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::DH::export_key_raw",
			"self", "Crypt::PK::DH")
;
#line 348 "./inc/CryptX_PK_DH.xs.inc"
    {
        int rv;
        unsigned long len, buffer_len = 1024;
        unsigned char buffer[1024];
	void *key;

        RETVAL = newSVpvn(NULL, 0); /* undef */
        if (strnEQ(type, "private", 7)) {
		key = self->key.x;
        }
        else if (strnEQ(type, "public", 6)) {
		key = self->key.y;
        }
        else {
          croak("FATAL: export_key_raw: invalid type '%s'", type);
        }

        len = (unsigned long)mp_unsigned_bin_size(key);
        if (buffer_len < len) {
            croak("FATAL: %s", error_to_string(CRYPT_BUFFER_OVERFLOW));
        }
        rv = mp_to_unsigned_bin(key, buffer);
        if (rv != CRYPT_OK) croak("FATAL: %s", error_to_string(rv));
        RETVAL = newSVpvn((char*)buffer, len);
    }
#line 8609 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PK__DH__is_pubkey_valid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__DH__is_pubkey_valid)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	int	RETVAL;
	dXSTARG;
	Crypt__PK__DH	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::DH")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__DH,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::DH::_is_pubkey_valid",
			"self", "Crypt::PK::DH")
;
#line 379 "./inc/CryptX_PK_DH.xs.inc"
    {
        int rv, i, bits_set = 0;
        mp_int one, two, p1, *y;
        mp_digit digit;

        if ((rv = mp_init_multi(&one, &two, &p1, NULL)) != MP_OKAY) {
            croak("FATAL: %s", error_to_string(rv));
        }

        y = self->key.y;
        mp_set(&one, 1);
        mp_set(&two, 2);

	/* p1 = p-1 */
        if ((rv = mp_sub(self->key.prime, &one, &p1)) != MP_OKAY) {
            croak("FATAL: %s", error_to_string(rv));
        }
	/* valid public key cannot be negative */
        if (y->sign == MP_NEG) {
            RETVAL = 0;
        }
	/* valid public key != 1 */
        else if (mp_cmp(y, &one) == MP_EQ) {
            RETVAL = 0;
        }
	/* public key cannot be > p-1 */
        else if (mp_cmp(y, &p1) == MP_GT) {
            RETVAL = 0;
        }
	/* if base == 2, public must have more than one bit set */
        else if (mp_cmp(self->key.base, &two) == MP_EQ) {
            for (i = 0; i < y->used; i++) {
                digit = y->dp[i];
                while (digit > ((mp_digit) 0)) {
                    if (digit & ((mp_digit) 1))
                        bits_set++;
                    digit >>= ((mp_digit) 1);
                }
            }
            if (bits_set > 1)
                RETVAL = 1;
            else RETVAL = 0;
        }
        else RETVAL = 1;
    }
#line 8683 "CryptX.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PK__DH_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__DH_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__PK__DH	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__DH,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Crypt::PK::DH::DESTROY",
			"self")
;
#line 430 "./inc/CryptX_PK_DH.xs.inc"
        if (self->key.type != -1) { dh_free(&self->key); self->key.type = -1; }
        Safefree(self);
#line 8711 "CryptX.c"
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'inc/CryptX_PK_DSA.xs.inc' from 'inc/CryptX_PK_DH.xs.inc' */


XS_EUPXS(XS_Crypt__PK__DSA__new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__DSA__new)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	Crypt__PK__DSA	RETVAL;
#line 6 "./inc/CryptX_PK_DSA.xs.inc"
    {
        int rv;
        Newz(0, RETVAL, 1, struct dsa_struct);
        if (!RETVAL) croak("FATAL: Newz failed");
        RETVAL->key.type = -1;
        RETVAL->yarrow_prng_index = find_prng("yarrow");
        if(RETVAL->yarrow_prng_index==-1) croak("FATAL: find_prng('yarrow') failed");
        rv = rng_make_prng(256, RETVAL->yarrow_prng_index, &RETVAL->yarrow_prng_state, NULL);
        if (rv != CRYPT_OK) croak("FATAL: rng_make_prng failed: %s", error_to_string(rv));
    }
#line 8739 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::PK::DSA", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PK__DSA_generate_key); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__DSA_generate_key)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "self, group_size=30, modulus_size=256");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Crypt__PK__DSA	self;
	int	group_size;
	int	modulus_size;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::DSA")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__DSA,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::DSA::generate_key",
			"self", "Crypt::PK::DSA")
;

	if (items < 2)
	    group_size = 30;
	else {
	    group_size = (int)SvIV(ST(1))
;
	}

	if (items < 3)
	    modulus_size = 256;
	else {
	    modulus_size = (int)SvIV(ST(2))
;
	}
#line 22 "./inc/CryptX_PK_DSA.xs.inc"
    {
        int rv;
        /* add a small random entropy before generating key - not necessary as we have initialized prng with 256bit entropy in _new() */
        rv = rng_make_prng(64, self->yarrow_prng_index, &self->yarrow_prng_state, NULL);
        if (rv != CRYPT_OK) croak("FATAL: rng_make_prng failed: %s", error_to_string(rv));
        /* gen the key */
        rv = dsa_make_key(&self->yarrow_prng_state, self->yarrow_prng_index, group_size, modulus_size, &self->key);
        if (rv != CRYPT_OK) croak("FATAL: dsa_make_key failed: %s", error_to_string(rv));
        XPUSHs(ST(0)); /* return self */
    }
#line 8798 "CryptX.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Crypt__PK__DSA__import); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__DSA__import)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, key_data");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Crypt__PK__DSA	self;
	SV *	key_data = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::DSA")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__DSA,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::DSA::_import",
			"self", "Crypt::PK::DSA")
;
#line 36 "./inc/CryptX_PK_DSA.xs.inc"
    {
        int rv;
        unsigned char *data=NULL;
        STRLEN data_len=0;

        data = (unsigned char *)SvPVbyte(key_data, data_len);
        if (self->key.type != -1) { dsa_free(&self->key); self->key.type = -1; }
        rv = dsa_import(data, (unsigned long)data_len, &self->key);
        if (rv != CRYPT_OK) croak("FATAL: dsa_import failed: %s", error_to_string(rv));
        XPUSHs(ST(0)); /* return self */
    }
#line 8839 "CryptX.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Crypt__PK__DSA__import_hex); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__DSA__import_hex)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "self, p, q, g, x, y");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Crypt__PK__DSA	self;
	char *        p = (SvOK(ST(1))) ? SvPV_nolen(ST(1)) : NULL
;
	char *        q = (SvOK(ST(2))) ? SvPV_nolen(ST(2)) : NULL
;
	char *        g = (SvOK(ST(3))) ? SvPV_nolen(ST(3)) : NULL
;
	char *        x = (SvOK(ST(4))) ? SvPV_nolen(ST(4)) : NULL
;
	char *        y = (SvOK(ST(5))) ? SvPV_nolen(ST(5)) : NULL
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::DSA")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__DSA,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::DSA::_import_hex",
			"self", "Crypt::PK::DSA")
;
#line 51 "./inc/CryptX_PK_DSA.xs.inc"
    {
        int rv;
        if (self->key.type != -1) { dsa_free(&self->key); self->key.type = -1; }
        rv = dsa_import_hex(p, q, g, x, y, &self->key);
        if (rv != CRYPT_OK) croak("FATAL: dsa_import_hex failed: %s", error_to_string(rv));
        XPUSHs(ST(0)); /* return self */
    }
#line 8884 "CryptX.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Crypt__PK__DSA_is_private); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__DSA_is_private)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	int	RETVAL;
	dXSTARG;
	Crypt__PK__DSA	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::DSA")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__DSA,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::DSA::is_private",
			"self", "Crypt::PK::DSA")
;
#line 62 "./inc/CryptX_PK_DSA.xs.inc"
        if (self->key.type == -1 || self->key.qord <= 0) XSRETURN_UNDEF;
        RETVAL = (self->key.type == PK_PRIVATE) ? 1 : 0;
#line 8914 "CryptX.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PK__DSA_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__DSA_size)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	int	RETVAL;
	dXSTARG;
	Crypt__PK__DSA	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::DSA")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__DSA,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::DSA::size",
			"self", "Crypt::PK::DSA")
;
#line 70 "./inc/CryptX_PK_DSA.xs.inc"
        if (self->key.type == -1 || self->key.qord <= 0) XSRETURN_UNDEF;
        RETVAL = mp_unsigned_bin_size(self->key.g);
#line 8944 "CryptX.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PK__DSA_size_q); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__DSA_size_q)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	int	RETVAL;
	dXSTARG;
	Crypt__PK__DSA	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::DSA")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__DSA,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::DSA::size_q",
			"self", "Crypt::PK::DSA")
;
#line 78 "./inc/CryptX_PK_DSA.xs.inc"
        if (self->key.type == -1 || self->key.qord <= 0) XSRETURN_UNDEF;
        RETVAL = self->key.qord;
#line 8974 "CryptX.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PK__DSA_key2hash); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__DSA_key2hash)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
#line 86 "./inc/CryptX_PK_DSA.xs.inc"
        HV *rv_hash;
        long siz;
        char buf[20001];
        SV **not_used;
#line 8993 "CryptX.c"
	SV *	RETVAL;
	Crypt__PK__DSA	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::DSA")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__DSA,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::DSA::key2hash",
			"self", "Crypt::PK::DSA")
;
#line 91 "./inc/CryptX_PK_DSA.xs.inc"
        if (self->key.type == -1 || self->key.qord <= 0) XSRETURN_UNDEF;
        rv_hash = newHV();
        /* =====> g */
        siz = (self->key.g) ? mp_unsigned_bin_size(self->key.g) : 0;
        if (siz>10000) {
          croak("FATAL: key2hash failed - 'g' too big number");
        }
        if (siz>0) {
          mp_tohex(self->key.g, buf);
          not_used = hv_store(rv_hash, "g", 1, newSVpv(buf, strlen(buf)), 0);
        }
        else{
          not_used = hv_store(rv_hash, "g", 1, newSVpv("", 0), 0);
        }
        /* =====> q */
        siz = (self->key.q) ? mp_unsigned_bin_size(self->key.q) : 0;
        if (siz>10000) {
          croak("FATAL: key2hash failed - 'q' too big number");
        }
        if (siz>0) {
          mp_tohex(self->key.q, buf);
          not_used = hv_store(rv_hash, "q", 1, newSVpv(buf, strlen(buf)), 0);
        }
        else{
          not_used = hv_store(rv_hash, "q", 1, newSVpv("", 0), 0);
        }
        /* =====> p */
        siz = (self->key.p) ? mp_unsigned_bin_size(self->key.p) : 0;
        if (siz>10000) {
          croak("FATAL: key2hash failed - 'p' too big number");
        }
        if (siz>0) {
          mp_tohex(self->key.p, buf);
          not_used = hv_store(rv_hash, "p", 1, newSVpv(buf, strlen(buf)), 0);
        }
        else{
          not_used = hv_store(rv_hash, "p", 1, newSVpv("", 0), 0);
        }
        /* =====> x */
        siz = (self->key.x) ? mp_unsigned_bin_size(self->key.x) : 0;
        if (siz>10000) {
          croak("FATAL: key2hash failed - 'x' too big number");
        }
        if (siz>0) {
          mp_tohex(self->key.x, buf);
          not_used = hv_store(rv_hash, "x", 1, newSVpv(buf, strlen(buf)), 0);
        }
        else{
          not_used = hv_store(rv_hash, "x", 1, newSVpv("", 0), 0);
        }
        /* =====> y */
        siz = (self->key.y) ? mp_unsigned_bin_size(self->key.y) : 0;
        if (siz>10000) {
          croak("FATAL: key2hash failed - 'y' too big number");
        }
        if (siz>0) {
          mp_tohex(self->key.y, buf);
          not_used = hv_store(rv_hash, "y", 1, newSVpv(buf, strlen(buf)), 0);
        }
        else{
          not_used = hv_store(rv_hash, "y", 1, newSVpv("", 0), 0);
        }
        /* =====> size */
        not_used = hv_store(rv_hash, "size", 4, newSViv(mp_unsigned_bin_size(self->key.q)), 0);
        /* =====> type */
        not_used = hv_store(rv_hash, "type", 4, newSViv(self->key.type), 0);
        if (not_used) not_used = NULL; /* just silence the warning: variable 'not_used' set but not used */
        RETVAL = newRV_noinc((SV*)rv_hash);
#line 9075 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PK__DSA_export_key_der); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__DSA_export_key_der)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, type");
    {
	SV *	RETVAL;
	Crypt__PK__DSA	self;
	char *        type = (SvOK(ST(1))) ? SvPV_nolen(ST(1)) : NULL
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::DSA")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__DSA,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::DSA::export_key_der",
			"self", "Crypt::PK::DSA")
;
#line 165 "./inc/CryptX_PK_DSA.xs.inc"
    {
        int rv;
        unsigned char out[4096];
        unsigned long int out_len = 4096;

        RETVAL = newSVpvn(NULL, 0); /* undef */
        if (strnEQ(type, "private", 7)) {
          rv = dsa_export(out, &out_len, PK_PRIVATE, &self->key);
          if (rv != CRYPT_OK) croak("FATAL: dsa_export(PK_PRIVATE) failed: %s", error_to_string(rv));
          RETVAL = newSVpvn((char*)out, out_len);
        }
        else if (strnEQ(type, "public", 6)) {
          rv = dsa_export(out, &out_len, PK_PUBLIC, &self->key);
          if (rv != CRYPT_OK) croak("FATAL: dsa_export(PK_PUBLIC|PK_STD) failed: %s", error_to_string(rv));
          RETVAL = newSVpvn((char*)out, out_len);
        }
        else {
          croak("FATAL: export_key_der invalid type '%s'", type);
        }
    }
#line 9125 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PK__DSA__encrypt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__DSA__encrypt)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, data, hash_name");
    {
	SV *	RETVAL;
	Crypt__PK__DSA	self;
	SV *	data = ST(1)
;
	char *        hash_name = (SvOK(ST(2))) ? SvPV_nolen(ST(2)) : NULL
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::DSA")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__DSA,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::DSA::_encrypt",
			"self", "Crypt::PK::DSA")
;
#line 191 "./inc/CryptX_PK_DSA.xs.inc"
    {
        int rv, hash_id;
        unsigned char *data_ptr=NULL;
        STRLEN data_len=0;
        unsigned char buffer[1024];
        unsigned long buffer_len = 1024;

        data_ptr = (unsigned char *)SvPVbyte(data, data_len);

        hash_id = find_hash(hash_name);
        if(hash_id==-1) croak("FATAL: find_hash failed for '%s'", hash_name);
        rv = dsa_encrypt_key(data_ptr, (unsigned long)data_len, buffer, &buffer_len,
                             &self->yarrow_prng_state, self->yarrow_prng_index,
                             hash_id, &self->key);
        if (rv != CRYPT_OK) croak("FATAL: dsa_encrypt_key failed: %s", error_to_string(rv));
        RETVAL = newSVpvn((char*)buffer, buffer_len);
    }
#line 9174 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PK__DSA__decrypt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__DSA__decrypt)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, data");
    {
	SV *	RETVAL;
	Crypt__PK__DSA	self;
	SV *	data = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::DSA")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__DSA,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::DSA::_decrypt",
			"self", "Crypt::PK::DSA")
;
#line 214 "./inc/CryptX_PK_DSA.xs.inc"
    {
        int rv;
        unsigned char *data_ptr=NULL;
        STRLEN data_len=0;
        unsigned char buffer[1024];
        unsigned long buffer_len = 1024;

        data_ptr = (unsigned char *)SvPVbyte(data, data_len);

        rv = dsa_decrypt_key(data_ptr, (unsigned long)data_len, buffer, &buffer_len, &self->key);
        if (rv != CRYPT_OK) croak("FATAL: dsa_decrypt_key_ex failed: %s", error_to_string(rv));
        RETVAL = newSVpvn((char*)buffer, buffer_len);
    }
#line 9217 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PK__DSA__sign); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__DSA__sign)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, data");
    {
	SV *	RETVAL;
	Crypt__PK__DSA	self;
	SV *	data = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::DSA")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__DSA,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::DSA::_sign",
			"self", "Crypt::PK::DSA")
;
#line 233 "./inc/CryptX_PK_DSA.xs.inc"
    {
        int rv;
        unsigned char *data_ptr=NULL;
        STRLEN data_len=0;
        unsigned char buffer[1024];
        unsigned long buffer_len = 1024;

        data_ptr = (unsigned char *)SvPVbyte(data, data_len);

        rv = dsa_sign_hash(data_ptr, (unsigned long)data_len, buffer, &buffer_len,
                           &self->yarrow_prng_state, self->yarrow_prng_index,
                           &self->key);
        if (rv != CRYPT_OK) croak("FATAL: dsa_sign_hash_ex failed: %s", error_to_string(rv));
        RETVAL = newSVpvn((char*)buffer, buffer_len);
    }
#line 9262 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PK__DSA__verify); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__DSA__verify)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, sig, data");
    {
	int	RETVAL;
	dXSTARG;
	Crypt__PK__DSA	self;
	SV *	sig = ST(1)
;
	SV *	data = ST(2)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::DSA")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__DSA,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::DSA::_verify",
			"self", "Crypt::PK::DSA")
;
#line 254 "./inc/CryptX_PK_DSA.xs.inc"
    {
        int rv, stat;
        unsigned char *data_ptr=NULL;
        STRLEN data_len=0;
        unsigned char *sig_ptr=NULL;
        STRLEN sig_len=0;

        data_ptr = (unsigned char *)SvPVbyte(data, data_len);
        sig_ptr = (unsigned char *)SvPVbyte(sig, sig_len);

        RETVAL = 1;
        rv = dsa_verify_hash(sig_ptr, (unsigned long)sig_len, data_ptr, (unsigned long)data_len, &stat, &self->key);
        if (rv != CRYPT_OK || stat != 1) RETVAL = 0;
    }
#line 9309 "CryptX.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PK__DSA_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__DSA_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__PK__DSA	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__DSA,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Crypt::PK::DSA::DESTROY",
			"self")
;
#line 274 "./inc/CryptX_PK_DSA.xs.inc"
        if (self->key.type != -1) { dsa_free(&self->key); self->key.type = -1; }
        Safefree(self);
#line 9337 "CryptX.c"
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'inc/CryptX_PK_RSA.xs.inc' from 'inc/CryptX_PK_DSA.xs.inc' */


XS_EUPXS(XS_Crypt__PK__RSA__new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__RSA__new)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	Crypt__PK__RSA	RETVAL;
#line 6 "./inc/CryptX_PK_RSA.xs.inc"
    {
        int rv;
        Newz(0, RETVAL, 1, struct rsa_struct);
        if (!RETVAL) croak("FATAL: Newz failed");
        RETVAL->key.type = -1;
        RETVAL->yarrow_prng_index = find_prng("yarrow");
        if(RETVAL->yarrow_prng_index==-1) croak("FATAL: find_prng('yarrow') failed");
        rv = rng_make_prng(256, RETVAL->yarrow_prng_index, &RETVAL->yarrow_prng_state, NULL);
        if (rv != CRYPT_OK) croak("FATAL: rng_make_prng failed: %s", error_to_string(rv));
    }
#line 9365 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::PK::RSA", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PK__RSA_generate_key); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__RSA_generate_key)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "self, key_size=256, key_e=65537");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Crypt__PK__RSA	self;
	int	key_size;
	long	key_e;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::RSA")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__RSA,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::RSA::generate_key",
			"self", "Crypt::PK::RSA")
;

	if (items < 2)
	    key_size = 256;
	else {
	    key_size = (int)SvIV(ST(1))
;
	}

	if (items < 3)
	    key_e = 65537;
	else {
	    key_e = (long)SvIV(ST(2))
;
	}
#line 22 "./inc/CryptX_PK_RSA.xs.inc"
    {
        /* key_size is in octets */
        int rv;
        /* add a small random entropy before generating key - not necessary as we have initialized prng with 256bit entropy in _new() */
        rv = rng_make_prng(64, self->yarrow_prng_index, &self->yarrow_prng_state, NULL);
        if (rv != CRYPT_OK) croak("FATAL: rng_make_prng failed: %s", error_to_string(rv));
        /* gen the key */
        rv = rsa_make_key(&self->yarrow_prng_state, self->yarrow_prng_index, key_size, key_e, &self->key);
        if (rv != CRYPT_OK) croak("FATAL: rsa_make_key failed: %s", error_to_string(rv));
        XPUSHs(ST(0)); /* return self */
    }
#line 9425 "CryptX.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Crypt__PK__RSA__import); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__RSA__import)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, key_data");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Crypt__PK__RSA	self;
	SV *	key_data = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::RSA")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__RSA,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::RSA::_import",
			"self", "Crypt::PK::RSA")
;
#line 37 "./inc/CryptX_PK_RSA.xs.inc"
    {
        int rv;
        unsigned char *data=NULL;
        STRLEN data_len=0;

        data = (unsigned char *)SvPVbyte(key_data, data_len);
        if (self->key.type != -1) { rsa_free(&self->key); self->key.type = -1; }
        rv = rsa_import(data, (unsigned long)data_len, &self->key);
        if (rv != CRYPT_OK) croak("FATAL: rsa_import failed: %s", error_to_string(rv));
        XPUSHs(ST(0)); /* return self */
    }
#line 9466 "CryptX.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Crypt__PK__RSA__import_pkcs8); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__RSA__import_pkcs8)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, key_data");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Crypt__PK__RSA	self;
	SV *	key_data = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::RSA")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__RSA,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::RSA::_import_pkcs8",
			"self", "Crypt::PK::RSA")
;
#line 52 "./inc/CryptX_PK_RSA.xs.inc"
    {
        int rv;
        unsigned char *data=NULL;
        STRLEN data_len=0;

        data = (unsigned char *)SvPVbyte(key_data, data_len);
        if (self->key.type != -1) { rsa_free(&self->key); self->key.type = -1; }
        rv = rsa_import_pkcs8(data, (unsigned long)data_len, &self->key);
        if (rv != CRYPT_OK) croak("FATAL: rsa_import_pkcs8 failed: %s", error_to_string(rv));
        XPUSHs(ST(0)); /* return self */
    }
#line 9507 "CryptX.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Crypt__PK__RSA__import_hex); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__RSA__import_hex)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 9)
       croak_xs_usage(cv,  "self, N, e, d=NULL, p=NULL, q=NULL, dP=NULL, dQ=NULL, qP=NULL");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Crypt__PK__RSA	self;
	char *        N = (SvOK(ST(1))) ? SvPV_nolen(ST(1)) : NULL
;
	char *        e = (SvOK(ST(2))) ? SvPV_nolen(ST(2)) : NULL
;
	char *	d;
	char *	p;
	char *	q;
	char *	dP;
	char *	dQ;
	char *	qP;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::RSA")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__RSA,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::RSA::_import_hex",
			"self", "Crypt::PK::RSA")
;

	if (items < 4)
	    d = NULL;
	else {
	d = (SvOK(ST(3))) ? SvPV_nolen(ST(3)) : NULL
;
	}

	if (items < 5)
	    p = NULL;
	else {
	p = (SvOK(ST(4))) ? SvPV_nolen(ST(4)) : NULL
;
	}

	if (items < 6)
	    q = NULL;
	else {
	q = (SvOK(ST(5))) ? SvPV_nolen(ST(5)) : NULL
;
	}

	if (items < 7)
	    dP = NULL;
	else {
	dP = (SvOK(ST(6))) ? SvPV_nolen(ST(6)) : NULL
;
	}

	if (items < 8)
	    dQ = NULL;
	else {
	dQ = (SvOK(ST(7))) ? SvPV_nolen(ST(7)) : NULL
;
	}

	if (items < 9)
	    qP = NULL;
	else {
	qP = (SvOK(ST(8))) ? SvPV_nolen(ST(8)) : NULL
;
	}
#line 67 "./inc/CryptX_PK_RSA.xs.inc"
    {
        int rv;
        if (self->key.type != -1) { rsa_free(&self->key); self->key.type = -1; }
        rv = rsa_import_hex(N, e, d, p, q, dP, dQ, qP, &self->key);
        if (rv != CRYPT_OK) croak("FATAL: rsa_import_hex failed: %s", error_to_string(rv));
        XPUSHs(ST(0)); /* return self */
    }
#line 9594 "CryptX.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Crypt__PK__RSA_is_private); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__RSA_is_private)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	int	RETVAL;
	dXSTARG;
	Crypt__PK__RSA	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::RSA")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__RSA,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::RSA::is_private",
			"self", "Crypt::PK::RSA")
;
#line 78 "./inc/CryptX_PK_RSA.xs.inc"
        if (self->key.type == -1 || self->key.N == NULL) XSRETURN_UNDEF;
        RETVAL = (self->key.type == PK_PRIVATE) ? 1 : 0;
#line 9624 "CryptX.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PK__RSA_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__RSA_size)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	int	RETVAL;
	dXSTARG;
	Crypt__PK__RSA	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::RSA")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__RSA,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::RSA::size",
			"self", "Crypt::PK::RSA")
;
#line 86 "./inc/CryptX_PK_RSA.xs.inc"
        if (self->key.type == -1 || self->key.N == NULL) XSRETURN_UNDEF;
        RETVAL = mp_unsigned_bin_size(self->key.N);
#line 9654 "CryptX.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PK__RSA_key2hash); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__RSA_key2hash)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
#line 94 "./inc/CryptX_PK_RSA.xs.inc"
        HV *rv_hash;
        long siz;
        char buf[20001];
        SV **not_used;
#line 9673 "CryptX.c"
	SV *	RETVAL;
	Crypt__PK__RSA	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::RSA")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__RSA,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::RSA::key2hash",
			"self", "Crypt::PK::RSA")
;
#line 99 "./inc/CryptX_PK_RSA.xs.inc"
        if (self->key.type == -1 || self->key.N == NULL) XSRETURN_UNDEF;
        rv_hash = newHV();
        /* =====> e */
        siz = (self->key.e) ? mp_unsigned_bin_size(self->key.e) : 0;
        if (siz>10000) {
          croak("FATAL: key2hash failed - 'e' too big number");
        }
        if (siz>0) {
          mp_tohex(self->key.e, buf);
          not_used = hv_store(rv_hash, "e", 1, newSVpv(buf, strlen(buf)), 0);
        }
        else{
          not_used = hv_store(rv_hash, "e", 1, newSVpv("", 0), 0);
        }
        /* =====> d */
        siz = (self->key.d) ? mp_unsigned_bin_size(self->key.d) : 0;
        if (siz>10000) {
          croak("FATAL: key2hash failed - 'd' too big number");
        }
        if (siz>0) {
          mp_tohex(self->key.d, buf);
          not_used = hv_store(rv_hash, "d", 1, newSVpv(buf, strlen(buf)), 0);
        }
        else{
          not_used = hv_store(rv_hash, "d", 1, newSVpv("", 0), 0);
        }
        /* =====> N */
        siz = (self->key.N) ? mp_unsigned_bin_size(self->key.N) : 0;
        if (siz>10000) {
          croak("FATAL: key2hash failed - 'N' too big number");
        }
        if (siz>0) {
          mp_tohex(self->key.N, buf);
          not_used = hv_store(rv_hash, "N", 1, newSVpv(buf, strlen(buf)), 0);
        }
        else{
          not_used = hv_store(rv_hash, "N", 1, newSVpv("", 0), 0);
        }
        /* =====> q */
        siz = (self->key.q) ? mp_unsigned_bin_size(self->key.q) : 0;
        if (siz>10000) {
          croak("FATAL: key2hash failed - 'q' too big number");
        }
        if (siz>0) {
          mp_tohex(self->key.q, buf);
          not_used = hv_store(rv_hash, "q", 1, newSVpv(buf, strlen(buf)), 0);
        }
        else{
          not_used = hv_store(rv_hash, "q", 1, newSVpv("", 0), 0);
        }
        /* =====> p */
        siz = (self->key.p) ? mp_unsigned_bin_size(self->key.p) : 0;
        if (siz>10000) {
          croak("FATAL: key2hash failed - 'p' too big number");
        }
        if (siz>0) {
          mp_tohex(self->key.p, buf);
          not_used = hv_store(rv_hash, "p", 1, newSVpv(buf, strlen(buf)), 0);
        }
        else{
          not_used = hv_store(rv_hash, "p", 1, newSVpv("", 0), 0);
        }
        /* =====> qP */
        siz = (self->key.qP) ? mp_unsigned_bin_size(self->key.qP) : 0;
        if (siz>10000) {
          croak("FATAL: key2hash failed - 'qP' too big number");
        }
        if (siz>0) {
          mp_tohex(self->key.qP, buf);
          not_used = hv_store(rv_hash, "qP", 2, newSVpv(buf, strlen(buf)), 0);
        }
        else{
          not_used = hv_store(rv_hash, "qP", 2, newSVpv("", 0), 0);
        }
        /* =====> dP */
        siz = (self->key.dP) ? mp_unsigned_bin_size(self->key.dP) : 0;
        if (siz>10000) {
          croak("FATAL: key2hash failed - 'dP' too big number");
        }
        if (siz>0) {
          mp_tohex(self->key.dP, buf);
          not_used = hv_store(rv_hash, "dP", 2, newSVpv(buf, strlen(buf)), 0);
        }
        else{
          not_used = hv_store(rv_hash, "dP", 2, newSVpv("", 0), 0);
        }
        /* =====> dQ */
        siz = (self->key.dQ) ? mp_unsigned_bin_size(self->key.dQ) : 0;
        if (siz>10000) {
          croak("FATAL: key2hash failed - 'dQ' too big number");
        }
        if (siz>0) {
          mp_tohex(self->key.dQ, buf);
          not_used = hv_store(rv_hash, "dQ", 2, newSVpv(buf, strlen(buf)), 0);
        }
        else{
          not_used = hv_store(rv_hash, "dQ", 2, newSVpv("", 0), 0);
        }
        /* =====> size */
        not_used = hv_store(rv_hash, "size", 4, newSViv(mp_unsigned_bin_size(self->key.N)), 0);
        /* =====> type */
        not_used = hv_store(rv_hash, "type", 4, newSViv(self->key.type), 0);
        if (not_used) not_used = NULL; /* just silence the warning: variable 'not_used' set but not used */
        RETVAL = newRV_noinc((SV*)rv_hash);
#line 9791 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PK__RSA_export_key_der); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__RSA_export_key_der)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, type");
    {
	SV *	RETVAL;
	Crypt__PK__RSA	self;
	char *        type = (SvOK(ST(1))) ? SvPV_nolen(ST(1)) : NULL
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::RSA")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__RSA,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::RSA::export_key_der",
			"self", "Crypt::PK::RSA")
;
#line 209 "./inc/CryptX_PK_RSA.xs.inc"
    {
        int rv;
        unsigned char out[4096];
        unsigned long int out_len = 4096;

        RETVAL = newSVpvn(NULL, 0); /* undef */
        if (strnEQ(type, "private", 7)) {
          rv = rsa_export(out, &out_len, PK_PRIVATE, &self->key);
          if (rv != CRYPT_OK) croak("FATAL: rsa_export(PK_PRIVATE) failed: %s", error_to_string(rv));
          RETVAL = newSVpvn((char*)out, out_len);
        }
        else if (strnEQ(type, "public", 6)) {
          rv = rsa_export(out, &out_len, PK_PUBLIC, &self->key);
          if (rv != CRYPT_OK) croak("FATAL: rsa_export(PK_PUBLIC|PK_STD) failed: %s", error_to_string(rv));
          RETVAL = newSVpvn((char*)out, out_len);
        }
        else {
          croak("FATAL: export_key_der invalid type '%s'", type);
        }
    }
#line 9841 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PK__RSA__encrypt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__RSA__encrypt)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "self, data, padding, oaep_hash, oaep_lparam");
    {
	SV *	RETVAL;
	Crypt__PK__RSA	self;
	SV *	data = ST(1)
;
	char *        padding = (SvOK(ST(2))) ? SvPV_nolen(ST(2)) : NULL
;
	char *        oaep_hash = (SvOK(ST(3))) ? SvPV_nolen(ST(3)) : NULL
;
	SV *	oaep_lparam = ST(4)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::RSA")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__RSA,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::RSA::_encrypt",
			"self", "Crypt::PK::RSA")
;
#line 235 "./inc/CryptX_PK_RSA.xs.inc"
    {
        int rv, hash_id;
        unsigned char *lparam_ptr=NULL;
        STRLEN lparam_len=0;
        unsigned char *data_ptr=NULL;
        STRLEN data_len=0;
        unsigned char buffer[1024];
        unsigned long buffer_len = 1024;

        data_ptr = (unsigned char *)SvPVbyte(data, data_len);

        RETVAL = newSVpvn(NULL, 0); /* undef */
        if (strnEQ(padding, "oaep", 4)) {
          hash_id = find_hash(oaep_hash);
          if(hash_id==-1) croak("FATAL: find_hash failed for '%s'", oaep_hash);
          lparam_ptr = (unsigned char *)SvPVbyte(oaep_lparam, lparam_len);
          rv = rsa_encrypt_key_ex(data_ptr, (unsigned long)data_len, buffer, &buffer_len, lparam_ptr, (unsigned long)lparam_len,
                                  &self->yarrow_prng_state, self->yarrow_prng_index,
                                  hash_id, LTC_PKCS_1_OAEP, &self->key);
          if (rv != CRYPT_OK) croak("FATAL: rsa_encrypt_key_ex failed: %s", error_to_string(rv));
          RETVAL = newSVpvn((char*)buffer, buffer_len);
        }
        else if (strnEQ(padding, "v1.5", 4)) {
          rv = rsa_encrypt_key_ex(data_ptr, (unsigned long)data_len, buffer, &buffer_len, NULL, 0,
                                  &self->yarrow_prng_state, self->yarrow_prng_index,
                                  0, LTC_PKCS_1_V1_5, &self->key);
          if (rv != CRYPT_OK) croak("FATAL: rsa_encrypt_key_ex failed: %s", error_to_string(rv));
          RETVAL = newSVpvn((char*)buffer, buffer_len);
        }
        else if (strnEQ(padding, "none", 4)) {
          /* raw RSA */
          rv = ltc_mp.rsa_me(data_ptr, (unsigned long)data_len, buffer, &buffer_len, PK_PUBLIC, &self->key);
          if (rv != CRYPT_OK) croak("FATAL: rsa_me failed: %s", error_to_string(rv));
          RETVAL = newSVpvn((char*)buffer, buffer_len);
        }
        else {
          croak("FATAL: rsa_encrypt invalid padding '%s'", padding);
        }
    }
#line 9916 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PK__RSA__decrypt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__RSA__decrypt)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "self, data, padding, oaep_hash, oaep_lparam");
    {
	SV *	RETVAL;
	Crypt__PK__RSA	self;
	SV *	data = ST(1)
;
	char *        padding = (SvOK(ST(2))) ? SvPV_nolen(ST(2)) : NULL
;
	char *        oaep_hash = (SvOK(ST(3))) ? SvPV_nolen(ST(3)) : NULL
;
	SV *	oaep_lparam = ST(4)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::RSA")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__RSA,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::RSA::_decrypt",
			"self", "Crypt::PK::RSA")
;
#line 280 "./inc/CryptX_PK_RSA.xs.inc"
    {
        int rv, hash_id, stat;
        unsigned char *lparam_ptr=NULL;
        STRLEN lparam_len=0;
        unsigned char *data_ptr=NULL;
        STRLEN data_len=0;
        unsigned char buffer[1024];
        unsigned long buffer_len = 1024;

        data_ptr = (unsigned char *)SvPVbyte(data, data_len);

        RETVAL = newSVpvn(NULL, 0); /* undef */
        if (strnEQ(padding, "oaep", 4)) {
          hash_id = find_hash(oaep_hash);
          if(hash_id==-1) croak("FATAL: find_hash failed for '%s'", oaep_hash);
          lparam_ptr = (unsigned char *)SvPVbyte(oaep_lparam, lparam_len);
          rv = rsa_decrypt_key_ex(data_ptr, (unsigned long)data_len, buffer, &buffer_len, lparam_ptr, (unsigned long)lparam_len,
                                  hash_id, LTC_PKCS_1_OAEP, &stat, &self->key);
          if (rv != CRYPT_OK) croak("FATAL: rsa_decrypt_key_ex failed: %s", error_to_string(rv));
          if (stat != 1) croak("FATAL: rsa_decrypt - not valid OAEP packet");
          RETVAL = newSVpvn((char*)buffer, buffer_len);
        }
        else if (strnEQ(padding, "v1.5", 4)) {
          rv = rsa_decrypt_key_ex(data_ptr, (unsigned long)data_len, buffer, &buffer_len, NULL, 0,
                                  0, LTC_PKCS_1_V1_5, &stat, &self->key);
          if (rv != CRYPT_OK) croak("FATAL: rsa_decrypt_key_ex failed: %s", error_to_string(rv));
          if (stat != 1) croak("FATAL: rsa_decrypt - invalid");
          RETVAL = newSVpvn((char*)buffer, buffer_len);
        }
        else if (strnEQ(padding, "none", 4)) {
          /* raw RSA */
          rv = ltc_mp.rsa_me(data_ptr, (unsigned long)data_len, buffer, &buffer_len, PK_PRIVATE, &self->key);
          if (rv != CRYPT_OK) croak("FATAL: rsa_me failed: %s", error_to_string(rv));
          RETVAL = newSVpvn((char*)buffer, buffer_len);
        }
        else {
          croak("FATAL: rsa_encrypt invalid padding '%s'", padding);
        }
    }
#line 9991 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PK__RSA__sign); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__RSA__sign)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 5)
       croak_xs_usage(cv,  "self, data, padding, hash_name, saltlen=12");
    {
	SV *	RETVAL;
	Crypt__PK__RSA	self;
	SV *	data = ST(1)
;
	char *        padding = (SvOK(ST(2))) ? SvPV_nolen(ST(2)) : NULL
;
	char *        hash_name = (SvOK(ST(3))) ? SvPV_nolen(ST(3)) : NULL
;
	unsigned long	saltlen;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::RSA")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__RSA,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::RSA::_sign",
			"self", "Crypt::PK::RSA")
;

	if (items < 5)
	    saltlen = 12;
	else {
	    saltlen = (unsigned long)SvUV(ST(4))
;
	}
#line 325 "./inc/CryptX_PK_RSA.xs.inc"
    {
        int rv, hash_id;
        unsigned char *data_ptr=NULL;
        STRLEN data_len=0;
        unsigned char buffer[1024];
        unsigned long buffer_len = 1024;

        data_ptr = (unsigned char *)SvPVbyte(data, data_len);

        RETVAL = newSVpvn(NULL, 0); /* undef */
        hash_id = find_hash(hash_name);
        if(hash_id==-1) croak("FATAL: find_hash failed for '%s'", hash_name);
        if (strnEQ(padding, "pss", 3)) {
          rv = rsa_sign_hash_ex(data_ptr, (unsigned long)data_len, buffer, &buffer_len, LTC_PKCS_1_PSS,
                                &self->yarrow_prng_state, self->yarrow_prng_index,
                                hash_id, saltlen, &self->key);
          if (rv != CRYPT_OK) croak("FATAL: rsa_sign_hash_ex failed: %s", error_to_string(rv));
          RETVAL = newSVpvn((char*)buffer, buffer_len);
        }
        else if (strnEQ(padding, "v1.5", 4)) {
          rv = rsa_sign_hash_ex(data_ptr, (unsigned long)data_len, buffer, &buffer_len, LTC_PKCS_1_V1_5,
                                &self->yarrow_prng_state, self->yarrow_prng_index,
                                hash_id, 0, &self->key);
          if (rv != CRYPT_OK) croak("FATAL: rsa_sign_hash_ex failed: %s", error_to_string(rv));
          RETVAL = newSVpvn((char*)buffer, buffer_len);
        }
        else {
          croak("FATAL: rsa_sign invalid padding '%s'", padding);
        }
    }
#line 10063 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PK__RSA__verify); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__RSA__verify)
{
    dVAR; dXSARGS;
    if (items < 5 || items > 6)
       croak_xs_usage(cv,  "self, sig, data, padding, hash_name, saltlen=12");
    {
	int	RETVAL;
	dXSTARG;
	Crypt__PK__RSA	self;
	SV *	sig = ST(1)
;
	SV *	data = ST(2)
;
	char *        padding = (SvOK(ST(3))) ? SvPV_nolen(ST(3)) : NULL
;
	char *        hash_name = (SvOK(ST(4))) ? SvPV_nolen(ST(4)) : NULL
;
	unsigned long	saltlen;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::PK::RSA")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__RSA,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::PK::RSA::_verify",
			"self", "Crypt::PK::RSA")
;

	if (items < 6)
	    saltlen = 12;
	else {
	    saltlen = (unsigned long)SvUV(ST(5))
;
	}
#line 361 "./inc/CryptX_PK_RSA.xs.inc"
    {
        int rv, hash_id, stat;
        unsigned char *data_ptr=NULL;
        STRLEN data_len=0;
        unsigned char *sig_ptr=NULL;
        STRLEN sig_len=0;

        data_ptr = (unsigned char *)SvPVbyte(data, data_len);
        sig_ptr = (unsigned char *)SvPVbyte(sig, sig_len);

        RETVAL = 1;
        hash_id = find_hash(hash_name);
        if(hash_id==-1) croak("FATAL: find_hash failed for '%s'", hash_name);
        if (strnEQ(padding, "pss", 3)) {
          rv = rsa_verify_hash_ex(sig_ptr, (unsigned long)sig_len, data_ptr, (unsigned long)data_len, LTC_PKCS_1_PSS,
                                hash_id, saltlen, &stat, &self->key);
          if (rv != CRYPT_OK || stat != 1) RETVAL = 0;
        }
        else if (strnEQ(padding, "v1.5", 4)) {
          rv = rsa_verify_hash_ex(sig_ptr, (unsigned long)sig_len, data_ptr, (unsigned long)data_len, LTC_PKCS_1_V1_5,
                                hash_id, 0, &stat, &self->key);
          if (rv != CRYPT_OK || stat != 1) RETVAL = 0;
        }
        else {
          croak("FATAL: rsa_verify invalid padding '%s'", padding);
        }
    }
#line 10135 "CryptX.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__PK__RSA_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__PK__RSA_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__PK__RSA	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__PK__RSA,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Crypt::PK::RSA::DESTROY",
			"self")
;
#line 394 "./inc/CryptX_PK_RSA.xs.inc"
        if (self->key.type != -1) { rsa_free(&self->key); self->key.type = -1; }
        Safefree(self);
#line 10163 "CryptX.c"
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'CryptX.xs' from 'inc/CryptX_PK_RSA.xs.inc' */


/* INCLUDE:  Including 'inc/CryptX_KeyDerivation.xs.inc' from 'CryptX.xs' */


XS_EUPXS(XS_Crypt__KeyDerivation__pkcs_5_alg1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__KeyDerivation__pkcs_5_alg1)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "password, salt, iteration_count, hash_name, len");
    {
	SV *	RETVAL;
	SV *	password = ST(0)
;
	SV *	salt = ST(1)
;
	int	iteration_count = (int)SvIV(ST(2))
;
	char *        hash_name = (SvOK(ST(3))) ? SvPV_nolen(ST(3)) : NULL
;
	int	len = (int)SvIV(ST(4))
;
#line 6 "./inc/CryptX_KeyDerivation.xs.inc"
    {
        /*
        int pkcs_5_alg1(const unsigned char *password, unsigned long password_len,
                        const unsigned char *salt,
                        int iteration_count,  int hash_idx,
                        unsigned char *out,   unsigned long *outlen)
        */
        int rv, id;
        unsigned long output_len;
        unsigned char *output;
        unsigned char *password_ptr=NULL;
        STRLEN password_len=0;
        unsigned char *salt_ptr=NULL;
        STRLEN salt_len=0;

        id = find_hash(hash_name);
        if(id==-1) croak("FATAL: find_hash failed for '%s'", hash_name);

        password_ptr = (unsigned char *)SvPVbyte(password, password_len);
        salt_ptr = (unsigned char *)SvPVbyte(salt, salt_len);
        if (salt_len < 8) croak("FATAL: salt_len has to be 8");

        output_len = len;
        Newz(0, output, output_len, unsigned char);
        if (!output) croak("FATAL: Newz failed [%ld]", output_len);

        rv = pkcs_5_alg1(password_ptr, (unsigned long)password_len, salt_ptr, iteration_count, id, output, &output_len);
        if (rv != CRYPT_OK) croak("FATAL: pkcs_5_alg1 process failed: %s", error_to_string(rv));

        RETVAL = newSVpvn((char *)output, output_len);
        Safefree(output);
    }
#line 10226 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__KeyDerivation__pkcs_5_alg2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__KeyDerivation__pkcs_5_alg2)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "password, salt, iteration_count, hash_name, len");
    {
	SV *	RETVAL;
	SV *	password = ST(0)
;
	SV *	salt = ST(1)
;
	int	iteration_count = (int)SvIV(ST(2))
;
	char *        hash_name = (SvOK(ST(3))) ? SvPV_nolen(ST(3)) : NULL
;
	int	len = (int)SvIV(ST(4))
;
#line 44 "./inc/CryptX_KeyDerivation.xs.inc"
    {
        /*
        int pkcs_5_alg2(const unsigned char *password, unsigned long password_len,
                        const unsigned char *salt,     unsigned long salt_len,
                        int iteration_count,           int hash_idx,
                        unsigned char *out,            unsigned long *outlen)
        */
        int rv, id;
        unsigned long output_len;
        unsigned char *output;
        unsigned char *password_ptr=NULL;
        STRLEN password_len=0;
        unsigned char *salt_ptr=NULL;
        STRLEN salt_len=0;

        id = find_hash(hash_name);
        if(id==-1) croak("FATAL: find_hash failed for '%s'", hash_name);

        password_ptr = (unsigned char *)SvPVbyte(password, password_len);
        salt_ptr = (unsigned char *)SvPVbyte(salt, salt_len);

        output_len = len;
        Newz(0, output, output_len, unsigned char);
        if (!output) croak("FATAL: Newz failed [%ld]", output_len);

        rv = pkcs_5_alg2(password_ptr, (unsigned long)password_len, salt_ptr, (unsigned long)salt_len, iteration_count, id, output, &output_len);
        if (rv != CRYPT_OK) croak("FATAL: pkcs_5_alg2 process failed: %s", error_to_string(rv));

        RETVAL = newSVpvn((char *)output, output_len);
        Safefree(output);
    }
#line 10284 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__KeyDerivation__hkdf_extract); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__KeyDerivation__hkdf_extract)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "hash_name, salt, in");
    {
	SV *	RETVAL;
	char *        hash_name = (SvOK(ST(0))) ? SvPV_nolen(ST(0)) : NULL
;
	SV *	salt = ST(1)
;
	SV *	in = ST(2)
;
#line 81 "./inc/CryptX_KeyDerivation.xs.inc"
    {
        /*
        int hkdf_extract(int hash_idx, const unsigned char *salt, unsigned long  saltlen,
                                       const unsigned char *in,   unsigned long  inlen,
                                       unsigned char *out,  unsigned long *outlen)
        */
        int rv, id;
        unsigned char output[MAXBLOCKSIZE];
        unsigned long output_len;
        unsigned char *in_ptr=NULL;
        STRLEN in_len=0;
        unsigned char *salt_ptr=NULL;
        STRLEN salt_len=0;

        id = find_hash(hash_name);
        if(id==-1) croak("FATAL: find_hash failed for '%s'", hash_name);

        in_ptr = (unsigned char *)SvPVbyte(in, in_len);
        salt_ptr = (unsigned char *)SvPVbyte(salt, salt_len);

        output_len = sizeof(output);
        rv = hkdf_extract(id, salt_ptr, (unsigned long)salt_len, in_ptr, (unsigned long)in_len, output, &output_len);
        if (rv != CRYPT_OK) croak("FATAL: hkdf_extract process failed: %s", error_to_string(rv));

        RETVAL = newSVpvn((char *)output, output_len);
    }
#line 10333 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__KeyDerivation__hkdf_expand); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__KeyDerivation__hkdf_expand)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "hash_name, info, in, output_len");
    {
	SV *	RETVAL;
	char *        hash_name = (SvOK(ST(0))) ? SvPV_nolen(ST(0)) : NULL
;
	SV *	info = ST(1)
;
	SV *	in = ST(2)
;
	unsigned long	output_len = (unsigned long)SvUV(ST(3))
;
#line 113 "./inc/CryptX_KeyDerivation.xs.inc"
    {
        /*
        int hkdf_expand(int hash_idx, const unsigned char *info, unsigned long infolen,
                                      const unsigned char *in,   unsigned long inlen,
                                      unsigned char *out,  unsigned long outlen)
        */
        int rv, id;
        unsigned char *output;
        unsigned char *in_ptr=NULL;
        STRLEN in_len=0;
        unsigned char *info_ptr=NULL;
        STRLEN info_len=0;

        id = find_hash(hash_name);
        if(id==-1) croak("FATAL: find_hash failed for '%s'", hash_name);

        in_ptr = (unsigned char *)SvPVbyte(in, in_len);
        info_ptr = (unsigned char *)SvPVbyte(info, info_len);

        Newz(0, output, output_len, unsigned char);
        if (!output) croak("FATAL: Newz failed [%ld]", output_len);

        rv = hkdf_expand(id, info_ptr, (unsigned long)info_len, in_ptr, (unsigned long)in_len, output, output_len);
        if (rv != CRYPT_OK) croak("FATAL: hkdf_expand process failed: %s", error_to_string(rv));

        RETVAL = newSVpvn((char *)output, output_len);
        Safefree(output);
    }
#line 10386 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__KeyDerivation__hkdf); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__KeyDerivation__hkdf)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "hash_name, salt, info, in, output_len");
    {
	SV *	RETVAL;
	char *        hash_name = (SvOK(ST(0))) ? SvPV_nolen(ST(0)) : NULL
;
	SV *	salt = ST(1)
;
	SV *	info = ST(2)
;
	SV *	in = ST(3)
;
	unsigned long	output_len = (unsigned long)SvUV(ST(4))
;
#line 147 "./inc/CryptX_KeyDerivation.xs.inc"
    {
        /*
        int hkdf(int hash_idx, const unsigned char *salt, unsigned long saltlen,
                               const unsigned char *info, unsigned long infolen,
                               const unsigned char *in,   unsigned long inlen,
                               unsigned char *out,  unsigned long outlen)
        */
        int rv, id;
        unsigned char *output;
        unsigned char *in_ptr=NULL;
        STRLEN in_len=0;
        unsigned char *info_ptr=NULL;
        STRLEN info_len=0;
        unsigned char *salt_ptr=NULL;
        STRLEN salt_len=0;

        id = find_hash(hash_name);
        if(id==-1) croak("FATAL: find_hash failed for '%s'", hash_name);

        in_ptr = (unsigned char *)SvPVbyte(in, in_len);
        info_ptr = (unsigned char *)SvPVbyte(info, info_len);
        salt_ptr = (unsigned char *)SvPVbyte(salt, salt_len);

        Newz(0, output, output_len, unsigned char);
        if (!output) croak("FATAL: Newz failed [%ld]", output_len);

        rv = hkdf(id, salt_ptr, (unsigned long)salt_len, info_ptr, (unsigned long)info_len, in_ptr, (unsigned long)in_len, output, output_len);
        if (rv != CRYPT_OK) croak("FATAL: hkdf_expand process failed: %s", error_to_string(rv));

        RETVAL = newSVpvn((char *)output, output_len);
        Safefree(output);
    }
#line 10445 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


/* INCLUDE: Returning to 'CryptX.xs' from 'inc/CryptX_KeyDerivation.xs.inc' */


/* INCLUDE:  Including 'inc/CryptX_BigInt_LTM.xs.inc' from 'CryptX.xs' */


XS_EUPXS(XS_Math__BigInt__LTM__new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM__new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, x");
    {
	Math__BigInt__LTM	RETVAL;
	SV *	x = ST(1)
;
#line 10 "./inc/CryptX_BigInt_LTM.xs.inc"
    Newz(0, RETVAL, 1, mp_int);
    mp_init(RETVAL);
    if ((SvUOK(x) || SvIOK(x)) && (sizeof(UV) <= sizeof(unsigned long) || SvUV(x) == (unsigned long)SvUV(x))) {
      mp_set_int(RETVAL, (unsigned long)SvUV(x));
    }
    else {
      mp_read_radix(RETVAL, SvPV_nolen(x), 10);
    }
#line 10478 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Math::BigInt::LTM", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__LTM__from_bin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM__from_bin)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, x");
    {
#line 27 "./inc/CryptX_BigInt_LTM.xs.inc"
    char *str, *start;
#line 10499 "CryptX.c"
	Math__BigInt__LTM	RETVAL;
	SV *	x = ST(1)
;
#line 29 "./inc/CryptX_BigInt_LTM.xs.inc"
    Newz(0, RETVAL, 1, mp_int);
    mp_init(RETVAL);
    str = SvPV_nolen(x);
    start = (strlen(str)>2 && str[0] == '0' && str[1] == 'b') ? str+2 : str;
    mp_read_radix(RETVAL, start, 2);
#line 10509 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Math::BigInt::LTM", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__LTM__from_hex); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM__from_hex)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, x");
    {
#line 43 "./inc/CryptX_BigInt_LTM.xs.inc"
    char *str, *start;
#line 10530 "CryptX.c"
	Math__BigInt__LTM	RETVAL;
	SV *	x = ST(1)
;
#line 45 "./inc/CryptX_BigInt_LTM.xs.inc"
    Newz(0, RETVAL, 1, mp_int);
    mp_init(RETVAL);
    str = SvPV_nolen(x);
    start = (strlen(str)>2 && str[0] == '0' && str[1] == 'x') ? str+2 : str;
    mp_read_radix(RETVAL, start, 16);
#line 10540 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Math::BigInt::LTM", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__LTM__from_oct); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM__from_oct)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, x");
    {
	Math__BigInt__LTM	RETVAL;
	SV *	x = ST(1)
;
#line 59 "./inc/CryptX_BigInt_LTM.xs.inc"
    Newz(0, RETVAL, 1, mp_int);
    mp_init(RETVAL);
    mp_read_radix(RETVAL, SvPV_nolen(x), 8);
#line 10566 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Math::BigInt::LTM", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__LTM__set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM__set)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "Class, n, x");
    {
	Math__BigInt__LTM	n;
	SV *	x = ST(2)
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    n = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_set",
			"n", "Math::BigInt::LTM")
;
#line 71 "./inc/CryptX_BigInt_LTM.xs.inc"
    mp_set_int(n, SvIV(x));
#line 10600 "CryptX.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__BigInt__LTM__zero); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM__zero)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "Class");
    {
	Math__BigInt__LTM	RETVAL;
#line 79 "./inc/CryptX_BigInt_LTM.xs.inc"
    Newz(0, RETVAL, 1, mp_int);
    mp_init(RETVAL);
    mp_set_int(RETVAL, 0);
#line 10618 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Math::BigInt::LTM", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__LTM__one); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM__one)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "Class");
    {
	Math__BigInt__LTM	RETVAL;
#line 91 "./inc/CryptX_BigInt_LTM.xs.inc"
    Newz(0, RETVAL, 1, mp_int);
    mp_init(RETVAL);
    mp_set_int(RETVAL, 1);
#line 10642 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Math::BigInt::LTM", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__LTM__two); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM__two)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "Class");
    {
	Math__BigInt__LTM	RETVAL;
#line 103 "./inc/CryptX_BigInt_LTM.xs.inc"
    Newz(0, RETVAL, 1, mp_int);
    mp_init(RETVAL);
    mp_set_int(RETVAL, 2);
#line 10666 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Math::BigInt::LTM", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__LTM__ten); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM__ten)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "Class");
    {
	Math__BigInt__LTM	RETVAL;
#line 115 "./inc/CryptX_BigInt_LTM.xs.inc"
    Newz(0, RETVAL, 1, mp_int);
    mp_init(RETVAL);
    mp_set_int(RETVAL, 10);
#line 10690 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Math::BigInt::LTM", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__LTM__1ex); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM__1ex)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, x");
    {
	Math__BigInt__LTM	RETVAL;
	int	x = (int)SvIV(ST(1))
;
#line 127 "./inc/CryptX_BigInt_LTM.xs.inc"
    Newz(0, RETVAL, 1, mp_int);
    mp_init(RETVAL);
    mp_set_int(RETVAL, 10);
    mp_expt_d(RETVAL, x, RETVAL);
#line 10717 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Math::BigInt::LTM", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__LTM_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "n");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Math__BigInt__LTM	n;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    n = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Math::BigInt::LTM::DESTROY",
			"n")
;
#line 140 "./inc/CryptX_BigInt_LTM.xs.inc"
    if (n) {
      mp_clear(n);
      Safefree(n);
    }
#line 10754 "CryptX.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__BigInt__LTM__str); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM__str)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, n");
    {
#line 151 "./inc/CryptX_BigInt_LTM.xs.inc"
    int len;
    char *buf;
#line 10771 "CryptX.c"
	SV *	RETVAL;
	Math__BigInt__LTM	n;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    n = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_str",
			"n", "Math::BigInt::LTM")
;
#line 154 "./inc/CryptX_BigInt_LTM.xs.inc"
    if (mp_iszero(n) == MP_YES) {
      RETVAL = newSVpv("0", 0);
    }
    else {
      len = mp_unsigned_bin_size(n) * 3 + 2; /* decimal size ~ 3 * bin size +1 for sign +1 for NUL-byte */
      Newz(0, buf, len, char);
      mp_toradix_n(n, buf, 10, len);
      RETVAL = newSVpv(buf, 0);
      Safefree(buf);
    }
#line 10795 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__LTM__len); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM__len)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, n");
    {
#line 173 "./inc/CryptX_BigInt_LTM.xs.inc"
    int len;
    char *buf;
#line 10813 "CryptX.c"
	int	RETVAL;
	dXSTARG;
	Math__BigInt__LTM	n;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    n = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_len",
			"n", "Math::BigInt::LTM")
;
#line 176 "./inc/CryptX_BigInt_LTM.xs.inc"
    if (mp_iszero(n) == MP_YES) {
      RETVAL = 1;
    }
    else {
      len = mp_unsigned_bin_size(n) * 3 + 2; /* decimal size ~ 3 * bin size +1 for sign +1 for NUL-byte */
      Newz(0, buf, len, char);
      mp_toradix_n(n, buf, 10, len);
      RETVAL = strlen(buf);
      Safefree(buf);
    }
#line 10838 "CryptX.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__LTM__alen); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM__alen)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, n");
    {
	int	RETVAL;
	dXSTARG;
	Math__BigInt__LTM	n;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    n = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_alen",
			"n", "Math::BigInt::LTM")
;
#line 195 "./inc/CryptX_BigInt_LTM.xs.inc"
    RETVAL = mp_unsigned_bin_size(n) * 3 + 2; /* decimal size ~ 3 * bin size XXX-FIXME very bad estimate */
#line 10867 "CryptX.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__LTM__zeros); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM__zeros)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, n");
    {
#line 205 "./inc/CryptX_BigInt_LTM.xs.inc"
    int len;
    char *buf;
#line 10884 "CryptX.c"
	int	RETVAL;
	dXSTARG;
	Math__BigInt__LTM	n;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    n = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_zeros",
			"n", "Math::BigInt::LTM")
;
#line 208 "./inc/CryptX_BigInt_LTM.xs.inc"
    if (mp_iszero(n) == MP_YES) {
      RETVAL = 0; /* '0' has no trailing zeros! */
    }
    else {
      len = mp_unsigned_bin_size(n) * 3 + 2; /* decimal size ~ 3 * bin size +1 for sign +1 for NUL-byte */
      Newz(0, buf, len, char);
      mp_toradix_n(n, buf, 10, len);
      len = strlen(buf);
      RETVAL = 0;
      while (len > 0) {
        if (buf[len-1] != '0') break;
        RETVAL++;
        len--;
      }
      Safefree(buf);
    }
#line 10915 "CryptX.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__LTM__as_hex); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM__as_hex)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, n");
    {
#line 233 "./inc/CryptX_BigInt_LTM.xs.inc"
    int i, len;
    char *buf;
#line 10932 "CryptX.c"
	SV *	RETVAL;
	Math__BigInt__LTM	n;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    n = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_as_hex",
			"n", "Math::BigInt::LTM")
;
#line 236 "./inc/CryptX_BigInt_LTM.xs.inc"
    len = mp_unsigned_bin_size(n) * 2 + 3;
    RETVAL = newSV(len);
    SvPOK_on(RETVAL);
    buf = SvPVX(RETVAL);                /* get ptr to storage */
    *buf++ = '0'; *buf++ = 'x';         /* prepend '0x' */
    mp_tohex(n, buf);
    for (i=0; i<len && buf[i]>0; i++) buf[i] = toLOWER(buf[i]);
    SvCUR_set(RETVAL, strlen(buf)+2);   /* set real length */
#line 10954 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__LTM__as_bin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM__as_bin)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, n");
    {
#line 253 "./inc/CryptX_BigInt_LTM.xs.inc"
    int len;
    char *buf;
#line 10972 "CryptX.c"
	SV *	RETVAL;
	Math__BigInt__LTM	n;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    n = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_as_bin",
			"n", "Math::BigInt::LTM")
;
#line 256 "./inc/CryptX_BigInt_LTM.xs.inc"
    len = mp_unsigned_bin_size(n) * 8 + 3;
    RETVAL = newSV(len);
    SvPOK_on(RETVAL);
    buf = SvPVX(RETVAL);                /* get ptr to storage */
    *buf++ = '0'; *buf++ = 'b';         /* prepend '0b' */
    mp_tobinary(n, buf);
    SvCUR_set(RETVAL, strlen(buf)+2);   /* set real length */
#line 10993 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__LTM__as_oct); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM__as_oct)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, n");
    {
#line 272 "./inc/CryptX_BigInt_LTM.xs.inc"
    int len;
    char *buf;
#line 11011 "CryptX.c"
	SV *	RETVAL;
	Math__BigInt__LTM	n;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    n = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_as_oct",
			"n", "Math::BigInt::LTM")
;
#line 275 "./inc/CryptX_BigInt_LTM.xs.inc"
    len = mp_unsigned_bin_size(n) * 3 + 3;
    RETVAL = newSV(len);
    SvPOK_on(RETVAL);
    buf = SvPVX(RETVAL);
    *buf++ = '0';                       /* prepend '0' */
    mp_tooctal(n, buf);
    SvCUR_set(RETVAL, strlen(buf)+1);   /* set real length */
#line 11032 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__LTM__modpow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM__modpow)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "Class, n, exp, mod");
    {
	Math__BigInt__LTM	RETVAL;
	Math__BigInt__LTM	n;
	Math__BigInt__LTM	exp;
	Math__BigInt__LTM	mod;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    n = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_modpow",
			"n", "Math::BigInt::LTM")
;

	if (SvROK(ST(2)) && sv_derived_from(ST(2), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(2)));
	    exp = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_modpow",
			"exp", "Math::BigInt::LTM")
;

	if (SvROK(ST(3)) && sv_derived_from(ST(3), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(3)));
	    mod = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_modpow",
			"mod", "Math::BigInt::LTM")
;
#line 291 "./inc/CryptX_BigInt_LTM.xs.inc"
    Newz(0, RETVAL, 1, mp_int);
    mp_init(RETVAL);
    if (mp_cmp_d(mod, 1) == MP_EQ) {
      mp_set_int(RETVAL, 0);
    }
    else {
      mp_exptmod(n, exp, mod, RETVAL);
    }
#line 11090 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Math::BigInt::LTM", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__LTM__modinv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM__modinv)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "Class, x, y");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 308 "./inc/CryptX_BigInt_LTM.xs.inc"
    int rc, sign;
    SV* s;
    mp_int* RETVAL;
#line 11115 "CryptX.c"
	Math__BigInt__LTM	x;
	Math__BigInt__LTM	y;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    x = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_modinv",
			"x", "Math::BigInt::LTM")
;

	if (SvROK(ST(2)) && sv_derived_from(ST(2), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(2)));
	    y = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_modinv",
			"y", "Math::BigInt::LTM")
;
#line 312 "./inc/CryptX_BigInt_LTM.xs.inc"
    Newz(0, RETVAL, 1, mp_int);
    mp_init(RETVAL);
    rc = mp_invmod(x, y, RETVAL);
    EXTEND(SP, 2);      /* we return two values */
    if (rc != MP_OKAY) {
      /* Inverse doesn't exist. Return both values undefined. */
      PUSHs(&PL_sv_undef);
      PUSHs(&PL_sv_undef);
    }
    else {
      /* Inverse exists. When the modulus to mp_invert() is positive,
       * the returned value is also positive. */
      PUSHs(sv_2mortal(sv_from_mpi(RETVAL)));
      s = sv_newmortal();
      sv_setpvn(s, "+", 1);
      PUSHs(s);
    }
#line 11156 "CryptX.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__BigInt__LTM__add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM__add)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "Class, x, y");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Math__BigInt__LTM	x;
	Math__BigInt__LTM	y;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    x = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_add",
			"x", "Math::BigInt::LTM")
;

	if (SvROK(ST(2)) && sv_derived_from(ST(2), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(2)));
	    y = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_add",
			"y", "Math::BigInt::LTM")
;
#line 336 "./inc/CryptX_BigInt_LTM.xs.inc"
    mp_add(x, y, x);
    XPUSHs(ST(1)); /* x */
#line 11197 "CryptX.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__BigInt__LTM__inc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM__inc)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, x");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Math__BigInt__LTM	x;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    x = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_inc",
			"x", "Math::BigInt::LTM")
;
#line 345 "./inc/CryptX_BigInt_LTM.xs.inc"
    mp_add_d(x, 1, x);
    XPUSHs(ST(1)); /* x */
#line 11227 "CryptX.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__BigInt__LTM__dec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM__dec)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, x");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Math__BigInt__LTM	x;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    x = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_dec",
			"x", "Math::BigInt::LTM")
;
#line 354 "./inc/CryptX_BigInt_LTM.xs.inc"
    mp_sub_d(x, 1, x);
    XPUSHs(ST(1)); /* x */
#line 11257 "CryptX.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__BigInt__LTM__sub); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM__sub)
{
    dVAR; dXSARGS;
    if (items < 3)
       croak_xs_usage(cv,  "Class, x, y, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Math__BigInt__LTM	x;
	Math__BigInt__LTM	y;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    x = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_sub",
			"x", "Math::BigInt::LTM")
;

	if (SvROK(ST(2)) && sv_derived_from(ST(2), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(2)));
	    y = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_sub",
			"y", "Math::BigInt::LTM")
;
#line 364 "./inc/CryptX_BigInt_LTM.xs.inc"
    if ( items == 4 && SvTRUE(ST(3)) ) {
      /* y -= x */
      mp_sub(x, y, y);
      XPUSHs(ST(2)); /* y */
    }
    else {
      /* x -= y */
      mp_sub(x, y, x);
      XPUSHs(ST(1)); /* x */
    }
#line 11306 "CryptX.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__BigInt__LTM__rsft); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM__rsft)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "Class, x, y, base_int");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 381 "./inc/CryptX_BigInt_LTM.xs.inc"
    mp_int*  BASE;
#line 11324 "CryptX.c"
	Math__BigInt__LTM	x;
	Math__BigInt__LTM	y;
	unsigned long	base_int = (unsigned long)SvUV(ST(3))
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    x = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_rsft",
			"x", "Math::BigInt::LTM")
;

	if (SvROK(ST(2)) && sv_derived_from(ST(2), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(2)));
	    y = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_rsft",
			"y", "Math::BigInt::LTM")
;
#line 383 "./inc/CryptX_BigInt_LTM.xs.inc"
    Newz(0, BASE, 1, mp_int);
    mp_init_set_int(BASE, base_int);
    mp_expt_d(BASE, mp_get_long(y), BASE);
    mp_div(x, BASE, x, NULL);
    mp_clear(BASE);
    Safefree(BASE);
    XPUSHs(ST(1)); /* x */
#line 11357 "CryptX.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__BigInt__LTM__lsft); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM__lsft)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "Class, x, y, base_int");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 397 "./inc/CryptX_BigInt_LTM.xs.inc"
    mp_int*  BASE;
#line 11375 "CryptX.c"
	Math__BigInt__LTM	x;
	Math__BigInt__LTM	y;
	unsigned long	base_int = (unsigned long)SvUV(ST(3))
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    x = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_lsft",
			"x", "Math::BigInt::LTM")
;

	if (SvROK(ST(2)) && sv_derived_from(ST(2), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(2)));
	    y = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_lsft",
			"y", "Math::BigInt::LTM")
;
#line 399 "./inc/CryptX_BigInt_LTM.xs.inc"
    Newz(0, BASE, 1, mp_int);
    mp_init_set_int(BASE, base_int);
    mp_expt_d(BASE, mp_get_long(y), BASE);
    mp_mul(x, BASE, x);
    mp_clear(BASE);
    Safefree(BASE);
    XPUSHs(ST(1)); /* x */
#line 11408 "CryptX.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__BigInt__LTM__mul); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM__mul)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "Class, x, y");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Math__BigInt__LTM	x;
	Math__BigInt__LTM	y;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    x = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_mul",
			"x", "Math::BigInt::LTM")
;

	if (SvROK(ST(2)) && sv_derived_from(ST(2), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(2)));
	    y = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_mul",
			"y", "Math::BigInt::LTM")
;
#line 413 "./inc/CryptX_BigInt_LTM.xs.inc"
    mp_mul(x, y, x);
    XPUSHs(ST(1)); /* x */
#line 11449 "CryptX.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__BigInt__LTM__div); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM__div)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "Class, x, y");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 422 "./inc/CryptX_BigInt_LTM.xs.inc"
    mp_int * rem;
#line 11467 "CryptX.c"
	Math__BigInt__LTM	x;
	Math__BigInt__LTM	y;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    x = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_div",
			"x", "Math::BigInt::LTM")
;

	if (SvROK(ST(2)) && sv_derived_from(ST(2), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(2)));
	    y = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_div",
			"y", "Math::BigInt::LTM")
;
#line 424 "./inc/CryptX_BigInt_LTM.xs.inc"
    if (GIMME_V == G_ARRAY) {
      Newz(0, rem, 1, mp_int);
      mp_init(rem);
      mp_div(x, y, x, rem);
      EXTEND(SP, 2);
      PUSHs(ST(1)); /* x */
      PUSHs(sv_2mortal(sv_from_mpi(rem)));
    }
    else {
      mp_div(x, y, x, NULL);
      XPUSHs(ST(1)); /* x */
    }
#line 11503 "CryptX.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__BigInt__LTM__mod); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM__mod)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "Class, x, y");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Math__BigInt__LTM	x;
	Math__BigInt__LTM	y;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    x = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_mod",
			"x", "Math::BigInt::LTM")
;

	if (SvROK(ST(2)) && sv_derived_from(ST(2), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(2)));
	    y = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_mod",
			"y", "Math::BigInt::LTM")
;
#line 443 "./inc/CryptX_BigInt_LTM.xs.inc"
    mp_mod(x, y, x);
    XPUSHs(ST(1)); /* x */
#line 11544 "CryptX.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__BigInt__LTM__acmp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM__acmp)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "Class, m, n");
    {
	int	RETVAL;
	dXSTARG;
	Math__BigInt__LTM	m;
	Math__BigInt__LTM	n;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    m = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_acmp",
			"m", "Math::BigInt::LTM")
;

	if (SvROK(ST(2)) && sv_derived_from(ST(2), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(2)));
	    n = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_acmp",
			"n", "Math::BigInt::LTM")
;
#line 452 "./inc/CryptX_BigInt_LTM.xs.inc"
    RETVAL = mp_cmp(m, n);
    if ( RETVAL < 0) RETVAL = -1;
    if ( RETVAL > 0) RETVAL =  1;
#line 11586 "CryptX.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__LTM__is_zero); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM__is_zero)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, x");
    {
	int	RETVAL;
	dXSTARG;
	Math__BigInt__LTM	x;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    x = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_is_zero",
			"x", "Math::BigInt::LTM")
;
#line 464 "./inc/CryptX_BigInt_LTM.xs.inc"
    RETVAL = (mp_iszero(x) == MP_YES) ? 1 : 0;
#line 11615 "CryptX.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__LTM__is_one); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM__is_one)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, x");
    {
	int	RETVAL;
	dXSTARG;
	Math__BigInt__LTM	x;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    x = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_is_one",
			"x", "Math::BigInt::LTM")
;
#line 474 "./inc/CryptX_BigInt_LTM.xs.inc"
    RETVAL = (mp_cmp_d(x, 1) == MP_EQ) ? 1 : 0;
#line 11644 "CryptX.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__LTM__is_two); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM__is_two)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, x");
    {
	int	RETVAL;
	dXSTARG;
	Math__BigInt__LTM	x;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    x = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_is_two",
			"x", "Math::BigInt::LTM")
;
#line 484 "./inc/CryptX_BigInt_LTM.xs.inc"
    RETVAL = (mp_cmp_d(x, 2) == MP_EQ) ? 1 : 0;
#line 11673 "CryptX.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__LTM__is_ten); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM__is_ten)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, x");
    {
	int	RETVAL;
	dXSTARG;
	Math__BigInt__LTM	x;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    x = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_is_ten",
			"x", "Math::BigInt::LTM")
;
#line 494 "./inc/CryptX_BigInt_LTM.xs.inc"
    RETVAL = (mp_cmp_d(x, 10) == MP_EQ) ? 1 : 0;
#line 11702 "CryptX.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__LTM__pow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM__pow)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "Class, x, y");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Math__BigInt__LTM	x;
	Math__BigInt__LTM	y;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    x = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_pow",
			"x", "Math::BigInt::LTM")
;

	if (SvROK(ST(2)) && sv_derived_from(ST(2), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(2)));
	    y = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_pow",
			"y", "Math::BigInt::LTM")
;
#line 504 "./inc/CryptX_BigInt_LTM.xs.inc"
    mp_expt_d(x, mp_get_long(y), x);
    XPUSHs(ST(1)); /* x */
#line 11743 "CryptX.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__BigInt__LTM__gcd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM__gcd)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "Class, x, y");
    {
	Math__BigInt__LTM	RETVAL;
	Math__BigInt__LTM	x;
	Math__BigInt__LTM	y;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    x = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_gcd",
			"x", "Math::BigInt::LTM")
;

	if (SvROK(ST(2)) && sv_derived_from(ST(2), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(2)));
	    y = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_gcd",
			"y", "Math::BigInt::LTM")
;
#line 513 "./inc/CryptX_BigInt_LTM.xs.inc"
    Newz(0, RETVAL, 1, mp_int);
    mp_init(RETVAL);
    mp_gcd(x, y, RETVAL);
#line 11784 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Math::BigInt::LTM", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__LTM__and); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM__and)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "Class, x, y");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Math__BigInt__LTM	x;
	Math__BigInt__LTM	y;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    x = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_and",
			"x", "Math::BigInt::LTM")
;

	if (SvROK(ST(2)) && sv_derived_from(ST(2), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(2)));
	    y = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_and",
			"y", "Math::BigInt::LTM")
;
#line 525 "./inc/CryptX_BigInt_LTM.xs.inc"
    mp_and(x, y, x);
    XPUSHs(ST(1)); /* x */
#line 11830 "CryptX.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__BigInt__LTM__xor); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM__xor)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "Class, x, y");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Math__BigInt__LTM	x;
	Math__BigInt__LTM	y;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    x = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_xor",
			"x", "Math::BigInt::LTM")
;

	if (SvROK(ST(2)) && sv_derived_from(ST(2), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(2)));
	    y = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_xor",
			"y", "Math::BigInt::LTM")
;
#line 534 "./inc/CryptX_BigInt_LTM.xs.inc"
    mp_xor(x, y, x);
    XPUSHs(ST(1)); /* x */
#line 11871 "CryptX.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__BigInt__LTM__or); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM__or)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "Class, x, y");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Math__BigInt__LTM	x;
	Math__BigInt__LTM	y;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    x = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_or",
			"x", "Math::BigInt::LTM")
;

	if (SvROK(ST(2)) && sv_derived_from(ST(2), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(2)));
	    y = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_or",
			"y", "Math::BigInt::LTM")
;
#line 543 "./inc/CryptX_BigInt_LTM.xs.inc"
    mp_or(x, y, x);
    XPUSHs(ST(1)); /* x */
#line 11912 "CryptX.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__BigInt__LTM__copy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM__copy)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, m");
    {
	Math__BigInt__LTM	RETVAL;
	Math__BigInt__LTM	m;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    m = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_copy",
			"m", "Math::BigInt::LTM")
;
#line 552 "./inc/CryptX_BigInt_LTM.xs.inc"
    Newz(0, RETVAL, 1, mp_int);
    mp_init(RETVAL);
    mp_copy(m, RETVAL);
#line 11942 "CryptX.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Math::BigInt::LTM", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__LTM__is_odd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM__is_odd)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, n");
    {
	int	RETVAL;
	dXSTARG;
	Math__BigInt__LTM	n;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    n = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_is_odd",
			"n", "Math::BigInt::LTM")
;
#line 564 "./inc/CryptX_BigInt_LTM.xs.inc"
    RETVAL = (mp_isodd(n) == MP_YES) ? 1 : 0;
#line 11976 "CryptX.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__LTM__is_even); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM__is_even)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, n");
    {
	int	RETVAL;
	dXSTARG;
	Math__BigInt__LTM	n;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    n = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_is_even",
			"n", "Math::BigInt::LTM")
;
#line 574 "./inc/CryptX_BigInt_LTM.xs.inc"
    RETVAL = (mp_iseven(n) == MP_YES || mp_iszero(n) == MP_YES) ? 1 : 0;
#line 12005 "CryptX.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__LTM__sqrt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM__sqrt)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, x");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Math__BigInt__LTM	x;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    x = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_sqrt",
			"x", "Math::BigInt::LTM")
;
#line 584 "./inc/CryptX_BigInt_LTM.xs.inc"
    mp_sqrt(x, x);
    XPUSHs(ST(1)); /* x */
#line 12035 "CryptX.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__BigInt__LTM__root); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM__root)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "Class, x, y");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Math__BigInt__LTM	x;
	Math__BigInt__LTM	y;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    x = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_root",
			"x", "Math::BigInt::LTM")
;

	if (SvROK(ST(2)) && sv_derived_from(ST(2), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(2)));
	    y = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::_root",
			"y", "Math::BigInt::LTM")
;
#line 593 "./inc/CryptX_BigInt_LTM.xs.inc"
    mp_n_root(x, mp_get_long(y), x);
    XPUSHs(ST(1)); /* x */
#line 12076 "CryptX.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__BigInt__LTM_STORABLE_thaw); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM_STORABLE_thaw)
{
    dVAR; dXSARGS;
    if (items < 3)
       croak_xs_usage(cv,  "blank_obj, cloning, serialized, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	blank_obj = ST(0)
;
	SV *	cloning;
	SV *	serialized = ST(2)
;
#line 605 "./inc/CryptX_BigInt_LTM.xs.inc"
    SV *target, *tmp;
    mp_int *mpi;
    mp_int *mpitmp;
#line 12101 "CryptX.c"
#line 609 "./inc/CryptX_BigInt_LTM.xs.inc"
    if (SvROK(blank_obj) && sv_isa(blank_obj, "Math::BigInt::LTM")) {
        Newz(0, mpi, 1, mp_int);
        mp_init(mpi);
        mp_read_radix(mpi, SvPV_nolen(serialized), 10);
        target = SvRV(blank_obj);
        SvIV_set(target, PTR2IV(mpi));
        SvIOK_on(target);
        PUSHs(target);
        XSRETURN(1);
    }
    else
        croak("Bad object for Math::BigInt::LTM::STORABLE_thaw call");
#line 12115 "CryptX.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__BigInt__LTM_STORABLE_freeze); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__LTM_STORABLE_freeze)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "self, cloning = NULL");
    {
	Math__BigInt__LTM	self;
	SV *	cloning;
#line 627 "./inc/CryptX_BigInt_LTM.xs.inc"
    unsigned long len;
    char *buf;
#line 12134 "CryptX.c"
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Math::BigInt::LTM")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Math__BigInt__LTM,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Math::BigInt::LTM::STORABLE_freeze",
			"self", "Math::BigInt::LTM")
;
#line 630 "./inc/CryptX_BigInt_LTM.xs.inc"
    if (mp_iszero(self) == MP_YES) {
      RETVAL = newSVpv("0", 0);
    }
    else {
      len = mp_unsigned_bin_size(self) * 3 + 2; /* decimal size ~ 3 * bin size +1 for sign +1 for NUL-byte */
      Newz(0, buf, len, char);
      mp_toradix_n(self, buf, 10, len);
      RETVAL = newSVpv(buf, 0);
      Safefree(buf);
    }
#line 12157 "CryptX.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


/* INCLUDE: Returning to 'CryptX.xs' from 'inc/CryptX_BigInt_LTM.xs.inc' */

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_CryptX); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_CryptX)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("CryptX::_encode_base64url", XS_CryptX__encode_base64url);
        newXS_deffile("CryptX::_decode_base64url", XS_CryptX__decode_base64url);
        newXS_deffile("CryptX::_encode_base64", XS_CryptX__encode_base64);
        newXS_deffile("CryptX::_decode_base64", XS_CryptX__decode_base64);
        newXS_deffile("Crypt::Cipher::_new", XS_Crypt__Cipher__new);
        newXS_deffile("Crypt::Cipher::DESTROY", XS_Crypt__Cipher_DESTROY);
        newXS_deffile("Crypt::Cipher::_max_keysize", XS_Crypt__Cipher__max_keysize);
        newXS_deffile("Crypt::Cipher::_min_keysize", XS_Crypt__Cipher__min_keysize);
        newXS_deffile("Crypt::Cipher::_blocksize", XS_Crypt__Cipher__blocksize);
        newXS_deffile("Crypt::Cipher::_default_rounds", XS_Crypt__Cipher__default_rounds);
        newXS_deffile("Crypt::Cipher::encrypt", XS_Crypt__Cipher_encrypt);
        newXS_deffile("Crypt::Cipher::decrypt", XS_Crypt__Cipher_decrypt);
        newXS_deffile("Crypt::Cipher::_block_length_by_name", XS_Crypt__Cipher__block_length_by_name);
        newXS_deffile("Crypt::Cipher::_min_key_length_by_name", XS_Crypt__Cipher__min_key_length_by_name);
        newXS_deffile("Crypt::Cipher::_max_key_length_by_name", XS_Crypt__Cipher__max_key_length_by_name);
        newXS_deffile("Crypt::Cipher::_default_rounds_by_name", XS_Crypt__Cipher__default_rounds_by_name);
        newXS_deffile("Crypt::Digest::_new", XS_Crypt__Digest__new);
        newXS_deffile("Crypt::Digest::DESTROY", XS_Crypt__Digest_DESTROY);
        newXS_deffile("Crypt::Digest::reset", XS_Crypt__Digest_reset);
        newXS_deffile("Crypt::Digest::clone", XS_Crypt__Digest_clone);
        newXS_deffile("Crypt::Digest::add", XS_Crypt__Digest_add);
        newXS_deffile("Crypt::Digest::digest", XS_Crypt__Digest_digest);
        newXS_deffile("Crypt::Digest::hexdigest", XS_Crypt__Digest_hexdigest);
        newXS_deffile("Crypt::Digest::b64digest", XS_Crypt__Digest_b64digest);
        newXS_deffile("Crypt::Digest::b64udigest", XS_Crypt__Digest_b64udigest);
        newXS_deffile("Crypt::Digest::_hashsize", XS_Crypt__Digest__hashsize);
        newXS_deffile("Crypt::Digest::_hashsize_by_name", XS_Crypt__Digest__hashsize_by_name);
        newXS_deffile("Crypt::Checksum::CRC32::new", XS_Crypt__Checksum__CRC32_new);
        newXS_deffile("Crypt::Checksum::CRC32::DESTROY", XS_Crypt__Checksum__CRC32_DESTROY);
        newXS_deffile("Crypt::Checksum::CRC32::reset", XS_Crypt__Checksum__CRC32_reset);
        newXS_deffile("Crypt::Checksum::CRC32::clone", XS_Crypt__Checksum__CRC32_clone);
        newXS_deffile("Crypt::Checksum::CRC32::add", XS_Crypt__Checksum__CRC32_add);
        newXS_deffile("Crypt::Checksum::CRC32::digest", XS_Crypt__Checksum__CRC32_digest);
        newXS_deffile("Crypt::Checksum::CRC32::hexdigest", XS_Crypt__Checksum__CRC32_hexdigest);
        newXS_deffile("Crypt::Checksum::Adler32::new", XS_Crypt__Checksum__Adler32_new);
        newXS_deffile("Crypt::Checksum::Adler32::DESTROY", XS_Crypt__Checksum__Adler32_DESTROY);
        newXS_deffile("Crypt::Checksum::Adler32::reset", XS_Crypt__Checksum__Adler32_reset);
        newXS_deffile("Crypt::Checksum::Adler32::clone", XS_Crypt__Checksum__Adler32_clone);
        newXS_deffile("Crypt::Checksum::Adler32::add", XS_Crypt__Checksum__Adler32_add);
        newXS_deffile("Crypt::Checksum::Adler32::digest", XS_Crypt__Checksum__Adler32_digest);
        newXS_deffile("Crypt::Checksum::Adler32::hexdigest", XS_Crypt__Checksum__Adler32_hexdigest);
        newXS_deffile("Crypt::AuthEnc::CCM::_memory_encrypt", XS_Crypt__AuthEnc__CCM__memory_encrypt);
        newXS_deffile("Crypt::AuthEnc::CCM::_memory_decrypt", XS_Crypt__AuthEnc__CCM__memory_decrypt);
        newXS_deffile("Crypt::AuthEnc::OCB::_new", XS_Crypt__AuthEnc__OCB__new);
        newXS_deffile("Crypt::AuthEnc::OCB::DESTROY", XS_Crypt__AuthEnc__OCB_DESTROY);
        newXS_deffile("Crypt::AuthEnc::OCB::clone", XS_Crypt__AuthEnc__OCB_clone);
        newXS_deffile("Crypt::AuthEnc::OCB::adata_add", XS_Crypt__AuthEnc__OCB_adata_add);
        newXS_deffile("Crypt::AuthEnc::OCB::encrypt_add", XS_Crypt__AuthEnc__OCB_encrypt_add);
        newXS_deffile("Crypt::AuthEnc::OCB::encrypt_last", XS_Crypt__AuthEnc__OCB_encrypt_last);
        newXS_deffile("Crypt::AuthEnc::OCB::decrypt_add", XS_Crypt__AuthEnc__OCB_decrypt_add);
        newXS_deffile("Crypt::AuthEnc::OCB::decrypt_last", XS_Crypt__AuthEnc__OCB_decrypt_last);
        newXS_deffile("Crypt::AuthEnc::OCB::encrypt_done", XS_Crypt__AuthEnc__OCB_encrypt_done);
        newXS_deffile("Crypt::AuthEnc::OCB::decrypt_done", XS_Crypt__AuthEnc__OCB_decrypt_done);
        newXS_deffile("Crypt::AuthEnc::OCB::blocksize", XS_Crypt__AuthEnc__OCB_blocksize);
        newXS_deffile("Crypt::AuthEnc::GCM::_new", XS_Crypt__AuthEnc__GCM__new);
        newXS_deffile("Crypt::AuthEnc::GCM::DESTROY", XS_Crypt__AuthEnc__GCM_DESTROY);
        newXS_deffile("Crypt::AuthEnc::GCM::clone", XS_Crypt__AuthEnc__GCM_clone);
        newXS_deffile("Crypt::AuthEnc::GCM::reset", XS_Crypt__AuthEnc__GCM_reset);
        newXS_deffile("Crypt::AuthEnc::GCM::encrypt_add", XS_Crypt__AuthEnc__GCM_encrypt_add);
        newXS_deffile("Crypt::AuthEnc::GCM::iv_add", XS_Crypt__AuthEnc__GCM_iv_add);
        newXS_deffile("Crypt::AuthEnc::GCM::adata_add", XS_Crypt__AuthEnc__GCM_adata_add);
        newXS_deffile("Crypt::AuthEnc::GCM::decrypt_add", XS_Crypt__AuthEnc__GCM_decrypt_add);
        newXS_deffile("Crypt::AuthEnc::GCM::encrypt_done", XS_Crypt__AuthEnc__GCM_encrypt_done);
        newXS_deffile("Crypt::AuthEnc::GCM::decrypt_done", XS_Crypt__AuthEnc__GCM_decrypt_done);
        newXS_deffile("Crypt::AuthEnc::EAX::_new", XS_Crypt__AuthEnc__EAX__new);
        newXS_deffile("Crypt::AuthEnc::EAX::DESTROY", XS_Crypt__AuthEnc__EAX_DESTROY);
        newXS_deffile("Crypt::AuthEnc::EAX::clone", XS_Crypt__AuthEnc__EAX_clone);
        newXS_deffile("Crypt::AuthEnc::EAX::encrypt_add", XS_Crypt__AuthEnc__EAX_encrypt_add);
        newXS_deffile("Crypt::AuthEnc::EAX::decrypt_add", XS_Crypt__AuthEnc__EAX_decrypt_add);
        newXS_deffile("Crypt::AuthEnc::EAX::encrypt_done", XS_Crypt__AuthEnc__EAX_encrypt_done);
        newXS_deffile("Crypt::AuthEnc::EAX::decrypt_done", XS_Crypt__AuthEnc__EAX_decrypt_done);
        newXS_deffile("Crypt::AuthEnc::EAX::header_add", XS_Crypt__AuthEnc__EAX_header_add);
        newXS_deffile("Crypt::Mac::XCBC::_new", XS_Crypt__Mac__XCBC__new);
        newXS_deffile("Crypt::Mac::XCBC::DESTROY", XS_Crypt__Mac__XCBC_DESTROY);
        newXS_deffile("Crypt::Mac::XCBC::clone", XS_Crypt__Mac__XCBC_clone);
        newXS_deffile("Crypt::Mac::XCBC::_add_single", XS_Crypt__Mac__XCBC__add_single);
        newXS_deffile("Crypt::Mac::XCBC::mac", XS_Crypt__Mac__XCBC_mac);
        newXS_deffile("Crypt::Mac::XCBC::b64mac", XS_Crypt__Mac__XCBC_b64mac);
        newXS_deffile("Crypt::Mac::XCBC::b64umac", XS_Crypt__Mac__XCBC_b64umac);
        newXS_deffile("Crypt::Mac::XCBC::hexmac", XS_Crypt__Mac__XCBC_hexmac);
        newXS_deffile("Crypt::Mac::PMAC::_new", XS_Crypt__Mac__PMAC__new);
        newXS_deffile("Crypt::Mac::PMAC::DESTROY", XS_Crypt__Mac__PMAC_DESTROY);
        newXS_deffile("Crypt::Mac::PMAC::clone", XS_Crypt__Mac__PMAC_clone);
        newXS_deffile("Crypt::Mac::PMAC::_add_single", XS_Crypt__Mac__PMAC__add_single);
        newXS_deffile("Crypt::Mac::PMAC::mac", XS_Crypt__Mac__PMAC_mac);
        newXS_deffile("Crypt::Mac::PMAC::b64mac", XS_Crypt__Mac__PMAC_b64mac);
        newXS_deffile("Crypt::Mac::PMAC::b64umac", XS_Crypt__Mac__PMAC_b64umac);
        newXS_deffile("Crypt::Mac::PMAC::hexmac", XS_Crypt__Mac__PMAC_hexmac);
        newXS_deffile("Crypt::Mac::Pelican::_new", XS_Crypt__Mac__Pelican__new);
        newXS_deffile("Crypt::Mac::Pelican::DESTROY", XS_Crypt__Mac__Pelican_DESTROY);
        newXS_deffile("Crypt::Mac::Pelican::clone", XS_Crypt__Mac__Pelican_clone);
        newXS_deffile("Crypt::Mac::Pelican::_add_single", XS_Crypt__Mac__Pelican__add_single);
        newXS_deffile("Crypt::Mac::Pelican::mac", XS_Crypt__Mac__Pelican_mac);
        newXS_deffile("Crypt::Mac::Pelican::b64mac", XS_Crypt__Mac__Pelican_b64mac);
        newXS_deffile("Crypt::Mac::Pelican::b64umac", XS_Crypt__Mac__Pelican_b64umac);
        newXS_deffile("Crypt::Mac::Pelican::hexmac", XS_Crypt__Mac__Pelican_hexmac);
        newXS_deffile("Crypt::Mac::OMAC::_new", XS_Crypt__Mac__OMAC__new);
        newXS_deffile("Crypt::Mac::OMAC::DESTROY", XS_Crypt__Mac__OMAC_DESTROY);
        newXS_deffile("Crypt::Mac::OMAC::clone", XS_Crypt__Mac__OMAC_clone);
        newXS_deffile("Crypt::Mac::OMAC::_add_single", XS_Crypt__Mac__OMAC__add_single);
        newXS_deffile("Crypt::Mac::OMAC::mac", XS_Crypt__Mac__OMAC_mac);
        newXS_deffile("Crypt::Mac::OMAC::b64mac", XS_Crypt__Mac__OMAC_b64mac);
        newXS_deffile("Crypt::Mac::OMAC::b64umac", XS_Crypt__Mac__OMAC_b64umac);
        newXS_deffile("Crypt::Mac::OMAC::hexmac", XS_Crypt__Mac__OMAC_hexmac);
        newXS_deffile("Crypt::Mac::HMAC::_new", XS_Crypt__Mac__HMAC__new);
        newXS_deffile("Crypt::Mac::HMAC::DESTROY", XS_Crypt__Mac__HMAC_DESTROY);
        newXS_deffile("Crypt::Mac::HMAC::clone", XS_Crypt__Mac__HMAC_clone);
        newXS_deffile("Crypt::Mac::HMAC::_add_single", XS_Crypt__Mac__HMAC__add_single);
        newXS_deffile("Crypt::Mac::HMAC::mac", XS_Crypt__Mac__HMAC_mac);
        newXS_deffile("Crypt::Mac::HMAC::b64mac", XS_Crypt__Mac__HMAC_b64mac);
        newXS_deffile("Crypt::Mac::HMAC::b64umac", XS_Crypt__Mac__HMAC_b64umac);
        newXS_deffile("Crypt::Mac::HMAC::hexmac", XS_Crypt__Mac__HMAC_hexmac);
        newXS_deffile("Crypt::Mac::F9::_new", XS_Crypt__Mac__F9__new);
        newXS_deffile("Crypt::Mac::F9::DESTROY", XS_Crypt__Mac__F9_DESTROY);
        newXS_deffile("Crypt::Mac::F9::clone", XS_Crypt__Mac__F9_clone);
        newXS_deffile("Crypt::Mac::F9::_add_single", XS_Crypt__Mac__F9__add_single);
        newXS_deffile("Crypt::Mac::F9::mac", XS_Crypt__Mac__F9_mac);
        newXS_deffile("Crypt::Mac::F9::b64mac", XS_Crypt__Mac__F9_b64mac);
        newXS_deffile("Crypt::Mac::F9::b64umac", XS_Crypt__Mac__F9_b64umac);
        newXS_deffile("Crypt::Mac::F9::hexmac", XS_Crypt__Mac__F9_hexmac);
        newXS_deffile("Crypt::Mode::CTR::_new", XS_Crypt__Mode__CTR__new);
        newXS_deffile("Crypt::Mode::CTR::DESTROY", XS_Crypt__Mode__CTR_DESTROY);
        newXS_deffile("Crypt::Mode::CTR::_get_dir", XS_Crypt__Mode__CTR__get_dir);
        newXS_deffile("Crypt::Mode::CTR::_start", XS_Crypt__Mode__CTR__start);
        newXS_deffile("Crypt::Mode::CTR::_crypt", XS_Crypt__Mode__CTR__crypt);
        newXS_deffile("Crypt::Mode::CTR::_finish", XS_Crypt__Mode__CTR__finish);
        newXS_deffile("Crypt::Mode::OFB::_new", XS_Crypt__Mode__OFB__new);
        newXS_deffile("Crypt::Mode::OFB::DESTROY", XS_Crypt__Mode__OFB_DESTROY);
        newXS_deffile("Crypt::Mode::OFB::_get_dir", XS_Crypt__Mode__OFB__get_dir);
        newXS_deffile("Crypt::Mode::OFB::_start", XS_Crypt__Mode__OFB__start);
        newXS_deffile("Crypt::Mode::OFB::_crypt", XS_Crypt__Mode__OFB__crypt);
        newXS_deffile("Crypt::Mode::OFB::_finish", XS_Crypt__Mode__OFB__finish);
        newXS_deffile("Crypt::Mode::CFB::_new", XS_Crypt__Mode__CFB__new);
        newXS_deffile("Crypt::Mode::CFB::DESTROY", XS_Crypt__Mode__CFB_DESTROY);
        newXS_deffile("Crypt::Mode::CFB::_get_dir", XS_Crypt__Mode__CFB__get_dir);
        newXS_deffile("Crypt::Mode::CFB::_start", XS_Crypt__Mode__CFB__start);
        newXS_deffile("Crypt::Mode::CFB::_crypt", XS_Crypt__Mode__CFB__crypt);
        newXS_deffile("Crypt::Mode::CFB::_finish", XS_Crypt__Mode__CFB__finish);
        newXS_deffile("Crypt::Mode::ECB::_new", XS_Crypt__Mode__ECB__new);
        newXS_deffile("Crypt::Mode::ECB::DESTROY", XS_Crypt__Mode__ECB_DESTROY);
        newXS_deffile("Crypt::Mode::ECB::_get_dir", XS_Crypt__Mode__ECB__get_dir);
        newXS_deffile("Crypt::Mode::ECB::_start", XS_Crypt__Mode__ECB__start);
        newXS_deffile("Crypt::Mode::ECB::_encrypt", XS_Crypt__Mode__ECB__encrypt);
        newXS_deffile("Crypt::Mode::ECB::_finish_enc", XS_Crypt__Mode__ECB__finish_enc);
        newXS_deffile("Crypt::Mode::ECB::_decrypt", XS_Crypt__Mode__ECB__decrypt);
        newXS_deffile("Crypt::Mode::ECB::_finish_dec", XS_Crypt__Mode__ECB__finish_dec);
        newXS_deffile("Crypt::Mode::CBC::_new", XS_Crypt__Mode__CBC__new);
        newXS_deffile("Crypt::Mode::CBC::DESTROY", XS_Crypt__Mode__CBC_DESTROY);
        newXS_deffile("Crypt::Mode::CBC::_get_dir", XS_Crypt__Mode__CBC__get_dir);
        newXS_deffile("Crypt::Mode::CBC::_start", XS_Crypt__Mode__CBC__start);
        newXS_deffile("Crypt::Mode::CBC::_encrypt", XS_Crypt__Mode__CBC__encrypt);
        newXS_deffile("Crypt::Mode::CBC::_finish_enc", XS_Crypt__Mode__CBC__finish_enc);
        newXS_deffile("Crypt::Mode::CBC::_decrypt", XS_Crypt__Mode__CBC__decrypt);
        newXS_deffile("Crypt::Mode::CBC::_finish_dec", XS_Crypt__Mode__CBC__finish_dec);
        newXS_deffile("Crypt::PRNG::_new", XS_Crypt__PRNG__new);
        newXS_deffile("Crypt::PRNG::DESTROY", XS_Crypt__PRNG_DESTROY);
        newXS_deffile("Crypt::PRNG::add_entropy", XS_Crypt__PRNG_add_entropy);
        newXS_deffile("Crypt::PRNG::_bytes", XS_Crypt__PRNG__bytes);
        newXS_deffile("Crypt::PRNG::_int32", XS_Crypt__PRNG__int32);
        newXS_deffile("Crypt::PRNG::_double", XS_Crypt__PRNG__double);
        newXS_deffile("Crypt::PK::ECC::_new", XS_Crypt__PK__ECC__new);
        newXS_deffile("Crypt::PK::ECC::generate_key", XS_Crypt__PK__ECC_generate_key);
        newXS_deffile("Crypt::PK::ECC::_import", XS_Crypt__PK__ECC__import);
        newXS_deffile("Crypt::PK::ECC::_import_pkcs8", XS_Crypt__PK__ECC__import_pkcs8);
        newXS_deffile("Crypt::PK::ECC::import_key_raw", XS_Crypt__PK__ECC_import_key_raw);
        newXS_deffile("Crypt::PK::ECC::is_private", XS_Crypt__PK__ECC_is_private);
        newXS_deffile("Crypt::PK::ECC::size", XS_Crypt__PK__ECC_size);
        newXS_deffile("Crypt::PK::ECC::key2hash", XS_Crypt__PK__ECC_key2hash);
        newXS_deffile("Crypt::PK::ECC::export_key_der", XS_Crypt__PK__ECC_export_key_der);
        newXS_deffile("Crypt::PK::ECC::export_key_raw", XS_Crypt__PK__ECC_export_key_raw);
        newXS_deffile("Crypt::PK::ECC::_encrypt", XS_Crypt__PK__ECC__encrypt);
        newXS_deffile("Crypt::PK::ECC::_decrypt", XS_Crypt__PK__ECC__decrypt);
        cv = newXS_deffile("Crypt::PK::ECC::_sign", XS_Crypt__PK__ECC__sign);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Crypt::PK::ECC::_sign_rfc7518", XS_Crypt__PK__ECC__sign);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Crypt::PK::ECC::_verify", XS_Crypt__PK__ECC__verify);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Crypt::PK::ECC::_verify_rfc7518", XS_Crypt__PK__ECC__verify);
        XSANY.any_i32 = 1;
        newXS_deffile("Crypt::PK::ECC::shared_secret", XS_Crypt__PK__ECC_shared_secret);
        newXS_deffile("Crypt::PK::ECC::DESTROY", XS_Crypt__PK__ECC_DESTROY);
        newXS_deffile("Crypt::PK::DH::_new", XS_Crypt__PK__DH__new);
        newXS_deffile("Crypt::PK::DH::_generate_key", XS_Crypt__PK__DH__generate_key);
        newXS_deffile("Crypt::PK::DH::_generate_key_ex", XS_Crypt__PK__DH__generate_key_ex);
        newXS_deffile("Crypt::PK::DH::_import", XS_Crypt__PK__DH__import);
        newXS_deffile("Crypt::PK::DH::_import_raw", XS_Crypt__PK__DH__import_raw);
        newXS_deffile("Crypt::PK::DH::is_private", XS_Crypt__PK__DH_is_private);
        newXS_deffile("Crypt::PK::DH::size", XS_Crypt__PK__DH_size);
        newXS_deffile("Crypt::PK::DH::key2hash", XS_Crypt__PK__DH_key2hash);
        newXS_deffile("Crypt::PK::DH::params2hash", XS_Crypt__PK__DH_params2hash);
        newXS_deffile("Crypt::PK::DH::export_key", XS_Crypt__PK__DH_export_key);
        newXS_deffile("Crypt::PK::DH::_encrypt", XS_Crypt__PK__DH__encrypt);
        newXS_deffile("Crypt::PK::DH::_decrypt", XS_Crypt__PK__DH__decrypt);
        newXS_deffile("Crypt::PK::DH::_sign", XS_Crypt__PK__DH__sign);
        newXS_deffile("Crypt::PK::DH::_verify", XS_Crypt__PK__DH__verify);
        newXS_deffile("Crypt::PK::DH::shared_secret", XS_Crypt__PK__DH_shared_secret);
        newXS_deffile("Crypt::PK::DH::export_key_raw", XS_Crypt__PK__DH_export_key_raw);
        newXS_deffile("Crypt::PK::DH::_is_pubkey_valid", XS_Crypt__PK__DH__is_pubkey_valid);
        newXS_deffile("Crypt::PK::DH::DESTROY", XS_Crypt__PK__DH_DESTROY);
        newXS_deffile("Crypt::PK::DSA::_new", XS_Crypt__PK__DSA__new);
        newXS_deffile("Crypt::PK::DSA::generate_key", XS_Crypt__PK__DSA_generate_key);
        newXS_deffile("Crypt::PK::DSA::_import", XS_Crypt__PK__DSA__import);
        newXS_deffile("Crypt::PK::DSA::_import_hex", XS_Crypt__PK__DSA__import_hex);
        newXS_deffile("Crypt::PK::DSA::is_private", XS_Crypt__PK__DSA_is_private);
        newXS_deffile("Crypt::PK::DSA::size", XS_Crypt__PK__DSA_size);
        newXS_deffile("Crypt::PK::DSA::size_q", XS_Crypt__PK__DSA_size_q);
        newXS_deffile("Crypt::PK::DSA::key2hash", XS_Crypt__PK__DSA_key2hash);
        newXS_deffile("Crypt::PK::DSA::export_key_der", XS_Crypt__PK__DSA_export_key_der);
        newXS_deffile("Crypt::PK::DSA::_encrypt", XS_Crypt__PK__DSA__encrypt);
        newXS_deffile("Crypt::PK::DSA::_decrypt", XS_Crypt__PK__DSA__decrypt);
        newXS_deffile("Crypt::PK::DSA::_sign", XS_Crypt__PK__DSA__sign);
        newXS_deffile("Crypt::PK::DSA::_verify", XS_Crypt__PK__DSA__verify);
        newXS_deffile("Crypt::PK::DSA::DESTROY", XS_Crypt__PK__DSA_DESTROY);
        newXS_deffile("Crypt::PK::RSA::_new", XS_Crypt__PK__RSA__new);
        newXS_deffile("Crypt::PK::RSA::generate_key", XS_Crypt__PK__RSA_generate_key);
        newXS_deffile("Crypt::PK::RSA::_import", XS_Crypt__PK__RSA__import);
        newXS_deffile("Crypt::PK::RSA::_import_pkcs8", XS_Crypt__PK__RSA__import_pkcs8);
        newXS_deffile("Crypt::PK::RSA::_import_hex", XS_Crypt__PK__RSA__import_hex);
        newXS_deffile("Crypt::PK::RSA::is_private", XS_Crypt__PK__RSA_is_private);
        newXS_deffile("Crypt::PK::RSA::size", XS_Crypt__PK__RSA_size);
        newXS_deffile("Crypt::PK::RSA::key2hash", XS_Crypt__PK__RSA_key2hash);
        newXS_deffile("Crypt::PK::RSA::export_key_der", XS_Crypt__PK__RSA_export_key_der);
        newXS_deffile("Crypt::PK::RSA::_encrypt", XS_Crypt__PK__RSA__encrypt);
        newXS_deffile("Crypt::PK::RSA::_decrypt", XS_Crypt__PK__RSA__decrypt);
        newXS_deffile("Crypt::PK::RSA::_sign", XS_Crypt__PK__RSA__sign);
        newXS_deffile("Crypt::PK::RSA::_verify", XS_Crypt__PK__RSA__verify);
        newXS_deffile("Crypt::PK::RSA::DESTROY", XS_Crypt__PK__RSA_DESTROY);
        newXS_deffile("Crypt::KeyDerivation::_pkcs_5_alg1", XS_Crypt__KeyDerivation__pkcs_5_alg1);
        newXS_deffile("Crypt::KeyDerivation::_pkcs_5_alg2", XS_Crypt__KeyDerivation__pkcs_5_alg2);
        newXS_deffile("Crypt::KeyDerivation::_hkdf_extract", XS_Crypt__KeyDerivation__hkdf_extract);
        newXS_deffile("Crypt::KeyDerivation::_hkdf_expand", XS_Crypt__KeyDerivation__hkdf_expand);
        newXS_deffile("Crypt::KeyDerivation::_hkdf", XS_Crypt__KeyDerivation__hkdf);
        newXS_deffile("Math::BigInt::LTM::_new", XS_Math__BigInt__LTM__new);
        newXS_deffile("Math::BigInt::LTM::_from_bin", XS_Math__BigInt__LTM__from_bin);
        newXS_deffile("Math::BigInt::LTM::_from_hex", XS_Math__BigInt__LTM__from_hex);
        newXS_deffile("Math::BigInt::LTM::_from_oct", XS_Math__BigInt__LTM__from_oct);
        newXS_deffile("Math::BigInt::LTM::_set", XS_Math__BigInt__LTM__set);
        newXS_deffile("Math::BigInt::LTM::_zero", XS_Math__BigInt__LTM__zero);
        newXS_deffile("Math::BigInt::LTM::_one", XS_Math__BigInt__LTM__one);
        newXS_deffile("Math::BigInt::LTM::_two", XS_Math__BigInt__LTM__two);
        newXS_deffile("Math::BigInt::LTM::_ten", XS_Math__BigInt__LTM__ten);
        newXS_deffile("Math::BigInt::LTM::_1ex", XS_Math__BigInt__LTM__1ex);
        newXS_deffile("Math::BigInt::LTM::DESTROY", XS_Math__BigInt__LTM_DESTROY);
        newXS_deffile("Math::BigInt::LTM::_str", XS_Math__BigInt__LTM__str);
        newXS_deffile("Math::BigInt::LTM::_len", XS_Math__BigInt__LTM__len);
        newXS_deffile("Math::BigInt::LTM::_alen", XS_Math__BigInt__LTM__alen);
        newXS_deffile("Math::BigInt::LTM::_zeros", XS_Math__BigInt__LTM__zeros);
        newXS_deffile("Math::BigInt::LTM::_as_hex", XS_Math__BigInt__LTM__as_hex);
        newXS_deffile("Math::BigInt::LTM::_as_bin", XS_Math__BigInt__LTM__as_bin);
        newXS_deffile("Math::BigInt::LTM::_as_oct", XS_Math__BigInt__LTM__as_oct);
        newXS_deffile("Math::BigInt::LTM::_modpow", XS_Math__BigInt__LTM__modpow);
        newXS_deffile("Math::BigInt::LTM::_modinv", XS_Math__BigInt__LTM__modinv);
        newXS_deffile("Math::BigInt::LTM::_add", XS_Math__BigInt__LTM__add);
        newXS_deffile("Math::BigInt::LTM::_inc", XS_Math__BigInt__LTM__inc);
        newXS_deffile("Math::BigInt::LTM::_dec", XS_Math__BigInt__LTM__dec);
        newXS_deffile("Math::BigInt::LTM::_sub", XS_Math__BigInt__LTM__sub);
        newXS_deffile("Math::BigInt::LTM::_rsft", XS_Math__BigInt__LTM__rsft);
        newXS_deffile("Math::BigInt::LTM::_lsft", XS_Math__BigInt__LTM__lsft);
        newXS_deffile("Math::BigInt::LTM::_mul", XS_Math__BigInt__LTM__mul);
        newXS_deffile("Math::BigInt::LTM::_div", XS_Math__BigInt__LTM__div);
        newXS_deffile("Math::BigInt::LTM::_mod", XS_Math__BigInt__LTM__mod);
        newXS_deffile("Math::BigInt::LTM::_acmp", XS_Math__BigInt__LTM__acmp);
        newXS_deffile("Math::BigInt::LTM::_is_zero", XS_Math__BigInt__LTM__is_zero);
        newXS_deffile("Math::BigInt::LTM::_is_one", XS_Math__BigInt__LTM__is_one);
        newXS_deffile("Math::BigInt::LTM::_is_two", XS_Math__BigInt__LTM__is_two);
        newXS_deffile("Math::BigInt::LTM::_is_ten", XS_Math__BigInt__LTM__is_ten);
        newXS_deffile("Math::BigInt::LTM::_pow", XS_Math__BigInt__LTM__pow);
        newXS_deffile("Math::BigInt::LTM::_gcd", XS_Math__BigInt__LTM__gcd);
        newXS_deffile("Math::BigInt::LTM::_and", XS_Math__BigInt__LTM__and);
        newXS_deffile("Math::BigInt::LTM::_xor", XS_Math__BigInt__LTM__xor);
        newXS_deffile("Math::BigInt::LTM::_or", XS_Math__BigInt__LTM__or);
        newXS_deffile("Math::BigInt::LTM::_copy", XS_Math__BigInt__LTM__copy);
        newXS_deffile("Math::BigInt::LTM::_is_odd", XS_Math__BigInt__LTM__is_odd);
        newXS_deffile("Math::BigInt::LTM::_is_even", XS_Math__BigInt__LTM__is_even);
        newXS_deffile("Math::BigInt::LTM::_sqrt", XS_Math__BigInt__LTM__sqrt);
        newXS_deffile("Math::BigInt::LTM::_root", XS_Math__BigInt__LTM__root);
        newXS_deffile("Math::BigInt::LTM::STORABLE_thaw", XS_Math__BigInt__LTM_STORABLE_thaw);
        newXS_deffile("Math::BigInt::LTM::STORABLE_freeze", XS_Math__BigInt__LTM_STORABLE_freeze);

    /* Initialisation Section */

#line 254 "CryptX.xs"
    if(register_cipher(&blowfish_desc)==-1)    { croak("FATAL: cannot register_cipher blowfish"); }
    if(register_cipher(&rc5_desc)==-1)         { croak("FATAL: cannot register_cipher rc5"); }
    if(register_cipher(&rc6_desc)==-1)         { croak("FATAL: cannot register_cipher rc6"); }
    if(register_cipher(&rc2_desc)==-1)         { croak("FATAL: cannot register_cipher rc2"); }
    if(register_cipher(&saferp_desc)==-1)      { croak("FATAL: cannot register_cipher saferp"); }
    if(register_cipher(&safer_k64_desc)==-1)   { croak("FATAL: cannot register_cipher safer_k64"); }
    if(register_cipher(&safer_k128_desc)==-1)  { croak("FATAL: cannot register_cipher safer_k128"); }
    if(register_cipher(&safer_sk64_desc)==-1)  { croak("FATAL: cannot register_cipher safer_sk64"); }
    if(register_cipher(&safer_sk128_desc)==-1) { croak("FATAL: cannot register_cipher safer_sk128"); }
    if(register_cipher(&aes_desc)==-1)         { croak("FATAL: cannot register_cipher aes"); }
    if(register_cipher(&xtea_desc)==-1)        { croak("FATAL: cannot register_cipher xtea"); }
    if(register_cipher(&twofish_desc)==-1)     { croak("FATAL: cannot register_cipher twofish"); }
    if(register_cipher(&des_desc)==-1)         { croak("FATAL: cannot register_cipher des"); }
    if(register_cipher(&des3_desc)==-1)        { croak("FATAL: cannot register_cipher des3"); }
    if(register_cipher(&cast5_desc)==-1)       { croak("FATAL: cannot register_cipher cast5"); }
    if(register_cipher(&noekeon_desc)==-1)     { croak("FATAL: cannot register_cipher noekeon"); }
    if(register_cipher(&skipjack_desc)==-1)    { croak("FATAL: cannot register_cipher skipjack"); }
    if(register_cipher(&khazad_desc)==-1)      { croak("FATAL: cannot register_cipher khazad"); }
    if(register_cipher(&anubis_desc)==-1)      { croak("FATAL: cannot register_cipher anubis"); }
    if(register_cipher(&kseed_desc)==-1)       { croak("FATAL: cannot register_cipher kseed"); }
    if(register_cipher(&kasumi_desc)==-1)      { croak("FATAL: cannot register_cipher kasumi"); }
    if(register_cipher(&multi2_desc)==-1)      { croak("FATAL: cannot register_cipher multi2"); }
    if(register_cipher(&camellia_desc)==-1)    { croak("FATAL: cannot register_cipher camellia"); }
    /* --- */
    if(register_hash(&chc_desc)==-1)           { croak("FATAL: cannot register_hash chc_hash"); }
    if(register_hash(&md2_desc)==-1)           { croak("FATAL: cannot register_hash md2"); }
    if(register_hash(&md4_desc)==-1)           { croak("FATAL: cannot register_hash md4"); }
    if(register_hash(&md5_desc)==-1)           { croak("FATAL: cannot register_hash md5"); }
    if(register_hash(&rmd128_desc)==-1)        { croak("FATAL: cannot register_hash rmd128"); }
    if(register_hash(&rmd160_desc)==-1)        { croak("FATAL: cannot register_hash rmd160"); }
    if(register_hash(&rmd256_desc)==-1)        { croak("FATAL: cannot register_hash rmd256"); }
    if(register_hash(&rmd320_desc)==-1)        { croak("FATAL: cannot register_hash rmd320"); }
    if(register_hash(&sha1_desc)==-1)          { croak("FATAL: cannot register_hash sha1"); }
    if(register_hash(&sha224_desc)==-1)        { croak("FATAL: cannot register_hash sha224"); }
    if(register_hash(&sha256_desc)==-1)        { croak("FATAL: cannot register_hash sha256"); }
    if(register_hash(&sha384_desc)==-1)        { croak("FATAL: cannot register_hash sha384"); }
    if(register_hash(&sha512_desc)==-1)        { croak("FATAL: cannot register_hash sha512"); }
    if(register_hash(&sha512_224_desc)==-1)    { croak("FATAL: cannot register_hash sha512_224"); }
    if(register_hash(&sha512_256_desc)==-1)    { croak("FATAL: cannot register_hash sha512_256"); }
    if(register_hash(&tiger_desc)==-1)         { croak("FATAL: cannot register_hash tiger"); }
    if(register_hash(&whirlpool_desc)==-1)     { croak("FATAL: cannot register_hash whirlpool"); }
    /* --- */
    if(chc_register(find_cipher("aes"))==-1)   { croak("FATAL: chc_register failed"); }
    /* --- */
    if(register_prng(&fortuna_desc)==-1)       { croak("FATAL: cannot register_prng fortuna"); }
    if(register_prng(&rc4_desc)==-1)           { croak("FATAL: cannot register_prng rc4"); }
    if(register_prng(&sober128_desc)==-1)      { croak("FATAL: cannot register_prng sober128"); }
    if(register_prng(&yarrow_desc)==-1)        { croak("FATAL: cannot register_prng yarrow"); }
    /* --- */
#ifdef TFM_DESC
    ltc_mp = tfm_desc;
#else
    ltc_mp = ltm_desc;
#endif

#line 12533 "CryptX.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

